/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 61 "src/parse.yy"


#include "decl.h"
#include "expr.h"
#include "func.h"
#include "ispc.h"
#include "module.h"
#include "stmt.h"
#include "sym.h"
#include "type.h"
#include "util.h"

#include <stdio.h>
#include <variant>
#include <llvm/IR/Constants.h>

using namespace ispc;

#define UNIMPLEMENTED \
        Error(yylloc, "Unimplemented parser functionality %s:%d", \
        __FILE__, __LINE__);

union YYSTYPE;
extern int yylex();

extern char *yytext;

void yyerror(const char *s);

void lCleanUpString(std::string *str);
void lFreeSimpleTemplateID(void *p);
static int lYYTNameErr(char *yyres, const char *yystr);

static void lSuggestBuiltinAlternates();
static void lSuggestParamListAlternates();

static void lAddDeclaration(DeclSpecs *ds, Declarator *decl);
static void lAddTemplateDeclaration(TemplateParms *templateParmList, DeclSpecs *ds, Declarator *decl);
static void lAddTemplateSpecialization(const TemplateArgs &templArgs, DeclSpecs *ds, Declarator *decl);
static void lAddFunctionParams(Declarator *decl);
static void lAddMaskToSymbolTable(SourcePos pos);
static void lAddThreadIndexCountToSymbolTable(SourcePos pos);
static std::string lGetAlternates(std::vector<std::string> &alternates);
static const char *lGetStorageClassString(StorageClass sc);
static bool lGetConstantIntOrSymbol(Expr *expr, std::variant<std::monostate, int, Symbol*> *value, SourcePos pos, const char *usage);

enum class TemplateType { Template, Instantiation, Specialization };
static void lCheckTemplateDeclSpecs(DeclSpecs *ds, SourcePos pos, TemplateType type, const char* name);

static EnumType *lCreateEnumType(const char *name, std::vector<Symbol *> *enums,
                                 SourcePos pos);
static void lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                                       const EnumType *enumType);

static const char *lBuiltinTokens[] = {
    "assert", "bool", "break", "case", "cdo",
    "cfor", "cif", "cwhile", "const", "continue", "default",
    "do", "delete", "double", "else", "enum", "export", "extern", "false",
    "float16", "float", "for", "foreach", "foreach_active", "foreach_tiled",
    "foreach_unique", "goto", "if", "in", "inline",
    "int", "int8", "int16", "int32", "int64", "invoke_sycl", "launch", "new", "NULL",
    "print", "return", "signed", "sizeof", "static", "struct", "switch",
    "sync", "task", "true", "typedef", "uniform", "unmasked", "unsigned",
    "varying", "void", "while", "__attribute__", NULL
};

static const char *lParamListTokens[] = {
    "bool", "const", "double", "enum", "false", "float16", "float", "int",
    "int8", "int16", "int32", "int64", "signed", "struct", "true",
    "uniform", "unsigned", "varying", "void", "__attribute__", NULL
};

struct ForeachDimension {
    ForeachDimension(Symbol *s = nullptr, Expr *b = nullptr, Expr *e = nullptr) {
        sym = s;
        beginExpr = b;
        endExpr = e;
    }
    Symbol *sym;
    Expr *beginExpr, *endExpr;
};


#line 155 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parse.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOKEN_INT8_CONSTANT = 3,        /* TOKEN_INT8_CONSTANT  */
  YYSYMBOL_TOKEN_UINT8_CONSTANT = 4,       /* TOKEN_UINT8_CONSTANT  */
  YYSYMBOL_TOKEN_INT16_CONSTANT = 5,       /* TOKEN_INT16_CONSTANT  */
  YYSYMBOL_TOKEN_UINT16_CONSTANT = 6,      /* TOKEN_UINT16_CONSTANT  */
  YYSYMBOL_TOKEN_INT32_CONSTANT = 7,       /* TOKEN_INT32_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32_CONSTANT = 8,      /* TOKEN_UINT32_CONSTANT  */
  YYSYMBOL_TOKEN_INT64_CONSTANT = 9,       /* TOKEN_INT64_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64_CONSTANT = 10,     /* TOKEN_UINT64_CONSTANT  */
  YYSYMBOL_TOKEN_INT32DOTDOTDOT_CONSTANT = 11, /* TOKEN_INT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32DOTDOTDOT_CONSTANT = 12, /* TOKEN_UINT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_INT64DOTDOTDOT_CONSTANT = 13, /* TOKEN_INT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64DOTDOTDOT_CONSTANT = 14, /* TOKEN_UINT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT16_CONSTANT = 15,    /* TOKEN_FLOAT16_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT_CONSTANT = 16,      /* TOKEN_FLOAT_CONSTANT  */
  YYSYMBOL_TOKEN_DOUBLE_CONSTANT = 17,     /* TOKEN_DOUBLE_CONSTANT  */
  YYSYMBOL_TOKEN_STRING_C_LITERAL = 18,    /* TOKEN_STRING_C_LITERAL  */
  YYSYMBOL_TOKEN_STRING_SYCL_LITERAL = 19, /* TOKEN_STRING_SYCL_LITERAL  */
  YYSYMBOL_TOKEN_IDENTIFIER = 20,          /* TOKEN_IDENTIFIER  */
  YYSYMBOL_TOKEN_STRING_LITERAL = 21,      /* TOKEN_STRING_LITERAL  */
  YYSYMBOL_TOKEN_TYPE_NAME = 22,           /* TOKEN_TYPE_NAME  */
  YYSYMBOL_TOKEN_PRAGMA = 23,              /* TOKEN_PRAGMA  */
  YYSYMBOL_TOKEN_NULL = 24,                /* TOKEN_NULL  */
  YYSYMBOL_TOKEN_TEMPLATE_NAME = 25,       /* TOKEN_TEMPLATE_NAME  */
  YYSYMBOL_TOKEN_TEMPLATE = 26,            /* TOKEN_TEMPLATE  */
  YYSYMBOL_TOKEN_TYPENAME = 27,            /* TOKEN_TYPENAME  */
  YYSYMBOL_TOKEN_PTR_OP = 28,              /* TOKEN_PTR_OP  */
  YYSYMBOL_TOKEN_INC_OP = 29,              /* TOKEN_INC_OP  */
  YYSYMBOL_TOKEN_DEC_OP = 30,              /* TOKEN_DEC_OP  */
  YYSYMBOL_TOKEN_LEFT_OP = 31,             /* TOKEN_LEFT_OP  */
  YYSYMBOL_TOKEN_RIGHT_OP = 32,            /* TOKEN_RIGHT_OP  */
  YYSYMBOL_TOKEN_LE_OP = 33,               /* TOKEN_LE_OP  */
  YYSYMBOL_TOKEN_GE_OP = 34,               /* TOKEN_GE_OP  */
  YYSYMBOL_TOKEN_EQ_OP = 35,               /* TOKEN_EQ_OP  */
  YYSYMBOL_TOKEN_NE_OP = 36,               /* TOKEN_NE_OP  */
  YYSYMBOL_TOKEN_AND_OP = 37,              /* TOKEN_AND_OP  */
  YYSYMBOL_TOKEN_OR_OP = 38,               /* TOKEN_OR_OP  */
  YYSYMBOL_TOKEN_MUL_ASSIGN = 39,          /* TOKEN_MUL_ASSIGN  */
  YYSYMBOL_TOKEN_DIV_ASSIGN = 40,          /* TOKEN_DIV_ASSIGN  */
  YYSYMBOL_TOKEN_MOD_ASSIGN = 41,          /* TOKEN_MOD_ASSIGN  */
  YYSYMBOL_TOKEN_ADD_ASSIGN = 42,          /* TOKEN_ADD_ASSIGN  */
  YYSYMBOL_TOKEN_SUB_ASSIGN = 43,          /* TOKEN_SUB_ASSIGN  */
  YYSYMBOL_TOKEN_LEFT_ASSIGN = 44,         /* TOKEN_LEFT_ASSIGN  */
  YYSYMBOL_TOKEN_RIGHT_ASSIGN = 45,        /* TOKEN_RIGHT_ASSIGN  */
  YYSYMBOL_TOKEN_AND_ASSIGN = 46,          /* TOKEN_AND_ASSIGN  */
  YYSYMBOL_TOKEN_OR_ASSIGN = 47,           /* TOKEN_OR_ASSIGN  */
  YYSYMBOL_TOKEN_XOR_ASSIGN = 48,          /* TOKEN_XOR_ASSIGN  */
  YYSYMBOL_TOKEN_SIZEOF = 49,              /* TOKEN_SIZEOF  */
  YYSYMBOL_TOKEN_NEW = 50,                 /* TOKEN_NEW  */
  YYSYMBOL_TOKEN_DELETE = 51,              /* TOKEN_DELETE  */
  YYSYMBOL_TOKEN_IN = 52,                  /* TOKEN_IN  */
  YYSYMBOL_TOKEN_ALLOCA = 53,              /* TOKEN_ALLOCA  */
  YYSYMBOL_TOKEN_INTRINSIC_CALL = 54,      /* TOKEN_INTRINSIC_CALL  */
  YYSYMBOL_TOKEN_EXTERN = 55,              /* TOKEN_EXTERN  */
  YYSYMBOL_TOKEN_EXPORT = 56,              /* TOKEN_EXPORT  */
  YYSYMBOL_TOKEN_STATIC = 57,              /* TOKEN_STATIC  */
  YYSYMBOL_TOKEN_INLINE = 58,              /* TOKEN_INLINE  */
  YYSYMBOL_TOKEN_NOINLINE = 59,            /* TOKEN_NOINLINE  */
  YYSYMBOL_TOKEN_VECTORCALL = 60,          /* TOKEN_VECTORCALL  */
  YYSYMBOL_TOKEN_REGCALL = 61,             /* TOKEN_REGCALL  */
  YYSYMBOL_TOKEN_TASK = 62,                /* TOKEN_TASK  */
  YYSYMBOL_TOKEN_DECLSPEC = 63,            /* TOKEN_DECLSPEC  */
  YYSYMBOL_TOKEN_UNIFORM = 64,             /* TOKEN_UNIFORM  */
  YYSYMBOL_TOKEN_VARYING = 65,             /* TOKEN_VARYING  */
  YYSYMBOL_TOKEN_TYPEDEF = 66,             /* TOKEN_TYPEDEF  */
  YYSYMBOL_TOKEN_SOA = 67,                 /* TOKEN_SOA  */
  YYSYMBOL_TOKEN_UNMASKED = 68,            /* TOKEN_UNMASKED  */
  YYSYMBOL_TOKEN_INT = 69,                 /* TOKEN_INT  */
  YYSYMBOL_TOKEN_SIGNED = 70,              /* TOKEN_SIGNED  */
  YYSYMBOL_TOKEN_UNSIGNED = 71,            /* TOKEN_UNSIGNED  */
  YYSYMBOL_TOKEN_FLOAT16 = 72,             /* TOKEN_FLOAT16  */
  YYSYMBOL_TOKEN_FLOAT = 73,               /* TOKEN_FLOAT  */
  YYSYMBOL_TOKEN_DOUBLE = 74,              /* TOKEN_DOUBLE  */
  YYSYMBOL_TOKEN_INT8 = 75,                /* TOKEN_INT8  */
  YYSYMBOL_TOKEN_INT16 = 76,               /* TOKEN_INT16  */
  YYSYMBOL_TOKEN_INT64 = 77,               /* TOKEN_INT64  */
  YYSYMBOL_TOKEN_CONST = 78,               /* TOKEN_CONST  */
  YYSYMBOL_TOKEN_VOID = 79,                /* TOKEN_VOID  */
  YYSYMBOL_TOKEN_BOOL = 80,                /* TOKEN_BOOL  */
  YYSYMBOL_TOKEN_UINT8 = 81,               /* TOKEN_UINT8  */
  YYSYMBOL_TOKEN_UINT16 = 82,              /* TOKEN_UINT16  */
  YYSYMBOL_TOKEN_UINT = 83,                /* TOKEN_UINT  */
  YYSYMBOL_TOKEN_UINT64 = 84,              /* TOKEN_UINT64  */
  YYSYMBOL_TOKEN_ENUM = 85,                /* TOKEN_ENUM  */
  YYSYMBOL_TOKEN_STRUCT = 86,              /* TOKEN_STRUCT  */
  YYSYMBOL_TOKEN_TRUE = 87,                /* TOKEN_TRUE  */
  YYSYMBOL_TOKEN_FALSE = 88,               /* TOKEN_FALSE  */
  YYSYMBOL_TOKEN_CASE = 89,                /* TOKEN_CASE  */
  YYSYMBOL_TOKEN_DEFAULT = 90,             /* TOKEN_DEFAULT  */
  YYSYMBOL_TOKEN_IF = 91,                  /* TOKEN_IF  */
  YYSYMBOL_TOKEN_ELSE = 92,                /* TOKEN_ELSE  */
  YYSYMBOL_TOKEN_SWITCH = 93,              /* TOKEN_SWITCH  */
  YYSYMBOL_TOKEN_WHILE = 94,               /* TOKEN_WHILE  */
  YYSYMBOL_TOKEN_DO = 95,                  /* TOKEN_DO  */
  YYSYMBOL_TOKEN_LAUNCH = 96,              /* TOKEN_LAUNCH  */
  YYSYMBOL_TOKEN_FOREACH = 97,             /* TOKEN_FOREACH  */
  YYSYMBOL_TOKEN_FOREACH_TILED = 98,       /* TOKEN_FOREACH_TILED  */
  YYSYMBOL_TOKEN_FOREACH_UNIQUE = 99,      /* TOKEN_FOREACH_UNIQUE  */
  YYSYMBOL_TOKEN_FOREACH_ACTIVE = 100,     /* TOKEN_FOREACH_ACTIVE  */
  YYSYMBOL_TOKEN_DOTDOTDOT = 101,          /* TOKEN_DOTDOTDOT  */
  YYSYMBOL_TOKEN_FOR = 102,                /* TOKEN_FOR  */
  YYSYMBOL_TOKEN_GOTO = 103,               /* TOKEN_GOTO  */
  YYSYMBOL_TOKEN_CONTINUE = 104,           /* TOKEN_CONTINUE  */
  YYSYMBOL_TOKEN_BREAK = 105,              /* TOKEN_BREAK  */
  YYSYMBOL_TOKEN_RETURN = 106,             /* TOKEN_RETURN  */
  YYSYMBOL_TOKEN_CIF = 107,                /* TOKEN_CIF  */
  YYSYMBOL_TOKEN_CDO = 108,                /* TOKEN_CDO  */
  YYSYMBOL_TOKEN_CFOR = 109,               /* TOKEN_CFOR  */
  YYSYMBOL_TOKEN_CWHILE = 110,             /* TOKEN_CWHILE  */
  YYSYMBOL_TOKEN_SYNC = 111,               /* TOKEN_SYNC  */
  YYSYMBOL_TOKEN_PRINT = 112,              /* TOKEN_PRINT  */
  YYSYMBOL_TOKEN_ASSERT = 113,             /* TOKEN_ASSERT  */
  YYSYMBOL_TOKEN_INVOKE_SYCL = 114,        /* TOKEN_INVOKE_SYCL  */
  YYSYMBOL_TOKEN_ATTRIBUTE = 115,          /* TOKEN_ATTRIBUTE  */
  YYSYMBOL_116_ = 116,                     /* '('  */
  YYSYMBOL_117_ = 117,                     /* ')'  */
  YYSYMBOL_118_ = 118,                     /* '['  */
  YYSYMBOL_119_ = 119,                     /* ']'  */
  YYSYMBOL_120_ = 120,                     /* ','  */
  YYSYMBOL_121_ = 121,                     /* '<'  */
  YYSYMBOL_122_ = 122,                     /* '>'  */
  YYSYMBOL_123_ = 123,                     /* '.'  */
  YYSYMBOL_124_ = 124,                     /* '&'  */
  YYSYMBOL_125_ = 125,                     /* '*'  */
  YYSYMBOL_126_ = 126,                     /* '+'  */
  YYSYMBOL_127_ = 127,                     /* '-'  */
  YYSYMBOL_128_ = 128,                     /* '~'  */
  YYSYMBOL_129_ = 129,                     /* '!'  */
  YYSYMBOL_130_ = 130,                     /* '/'  */
  YYSYMBOL_131_ = 131,                     /* '%'  */
  YYSYMBOL_132_ = 132,                     /* '^'  */
  YYSYMBOL_133_ = 133,                     /* '|'  */
  YYSYMBOL_134_ = 134,                     /* '?'  */
  YYSYMBOL_135_ = 135,                     /* ':'  */
  YYSYMBOL_136_ = 136,                     /* '='  */
  YYSYMBOL_137_ = 137,                     /* ';'  */
  YYSYMBOL_138_ = 138,                     /* '{'  */
  YYSYMBOL_139_ = 139,                     /* '}'  */
  YYSYMBOL_YYACCEPT = 140,                 /* $accept  */
  YYSYMBOL_string_constant = 141,          /* string_constant  */
  YYSYMBOL_primary_expression = 142,       /* primary_expression  */
  YYSYMBOL_launch_expression = 143,        /* launch_expression  */
  YYSYMBOL_invoke_sycl_expression = 144,   /* invoke_sycl_expression  */
  YYSYMBOL_postfix_expression = 145,       /* postfix_expression  */
  YYSYMBOL_intrinsic_name = 146,           /* intrinsic_name  */
  YYSYMBOL_intrincall_expression = 147,    /* intrincall_expression  */
  YYSYMBOL_funcall_expression = 148,       /* funcall_expression  */
  YYSYMBOL_argument_expression_list = 149, /* argument_expression_list  */
  YYSYMBOL_unary_expression = 150,         /* unary_expression  */
  YYSYMBOL_cast_expression = 151,          /* cast_expression  */
  YYSYMBOL_multiplicative_expression = 152, /* multiplicative_expression  */
  YYSYMBOL_additive_expression = 153,      /* additive_expression  */
  YYSYMBOL_shift_expression = 154,         /* shift_expression  */
  YYSYMBOL_relational_expression = 155,    /* relational_expression  */
  YYSYMBOL_equality_expression = 156,      /* equality_expression  */
  YYSYMBOL_and_expression = 157,           /* and_expression  */
  YYSYMBOL_exclusive_or_expression = 158,  /* exclusive_or_expression  */
  YYSYMBOL_inclusive_or_expression = 159,  /* inclusive_or_expression  */
  YYSYMBOL_logical_and_expression = 160,   /* logical_and_expression  */
  YYSYMBOL_logical_or_expression = 161,    /* logical_or_expression  */
  YYSYMBOL_conditional_expression = 162,   /* conditional_expression  */
  YYSYMBOL_rate_qualified_new = 163,       /* rate_qualified_new  */
  YYSYMBOL_rate_qualified_type_specifier = 164, /* rate_qualified_type_specifier  */
  YYSYMBOL_new_expression = 165,           /* new_expression  */
  YYSYMBOL_assignment_expression = 166,    /* assignment_expression  */
  YYSYMBOL_expression = 167,               /* expression  */
  YYSYMBOL_constant_expression = 168,      /* constant_expression  */
  YYSYMBOL_declaration_statement = 169,    /* declaration_statement  */
  YYSYMBOL_declaration = 170,              /* declaration  */
  YYSYMBOL_soa_width_specifier = 171,      /* soa_width_specifier  */
  YYSYMBOL_declspec_item = 172,            /* declspec_item  */
  YYSYMBOL_declspec_list = 173,            /* declspec_list  */
  YYSYMBOL_declspec_specifier = 174,       /* declspec_specifier  */
  YYSYMBOL_declaration_specifiers = 175,   /* declaration_specifiers  */
  YYSYMBOL_attribute_specifier = 176,      /* attribute_specifier  */
  YYSYMBOL_attribute_list = 177,           /* attribute_list  */
  YYSYMBOL_attribute = 178,                /* attribute  */
  YYSYMBOL_attribute_argument = 179,       /* attribute_argument  */
  YYSYMBOL_init_declarator_list = 180,     /* init_declarator_list  */
  YYSYMBOL_init_declarator = 181,          /* init_declarator  */
  YYSYMBOL_storage_class_specifier = 182,  /* storage_class_specifier  */
  YYSYMBOL_type_specifier = 183,           /* type_specifier  */
  YYSYMBOL_type_specifier_list = 184,      /* type_specifier_list  */
  YYSYMBOL_atomic_var_type_specifier = 185, /* atomic_var_type_specifier  */
  YYSYMBOL_short_vec_specifier = 186,      /* short_vec_specifier  */
  YYSYMBOL_struct_or_union_name = 187,     /* struct_or_union_name  */
  YYSYMBOL_struct_or_union_and_name = 188, /* struct_or_union_and_name  */
  YYSYMBOL_struct_or_union_specifier = 189, /* struct_or_union_specifier  */
  YYSYMBOL_struct_or_union = 190,          /* struct_or_union  */
  YYSYMBOL_struct_declaration_list = 191,  /* struct_declaration_list  */
  YYSYMBOL_struct_declaration = 192,       /* struct_declaration  */
  YYSYMBOL_specifier_qualifier_list = 193, /* specifier_qualifier_list  */
  YYSYMBOL_struct_declarator_list = 194,   /* struct_declarator_list  */
  YYSYMBOL_struct_declarator = 195,        /* struct_declarator  */
  YYSYMBOL_enum_identifier = 196,          /* enum_identifier  */
  YYSYMBOL_enum_specifier = 197,           /* enum_specifier  */
  YYSYMBOL_enumerator_list = 198,          /* enumerator_list  */
  YYSYMBOL_enumerator = 199,               /* enumerator  */
  YYSYMBOL_type_qualifier = 200,           /* type_qualifier  */
  YYSYMBOL_type_qualifier_list = 201,      /* type_qualifier_list  */
  YYSYMBOL_declarator = 202,               /* declarator  */
  YYSYMBOL_int_constant = 203,             /* int_constant  */
  YYSYMBOL_direct_declarator = 204,        /* direct_declarator  */
  YYSYMBOL_pointer = 205,                  /* pointer  */
  YYSYMBOL_reference = 206,                /* reference  */
  YYSYMBOL_parameter_type_list = 207,      /* parameter_type_list  */
  YYSYMBOL_parameter_list = 208,           /* parameter_list  */
  YYSYMBOL_parameter_declaration = 209,    /* parameter_declaration  */
  YYSYMBOL_type_name = 210,                /* type_name  */
  YYSYMBOL_abstract_declarator = 211,      /* abstract_declarator  */
  YYSYMBOL_direct_abstract_declarator = 212, /* direct_abstract_declarator  */
  YYSYMBOL_initializer = 213,              /* initializer  */
  YYSYMBOL_initializer_list = 214,         /* initializer_list  */
  YYSYMBOL_pragma = 215,                   /* pragma  */
  YYSYMBOL_attributed_statement = 216,     /* attributed_statement  */
  YYSYMBOL_statement = 217,                /* statement  */
  YYSYMBOL_labeled_statement = 218,        /* labeled_statement  */
  YYSYMBOL_start_scope = 219,              /* start_scope  */
  YYSYMBOL_end_scope = 220,                /* end_scope  */
  YYSYMBOL_compound_statement = 221,       /* compound_statement  */
  YYSYMBOL_statement_list = 222,           /* statement_list  */
  YYSYMBOL_expression_statement = 223,     /* expression_statement  */
  YYSYMBOL_selection_statement = 224,      /* selection_statement  */
  YYSYMBOL_for_test = 225,                 /* for_test  */
  YYSYMBOL_for_init_statement = 226,       /* for_init_statement  */
  YYSYMBOL_for_scope = 227,                /* for_scope  */
  YYSYMBOL_cfor_scope = 228,               /* cfor_scope  */
  YYSYMBOL_foreach_scope = 229,            /* foreach_scope  */
  YYSYMBOL_foreach_tiled_scope = 230,      /* foreach_tiled_scope  */
  YYSYMBOL_foreach_identifier = 231,       /* foreach_identifier  */
  YYSYMBOL_foreach_active_scope = 232,     /* foreach_active_scope  */
  YYSYMBOL_foreach_active_identifier = 233, /* foreach_active_identifier  */
  YYSYMBOL_integer_dotdotdot = 234,        /* integer_dotdotdot  */
  YYSYMBOL_foreach_dimension_specifier = 235, /* foreach_dimension_specifier  */
  YYSYMBOL_foreach_dimension_list = 236,   /* foreach_dimension_list  */
  YYSYMBOL_foreach_unique_scope = 237,     /* foreach_unique_scope  */
  YYSYMBOL_foreach_unique_identifier = 238, /* foreach_unique_identifier  */
  YYSYMBOL_iteration_statement = 239,      /* iteration_statement  */
  YYSYMBOL_240_1 = 240,                    /* $@1  */
  YYSYMBOL_241_2 = 241,                    /* $@2  */
  YYSYMBOL_242_3 = 242,                    /* $@3  */
  YYSYMBOL_243_4 = 243,                    /* $@4  */
  YYSYMBOL_goto_identifier = 244,          /* goto_identifier  */
  YYSYMBOL_jump_statement = 245,           /* jump_statement  */
  YYSYMBOL_sync_statement = 246,           /* sync_statement  */
  YYSYMBOL_delete_statement = 247,         /* delete_statement  */
  YYSYMBOL_unmasked_statement = 248,       /* unmasked_statement  */
  YYSYMBOL_print_statement = 249,          /* print_statement  */
  YYSYMBOL_assert_statement = 250,         /* assert_statement  */
  YYSYMBOL_translation_unit = 251,         /* translation_unit  */
  YYSYMBOL_external_declaration = 252,     /* external_declaration  */
  YYSYMBOL_function_definition = 253,      /* function_definition  */
  YYSYMBOL_254_5 = 254,                    /* $@5  */
  YYSYMBOL_template_type_parameter = 255,  /* template_type_parameter  */
  YYSYMBOL_int_constant_type = 256,        /* int_constant_type  */
  YYSYMBOL_template_int_constant_type = 257, /* template_int_constant_type  */
  YYSYMBOL_template_int_parameter = 258,   /* template_int_parameter  */
  YYSYMBOL_template_enum_parameter = 259,  /* template_enum_parameter  */
  YYSYMBOL_template_parameter = 260,       /* template_parameter  */
  YYSYMBOL_template_parameter_list = 261,  /* template_parameter_list  */
  YYSYMBOL_template_head = 262,            /* template_head  */
  YYSYMBOL_template_declaration = 263,     /* template_declaration  */
  YYSYMBOL_264_6 = 264,                    /* $@6  */
  YYSYMBOL_template_function_declaration_or_definition = 265, /* template_function_declaration_or_definition  */
  YYSYMBOL_template_argument = 266,        /* template_argument  */
  YYSYMBOL_template_argument_list = 267,   /* template_argument_list  */
  YYSYMBOL_template_identifier = 268,      /* template_identifier  */
  YYSYMBOL_simple_template_id = 269,       /* simple_template_id  */
  YYSYMBOL_template_function_instantiation = 270, /* template_function_instantiation  */
  YYSYMBOL_template_function_specialization_declaration = 271, /* template_function_specialization_declaration  */
  YYSYMBOL_template_function_specialization = 272 /* template_function_specialization  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  98
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4512

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  140
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  133
/* YYNRULES -- Number of rules.  */
#define YYNRULES  428
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  792

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   370


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   129,     2,     2,     2,   131,   124,     2,
     116,   117,   125,   126,   120,   127,   123,   130,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   135,   137,
     121,   136,   122,   134,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   118,     2,   119,   132,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   138,   133,   139,   128,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   300,   300,   305,   318,   338,   342,   346,   350,   354,
     358,   362,   366,   370,   379,   384,   389,   392,   395,   400,
     401,   405,   411,   418,   424,   431,   437,   443,   449,   456,
     461,   466,   471,   478,   484,   490,   496,   505,   509,   513,
     518,   519,   521,   523,   524,   531,   536,   541,   548,   553,
     558,   560,   565,   572,   588,   589,   591,   593,   595,   615,
     635,   645,   646,   660,   661,   662,   663,   665,   667,   669,
     671,   673,   675,   677,   679,   681,   683,   690,   691,   698,
     699,   701,   703,   708,   709,   711,   716,   717,   719,   724,
     725,   727,   729,   731,   736,   737,   739,   744,   745,   750,
     751,   756,   757,   762,   763,   768,   769,   774,   775,   780,
     781,   782,   786,   787,   798,   809,   833,   834,   838,   842,
     849,   850,   852,   854,   856,   858,   860,   862,   864,   866,
     868,   870,   875,   876,   881,   885,   911,   915,   925,   930,
     941,   948,   960,   968,   972,   986,   995,  1008,  1014,  1025,
    1029,  1035,  1048,  1069,  1073,  1080,  1090,  1103,  1110,  1118,
    1129,  1136,  1148,  1152,  1162,  1169,  1183,  1184,  1193,  1194,
    1195,  1196,  1197,  1201,  1202,  1208,  1209,  1213,  1224,  1235,
    1236,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,
    1246,  1247,  1251,  1266,  1271,  1279,  1303,  1304,  1326,  1342,
    1350,  1367,  1371,  1378,  1392,  1397,  1398,  1399,  1400,  1486,
    1493,  1507,  1515,  1523,  1529,  1538,  1544,  1553,  1578,  1588,
    1602,  1608,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1644,  1645,  1646,  1647,  1651,  1655,  1662,  1674,  1686,  1690,
    1691,  1692,  1693,  1697,  1706,  1713,  1717,  1748,  1759,  1763,
    1778,  1788,  1796,  1800,  1806,  1812,  1823,  1831,  1835,  1842,
    1851,  1859,  1863,  1872,  1879,  1896,  1897,  1909,  1913,  1914,
    1924,  1928,  1941,  1943,  1949,  1978,  1989,  2020,  2022,  2032,
    2042,  2060,  2061,  2062,  2066,  2068,  2082,  2089,  2099,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2123,  2129,  2147,  2152,  2156,  2160,  2161,  2165,
    2171,  2184,  2185,  2189,  2191,  2193,  2195,  2197,  2202,  2204,
    2209,  2210,  2214,  2218,  2222,  2226,  2230,  2238,  2242,  2250,
    2254,  2258,  2262,  2269,  2273,  2280,  2285,  2299,  2303,  2311,
    2313,  2315,  2317,  2319,  2323,  2327,  2331,  2336,  2335,  2371,
    2370,  2407,  2406,  2418,  2416,  2440,  2448,  2454,  2456,  2458,
    2460,  2465,  2470,  2477,  2484,  2490,  2499,  2508,  2509,  2510,
    2514,  2515,  2516,  2517,  2518,  2519,  2520,  2525,  2531,  2536,
    2535,  2573,  2578,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
    2595,  2599,  2600,  2604,  2609,  2619,  2632,  2638,  2644,  2653,
    2661,  2676,  2684,  2683,  2710,  2717,  2733,  2740,  2744,  2748,
    2752,  2756,  2760,  2764,  2768,  2773,  2794,  2803,  2814,  2822,
    2834,  2851,  2877,  2898,  2908,  2930,  2944,  2954,  2963
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOKEN_INT8_CONSTANT",
  "TOKEN_UINT8_CONSTANT", "TOKEN_INT16_CONSTANT", "TOKEN_UINT16_CONSTANT",
  "TOKEN_INT32_CONSTANT", "TOKEN_UINT32_CONSTANT", "TOKEN_INT64_CONSTANT",
  "TOKEN_UINT64_CONSTANT", "TOKEN_INT32DOTDOTDOT_CONSTANT",
  "TOKEN_UINT32DOTDOTDOT_CONSTANT", "TOKEN_INT64DOTDOTDOT_CONSTANT",
  "TOKEN_UINT64DOTDOTDOT_CONSTANT", "TOKEN_FLOAT16_CONSTANT",
  "TOKEN_FLOAT_CONSTANT", "TOKEN_DOUBLE_CONSTANT",
  "TOKEN_STRING_C_LITERAL", "TOKEN_STRING_SYCL_LITERAL",
  "TOKEN_IDENTIFIER", "TOKEN_STRING_LITERAL", "TOKEN_TYPE_NAME",
  "TOKEN_PRAGMA", "TOKEN_NULL", "TOKEN_TEMPLATE_NAME", "TOKEN_TEMPLATE",
  "TOKEN_TYPENAME", "TOKEN_PTR_OP", "TOKEN_INC_OP", "TOKEN_DEC_OP",
  "TOKEN_LEFT_OP", "TOKEN_RIGHT_OP", "TOKEN_LE_OP", "TOKEN_GE_OP",
  "TOKEN_EQ_OP", "TOKEN_NE_OP", "TOKEN_AND_OP", "TOKEN_OR_OP",
  "TOKEN_MUL_ASSIGN", "TOKEN_DIV_ASSIGN", "TOKEN_MOD_ASSIGN",
  "TOKEN_ADD_ASSIGN", "TOKEN_SUB_ASSIGN", "TOKEN_LEFT_ASSIGN",
  "TOKEN_RIGHT_ASSIGN", "TOKEN_AND_ASSIGN", "TOKEN_OR_ASSIGN",
  "TOKEN_XOR_ASSIGN", "TOKEN_SIZEOF", "TOKEN_NEW", "TOKEN_DELETE",
  "TOKEN_IN", "TOKEN_ALLOCA", "TOKEN_INTRINSIC_CALL", "TOKEN_EXTERN",
  "TOKEN_EXPORT", "TOKEN_STATIC", "TOKEN_INLINE", "TOKEN_NOINLINE",
  "TOKEN_VECTORCALL", "TOKEN_REGCALL", "TOKEN_TASK", "TOKEN_DECLSPEC",
  "TOKEN_UNIFORM", "TOKEN_VARYING", "TOKEN_TYPEDEF", "TOKEN_SOA",
  "TOKEN_UNMASKED", "TOKEN_INT", "TOKEN_SIGNED", "TOKEN_UNSIGNED",
  "TOKEN_FLOAT16", "TOKEN_FLOAT", "TOKEN_DOUBLE", "TOKEN_INT8",
  "TOKEN_INT16", "TOKEN_INT64", "TOKEN_CONST", "TOKEN_VOID", "TOKEN_BOOL",
  "TOKEN_UINT8", "TOKEN_UINT16", "TOKEN_UINT", "TOKEN_UINT64",
  "TOKEN_ENUM", "TOKEN_STRUCT", "TOKEN_TRUE", "TOKEN_FALSE", "TOKEN_CASE",
  "TOKEN_DEFAULT", "TOKEN_IF", "TOKEN_ELSE", "TOKEN_SWITCH", "TOKEN_WHILE",
  "TOKEN_DO", "TOKEN_LAUNCH", "TOKEN_FOREACH", "TOKEN_FOREACH_TILED",
  "TOKEN_FOREACH_UNIQUE", "TOKEN_FOREACH_ACTIVE", "TOKEN_DOTDOTDOT",
  "TOKEN_FOR", "TOKEN_GOTO", "TOKEN_CONTINUE", "TOKEN_BREAK",
  "TOKEN_RETURN", "TOKEN_CIF", "TOKEN_CDO", "TOKEN_CFOR", "TOKEN_CWHILE",
  "TOKEN_SYNC", "TOKEN_PRINT", "TOKEN_ASSERT", "TOKEN_INVOKE_SYCL",
  "TOKEN_ATTRIBUTE", "'('", "')'", "'['", "']'", "','", "'<'", "'>'",
  "'.'", "'&'", "'*'", "'+'", "'-'", "'~'", "'!'", "'/'", "'%'", "'^'",
  "'|'", "'?'", "':'", "'='", "';'", "'{'", "'}'", "$accept",
  "string_constant", "primary_expression", "launch_expression",
  "invoke_sycl_expression", "postfix_expression", "intrinsic_name",
  "intrincall_expression", "funcall_expression",
  "argument_expression_list", "unary_expression", "cast_expression",
  "multiplicative_expression", "additive_expression", "shift_expression",
  "relational_expression", "equality_expression", "and_expression",
  "exclusive_or_expression", "inclusive_or_expression",
  "logical_and_expression", "logical_or_expression",
  "conditional_expression", "rate_qualified_new",
  "rate_qualified_type_specifier", "new_expression",
  "assignment_expression", "expression", "constant_expression",
  "declaration_statement", "declaration", "soa_width_specifier",
  "declspec_item", "declspec_list", "declspec_specifier",
  "declaration_specifiers", "attribute_specifier", "attribute_list",
  "attribute", "attribute_argument", "init_declarator_list",
  "init_declarator", "storage_class_specifier", "type_specifier",
  "type_specifier_list", "atomic_var_type_specifier",
  "short_vec_specifier", "struct_or_union_name",
  "struct_or_union_and_name", "struct_or_union_specifier",
  "struct_or_union", "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_identifier", "enum_specifier",
  "enumerator_list", "enumerator", "type_qualifier", "type_qualifier_list",
  "declarator", "int_constant", "direct_declarator", "pointer",
  "reference", "parameter_type_list", "parameter_list",
  "parameter_declaration", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "initializer", "initializer_list",
  "pragma", "attributed_statement", "statement", "labeled_statement",
  "start_scope", "end_scope", "compound_statement", "statement_list",
  "expression_statement", "selection_statement", "for_test",
  "for_init_statement", "for_scope", "cfor_scope", "foreach_scope",
  "foreach_tiled_scope", "foreach_identifier", "foreach_active_scope",
  "foreach_active_identifier", "integer_dotdotdot",
  "foreach_dimension_specifier", "foreach_dimension_list",
  "foreach_unique_scope", "foreach_unique_identifier",
  "iteration_statement", "$@1", "$@2", "$@3", "$@4", "goto_identifier",
  "jump_statement", "sync_statement", "delete_statement",
  "unmasked_statement", "print_statement", "assert_statement",
  "translation_unit", "external_declaration", "function_definition", "$@5",
  "template_type_parameter", "int_constant_type",
  "template_int_constant_type", "template_int_parameter",
  "template_enum_parameter", "template_parameter",
  "template_parameter_list", "template_head", "template_declaration",
  "$@6", "template_function_declaration_or_definition",
  "template_argument", "template_argument_list", "template_identifier",
  "simple_template_id", "template_function_instantiation",
  "template_function_specialization_declaration",
  "template_function_specialization", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-423)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-380)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1096,   -98,  -423,  4227,   240,   -71,  -423,  -423,  -423,  -423,
    -423,  -423,   -28,  -423,  -423,  -423,   -15,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,     2,  -423,    -6,  -423,  -423,  4361,
    4361,    39,  4361,  4361,  4294,  -423,   -16,  -423,    -2,  -423,
    4361,  1010,  -423,  -423,  -423,   141,  -423,  -423,   177,  -423,
    -423,   354,  -423,   483,   131,    28,    43,   577,    96,   264,
    -423,   178,    65,   112,  -423,  -423,  -423,  -423,    71,  -423,
     979,  -423,   -90,  -423,     8,   101,    29,    29,  -423,  -423,
     215,  -423,  3714,  -423,  -423,  3745,  -423,  -423,  -423,  -423,
    4361,  -423,   124,   893,  -423,  -423,  -423,  -423,  -423,   290,
     325,   308,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    4361,  -423,  -423,   335,  -423,  -423,  -423,   244,  -423,   153,
     168,  4361,  4361,  -423,   -52,  -423,  -423,    42,  -423,  -423,
    -423,  -423,   274,   312,   -49,  -423,   178,   423,   343,  -423,
     979,  -423,    71,  -423,  1238,   314,  3904,  2093,   101,   101,
     365,   378,  -423,  4426,   344,  -423,  3786,  -423,    71,  4426,
    -423,  3817,    71,  -423,   367,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,   356,  -423,  -423,  3228,
    3228,  3297,  -423,  3021,   390,  -423,   463,   465,   381,  -423,
    -423,  3366,   394,   433,   435,   437,   893,  3611,  -423,  -423,
    -423,  -423,  -423,   516,   439,   444,  1500,   468,   893,  -423,
     474,   472,   484,   499,   513,  1688,  3228,  3228,  3366,  3366,
    3366,  3366,  -423,  -423,  -423,  -423,   247,   518,  -423,  -423,
     257,  -423,   -11,   255,   355,    70,   368,   431,   478,   503,
     604,    24,  -423,  1263,  -423,  -423,   -65,  -423,  -423,    39,
     893,  -423,  -423,  -423,  -423,   615,  -423,  -423,   526,   527,
     531,   532,   539,   551,  -423,   572,  -423,  -423,  -423,  -423,
    -423,  -423,   600,  -423,   596,  -423,   131,   598,   711,  -423,
    3675,  3990,   597,   606,   577,   609,  -423,    96,  -423,  3366,
      -1,  -423,   -39,   619,    68,  -423,  -423,  -423,  -423,  -423,
     601,  -423,   463,   465,  1238,  -423,  -423,  -423,   135,  -423,
      49,   630,   628,  -423,   631,  -423,  -423,  -423,   632,  -423,
    -423,  -423,   264,  -423,  -423,   -55,  -423,  -423,  -423,  -423,
    -423,  -423,  1955,  -423,  -423,  1688,  -423,   -45,  3021,  -423,
    -423,   893,   614,   893,  3021,  3021,  3021,   662,  3021,  2347,
     279,  -423,   629,  -423,  -423,  -423,   -12,  3021,   671,  3021,
    -423,   746,   746,  2155,   651,   166,   107,   655,  -423,  -423,
    -423,  -423,  -423,  -423,   108,  -423,  -423,  1817,  2024,   322,
    3021,  3021,  3021,  3021,  3021,  3021,  3021,  3021,  3021,  3021,
    3021,  3021,  3366,  3366,  3366,  3366,  3366,  3366,  3366,  3366,
    3366,  3366,  3366,  3366,  3366,  3366,  3366,  3366,  3366,  3366,
    3021,   577,   577,   326,   577,  -423,  3021,  -423,  -423,  -423,
    -423,  -423,  1365,  1365,   753,   753,   761,   762,   893,  1886,
     577,   669,   264,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,   303,   173,   652,   673,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,     3,  -423,   261,
     674,   423,  -423,   -22,  -423,  -423,  3441,  3090,   660,    64,
      64,  -423,   340,  -423,  4361,  -423,  -423,   675,    71,  -423,
     681,  -423,   682,   754,   893,  -423,   226,   233,   234,   684,
     309,   289,  2273,  -423,  -423,   239,   685,   254,  -423,    52,
       4,   689,   171,  -423,  -423,  3527,   380,   380,  -423,  3366,
    -423,  -423,  -423,   729,  -423,   296,  -423,   683,   315,  -423,
    -423,  -423,   300,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,   -11,   -11,   255,
     255,   355,   355,   355,   355,    70,    70,   368,   431,   478,
     503,   604,    55,  -423,  -423,  1238,  3021,  -423,  -423,  -423,
    -423,  1553,  1553,  -423,   719,  -423,   301,   307,  -423,   755,
    -423,   819,  -423,   756,  -423,   313,  -423,  4076,  -423,  3675,
    -423,   737,  -423,   738,  -423,   855,   760,  -423,  -423,  -423,
    1185,  -423,   764,  -423,   768,   769,  -423,   770,  1238,   340,
     340,  4162,  3159,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
     893,   893,   893,  3021,  3650,  3021,  2400,  -423,   333,   893,
    3021,   893,  -423,   750,  3021,  3021,  -423,  -423,  3021,  -423,
    -423,  -423,  3021,  -423,  -423,  -423,  3366,   347,   362,  -423,
      -5,  2469,  2538,  2220,  -423,   753,  -423,  -423,  3021,  -423,
    -423,   359,  -423,   771,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,   773,  -423,   776,   812,  -423,
    -423,   369,  3021,  2347,   292,   442,   783,   397,  -423,   814,
     406,  -423,  -423,   407,   418,   420,  -423,  -423,  -423,  1238,
    -423,  -423,   893,   424,   893,   426,  -423,  -423,  -423,  -423,
     806,  3021,   893,  -423,   893,   893,   457,  -423,  -423,  -423,
    -423,   893,   774,   793,   339,  2607,  2347,  3021,  -423,   792,
     893,   782,   784,   787,  -423,  -423,   893,  -423,   893,  3021,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,  3907,  2676,  -423,
     458,   350,   801,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,   893,  3021,   464,   803,   466,  -423,  2745,  2347,  -423,
     807,  2814,  -423,   805,  -423,   481,   473,  2347,  -423,   486,
    -423,  -423,  2883,   479,  -423,  -423,   487,  2952,  -423,  -423,
     494,  -423
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,   174,     0,   169,   227,   172,   228,   229,   230,
     231,   225,     0,   223,   224,   168,     0,   226,   185,   232,
     233,   187,   188,   189,   181,   183,   190,   222,   179,   180,
     182,   184,   186,   191,     0,   201,     0,   378,   377,   147,
     145,     0,   155,   143,   149,   173,   196,   175,     0,   176,
     153,     0,   367,   370,   402,     0,   371,   373,     0,   372,
     369,   169,   227,     0,     0,   170,   171,     0,     0,     0,
     212,     0,   217,     0,   148,   146,   243,   244,     0,   256,
     252,   136,     0,   164,   166,   238,     0,     0,   156,   144,
       0,   152,     0,   193,   194,     0,   195,   154,     1,   368,
       0,   404,   305,     0,   405,   427,   428,   170,   171,     0,
       0,     0,   385,   383,   384,   386,   387,   388,   389,   390,
       0,   396,   392,     0,   397,   398,   399,     0,   418,   420,
       0,     0,     0,   177,     0,   139,   140,     0,   239,   240,
     241,   242,     0,   220,     0,   218,     0,     0,     0,   234,
     253,   254,     0,   137,     0,     0,     0,     0,   236,   237,
       0,     0,   200,   206,   173,   207,     0,   202,     0,     0,
     199,     0,     0,   307,     0,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,     4,   286,    18,     0,
       0,     0,   109,     0,     0,    52,   223,   224,   226,    16,
      17,     0,     0,     0,     0,     0,     0,     0,   324,   325,
     337,   327,   322,     0,     0,     0,     0,     0,     0,   323,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   311,    40,    43,    65,    54,     0,    64,    63,
      77,    79,    83,    86,    89,    94,    97,    99,   101,   103,
     105,   107,   116,     0,   120,   132,     0,   295,   135,     0,
       0,   309,   288,   289,   290,     0,   291,   292,     0,     0,
       0,     0,     0,     0,   293,     0,   294,   298,   299,   300,
     296,   297,     0,   395,   381,   391,     0,   393,     0,   401,
       0,     0,     0,     0,     0,     0,   142,     0,   138,     0,
       0,   213,     0,   160,     0,   158,   245,   235,   255,   165,
     166,     4,     0,     0,     0,   281,   167,   380,     0,   250,
     264,     0,   257,   258,     0,   247,    77,   134,     0,   151,
     150,   205,     0,   197,   203,     0,   209,   211,   208,   198,
     403,   301,     0,    66,    67,     0,    74,     0,     0,   110,
     111,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   355,     0,   357,   358,   359,     0,     0,     0,     0,
     361,     0,     0,     0,     0,     0,   265,     0,    68,    69,
      70,    71,    72,    73,     0,    50,    51,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   117,     0,   112,     0,   312,   287,   306,
     310,   308,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   400,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   406,   416,     0,     0,     0,     0,   374,
     375,   178,   376,   141,   221,   215,   219,     0,   214,     0,
       0,     0,   284,     0,   251,   260,     0,     0,   261,   267,
     270,   263,   268,   249,     0,   248,   246,     0,     0,   204,
       0,   362,     0,     0,     0,   304,     0,     0,     0,     0,
       0,     0,     0,   356,   360,     0,     0,     0,     2,     0,
       0,     0,     0,    20,    19,     0,   267,   270,   266,     0,
      47,    48,    49,     0,    55,     0,    61,     0,     0,    44,
      45,    46,     0,   122,   123,   124,   125,   126,   127,   128,
     129,   131,   130,   121,    80,    81,    82,    84,    85,    87,
      88,    92,    93,    90,    91,    95,    96,    98,   100,   102,
     104,   106,     0,   113,   114,     0,     0,   115,   133,   321,
     320,     0,     0,   326,     0,   335,     0,     0,   328,     0,
     338,     0,   302,     0,    58,     0,   382,     0,   394,     0,
     419,     0,   422,     0,   216,   163,     0,   162,   157,   159,
       0,   282,     0,   277,     0,     0,   273,     0,     0,   269,
     271,     0,     0,   259,   192,   210,    75,    76,   363,   303,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,     0,     3,     0,     0,     0,    39,    37,     0,    78,
      57,    56,     0,    42,    41,    53,     0,     0,     0,   318,
       0,     0,     0,     0,   347,     0,   349,   351,     0,    60,
      59,     0,   425,     0,   417,   423,   421,   161,   283,   285,
     278,   272,   274,   262,   279,     0,   275,     0,   313,   317,
     339,     0,     0,     0,     0,     0,     0,     0,    21,   315,
       0,   340,   364,     0,     0,     0,    62,   108,   118,     0,
     119,   319,     0,     0,     0,     0,   329,   330,   331,   332,
       0,     0,     0,   336,     0,     0,     0,   426,   424,   280,
     276,     0,     0,     0,     0,     0,     0,     0,    34,     0,
       0,     0,     0,     0,    38,   343,     0,   345,     0,     0,
     334,   348,   350,   352,   353,   314,   341,     0,     0,    24,
       0,     0,     0,    33,   316,   342,   365,   366,   344,   346,
     333,     0,     0,     0,     0,     0,    23,     0,     0,   354,
       0,     0,    36,     0,    26,     0,     0,     0,    28,     0,
      35,    25,     0,     0,    27,    30,     0,     0,    29,    32,
       0,    31
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -423,  -334,  -423,  -423,  -423,  -205,  -423,  -423,  -423,  -373,
     -78,  -196,    69,    62,  -199,   156,   514,   512,   515,   517,
     511,  -423,  -115,  -423,   678,  -423,  -154,  -140,  -190,   160,
      46,  -240,   636,  -423,  -423,     1,  -423,  -423,   467,  -423,
    -423,   785,  -423,   -64,  -423,    91,  -423,  -423,  -423,  -423,
    -423,   839,  -110,  -148,  -423,   448,   905,  -423,   794,  -288,
     -32,  -423,   -25,   -81,   -79,   -70,  -306,  -150,  -423,   461,
     640,  -283,  -422,  -149,   376,  -423,  -182,  -423,  -423,  -423,
    -423,   -29,   643,   194,  -423,   440,   578,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,   358,   579,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,   802,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,   965,  -423,  -423,  -423,   912,  -423,  -423,  -423,
     736,  -423,  -423,  -423,  -423,  -423,   436,  -423,  -423,   -37,
    -423,  -423,  -423
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   509,   233,   234,   235,   236,   237,   238,   239,   525,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   453,   254,   255,   256,   328,   257,
     258,    39,   136,   137,    40,   259,    42,   304,   305,   596,
      82,    83,    43,    44,   134,    45,   165,    96,    46,    47,
      48,   166,   167,   168,   335,   336,   143,    49,   144,   145,
      50,   150,   148,   142,    85,    86,    87,   604,   322,   323,
     377,   605,   482,   472,   473,   260,   261,   262,   263,   103,
     431,   264,   265,   266,   267,   651,   571,   268,   269,   270,
     271,   574,   272,   579,   711,   575,   576,   273,   581,   274,
     712,   714,   715,   761,   275,   276,   277,   278,   279,   280,
     281,    51,    52,    53,   155,   121,   122,   123,   124,   125,
     126,   127,    54,    55,   100,    56,   454,   455,   129,   282,
      57,    58,    59
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     315,    41,   360,   133,    64,   316,   321,   158,   159,   161,
     151,   352,   466,   424,   480,   331,    84,   532,    93,    70,
      94,   338,    70,    70,   357,   632,   104,   130,   163,   106,
     152,   163,   380,   381,   382,   383,   368,   481,   510,    60,
      74,    75,   327,    88,    89,    91,    38,   153,   149,    76,
     424,    97,    41,   347,    77,   426,   334,   609,   610,    76,
     169,   334,   419,   169,    77,   488,   585,    67,   294,    76,
     517,   300,   427,   632,    77,   426,   366,   376,   428,   326,
     308,   467,   489,   430,    76,   375,   327,   295,    68,    77,
     301,    76,   491,   518,   609,   610,    77,    38,   600,   163,
     468,   172,   163,   409,   410,   163,    69,   163,   426,   464,
      73,   343,   344,   346,   402,   426,   135,   601,   307,   403,
     404,   286,    92,   326,   635,   504,   317,   310,   520,   628,
     521,   169,   701,   522,   169,   595,    95,   169,   465,   169,
      71,   458,   594,   337,   154,    78,  -379,   340,   378,   379,
     326,   326,   326,   326,   501,    78,   128,   320,   420,   296,
     315,   163,   297,    79,    80,   476,   131,   477,   512,   633,
     480,   495,   634,    79,    80,   426,    81,   292,   293,   466,
     476,   132,   477,   164,   327,   470,   164,    78,   471,   425,
     646,   411,   412,   169,   492,    79,    80,   376,    70,   384,
     385,   386,   375,   146,   500,   375,   544,   545,   546,   517,
     551,   552,   553,   554,   496,   497,   498,   156,   138,   157,
     139,   326,   140,   515,   141,   477,   425,   505,   147,   507,
     461,    79,    80,   526,   310,   160,   526,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   528,   441,
     479,   487,   474,   687,   164,   475,   582,   164,    65,    66,
     164,   693,   164,   173,   138,   695,   139,   138,   140,   139,
     141,   140,   568,   141,   290,   384,   385,   386,   101,   102,
     562,   163,   508,   514,   291,   526,   426,   607,   637,   388,
     591,   638,   320,   475,   389,   478,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   516,   384,   385,   386,
     283,   430,   619,   169,   105,   102,   164,   384,   385,   386,
     384,   385,   386,   639,   326,   326,   326,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   529,   620,   530,   284,   426,   531,   526,   424,
     621,   622,   750,   426,   426,   287,   629,   563,   564,   426,
     567,   588,   327,   387,   288,   388,   289,   384,   385,   386,
     389,   631,   107,   108,   426,   765,   586,   112,   384,   385,
     386,   405,   406,   113,   114,   115,   407,   408,   597,   116,
     117,   118,   119,   401,   775,   502,   298,   388,   779,   326,
     158,   159,   389,   413,   414,   626,   479,   388,   725,   786,
     388,   315,   389,   641,   790,   389,   642,   645,   654,   684,
     642,   655,   677,   589,   656,   590,   648,   655,   624,   625,
     660,   650,   650,   642,   644,   426,   164,   663,   678,   679,
     680,   326,   565,   303,   566,   516,   315,   689,   299,   691,
     688,   669,   102,   642,   315,   748,   611,   388,   612,   673,
     306,   675,   389,   337,   698,   332,   767,   699,   388,   549,
     550,   685,   526,   389,   547,   548,   717,   320,   724,   475,
     526,   700,   426,   681,   526,   320,   722,   329,   696,   426,
     690,  -355,   384,   385,   386,   694,   515,   327,   477,   710,
     330,   384,   385,   386,   341,   109,   348,   384,   385,   386,
     110,   703,   705,   349,   729,   350,   320,   642,   716,   351,
     735,   751,   737,   731,   732,   425,   426,   642,   723,   353,
     741,   697,   742,   743,   326,   733,   361,   734,   426,   745,
     642,   736,   763,   738,   426,   315,   426,   111,   754,   354,
     669,   355,   112,   356,   758,   415,   759,   740,   113,   114,
     115,   726,   727,   776,   116,   117,   118,   119,   326,   555,
     556,   526,   783,   752,   744,   766,   363,   426,   642,   769,
     771,   364,   388,   773,   367,   760,   642,   389,   320,   782,
     369,   388,   569,   569,   526,   787,   389,   388,   781,     2,
     371,   642,   389,   784,   788,   120,   642,   642,   770,   370,
     416,   791,   320,   526,   642,   372,   174,   526,   175,   176,
     177,   178,   179,   180,   181,   182,   570,   570,   526,   373,
     183,   184,   185,   526,   390,   186,   417,     2,   187,   188,
     128,   418,   432,   433,   189,   190,    18,   434,   435,    21,
      22,    23,    24,    25,    26,   436,    28,    29,    30,    31,
      32,    33,    34,    35,   191,   192,   193,   437,   194,   195,
      61,    62,     6,     7,     8,     9,    10,    11,    12,   196,
     197,    15,    16,   198,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,   199,   200,   201,   202,   203,   438,   204,   205,
     206,   207,   208,   209,   210,   211,   439,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      36,   225,   440,   109,   442,   469,   459,   154,   110,   226,
     227,   228,   229,   230,   231,   460,   462,   483,   484,   494,
     485,   486,   232,   102,   429,   174,   499,   175,   176,   177,
     178,   179,   180,   181,   182,   506,   503,   508,   513,   183,
     184,   185,   519,   573,   186,   111,     2,   187,   188,   128,
     112,   578,   580,   189,   190,   587,   113,   114,   115,   592,
     593,   598,   116,   117,   118,   119,   608,   614,   616,   617,
     623,   630,   643,   191,   192,   193,   636,   194,   195,    61,
      62,     6,     7,     8,     9,    10,    11,    12,   196,   197,
      15,    16,   198,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,   199,   200,   201,   202,   203,   640,   204,   205,   206,
     207,   208,   209,   210,   211,   653,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    36,
     225,   658,   657,   659,   665,   666,   632,   667,   226,   227,
     228,   229,   230,   231,   475,   670,   671,   692,   718,   672,
     719,   232,   102,   618,   174,   720,   175,   176,   177,   178,
     179,   180,   181,   182,   721,   728,   730,   739,   183,   184,
     185,   746,   747,   186,   753,     2,   187,   188,   128,   755,
     768,   756,   189,   190,   757,   772,   777,   780,   558,   557,
     561,   423,   559,   463,   171,   560,   615,   309,   599,    72,
     302,   647,   191,   192,   193,   613,   194,   195,    61,    62,
       6,     7,     8,     9,    10,    11,    12,   196,   197,    15,
      16,   198,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
     199,   200,   201,   202,   203,   490,   204,   205,   206,   207,
     208,   209,   210,   211,   493,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    36,   225,
      98,   572,   652,   713,   577,   362,    99,   226,   227,   228,
     229,   230,   231,   285,   443,   664,     0,     0,     0,     0,
     232,   102,     2,     0,     0,    62,     3,     7,     8,     9,
      10,    11,     0,    13,    14,     0,     0,    17,     0,    19,
      20,     0,     0,     0,     0,     0,     0,    27,     0,     0,
       0,     0,     0,     0,     0,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,     1,     0,     0,
       0,     0,     0,     0,    80,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     2,     0,
       0,     0,     3,     0,     0,    36,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    37,     0,     0,
       0,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,     0,     0,     0,     0,     0,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,     0,
     183,   184,   185,     0,     0,   311,     0,     0,     0,   188,
     128,    36,     0,     0,   189,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    37,   191,   192,     0,     0,   194,   195,
       0,   175,   176,   177,   178,   179,   180,   181,   182,   312,
     313,     0,     0,   183,   184,   185,     0,     0,   311,     0,
       0,     0,   188,   128,     0,     0,     0,   189,   190,     0,
       0,     0,   199,   200,     0,     0,     0,     0,     0,     0,
       0,   207,     0,     0,     0,     2,     0,   191,   192,     0,
       0,   194,   195,     0,     0,     0,     0,     0,     0,   224,
       0,   225,   312,   313,     0,     0,     0,     0,     0,   226,
     227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,     0,   314,   668,   199,   200,   421,   422,     0,
      16,     0,    18,     0,   207,    21,    22,    23,    24,    25,
      26,     0,    28,    29,    30,    31,    32,    33,    34,    35,
       0,     0,   224,     0,   225,     0,     0,     0,     0,     0,
       0,     0,   226,   227,   228,   229,   230,   231,   175,   176,
     177,   178,   179,   180,   181,   182,   314,     0,     0,     0,
     183,   184,   185,     0,     0,   311,     0,     2,     0,   188,
     128,     0,     0,     0,   189,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,     0,     0,   194,   195,
      61,    62,     6,     7,     8,     9,    10,    11,    12,   196,
     197,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,   199,   200,     0,     0,     0,     0,     0,     0,
       0,   207,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
      36,   225,     0,     0,     0,     0,     0,     0,     0,   226,
     227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,     0,     0,   183,   184,   185,     0,     0,
     311,     0,     0,     0,   188,   128,     0,     0,     0,   189,
     190,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   191,
     192,     0,     0,   194,   195,     0,   175,   176,   177,   178,
     179,   180,   181,   182,   312,   313,     0,     0,   183,   184,
     185,     0,     0,   311,     0,     0,     0,   188,   128,     0,
       0,     0,   189,   190,     0,     0,     0,   199,   200,     0,
       0,     0,     0,     0,     0,     0,   207,     0,     0,     0,
       0,     0,   191,   192,     0,     0,   194,   195,     0,     0,
       0,     0,     0,     0,   224,     0,   225,   312,   313,     0,
       0,     0,     0,     0,   226,   227,   228,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   365,     0,     0,
     199,   200,     0,     0,     0,     0,     0,     0,     0,   207,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,     0,   225,
       0,     0,     0,     0,     0,     0,     0,   226,   227,   228,
     229,   230,   231,     0,     0,     0,     0,     0,     0,   374,
     649,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,     0,   183,   184,   185,     0,     0,   311,     0,
       2,     0,   188,   128,     0,     0,     0,   189,   190,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   191,   192,     0,
       0,   194,   195,     0,    62,     0,     7,     8,     9,    10,
      11,     0,   196,   197,     0,     0,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,   199,   200,     0,     0,     0,
       0,     0,     0,     0,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,     0,   225,     0,     0,     0,     0,     0,
       0,     0,   226,   227,   228,   229,   230,   231,   523,     0,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,     0,   183,   184,   185,     0,     0,   311,     0,     0,
       0,   188,   128,     0,     0,     0,   189,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,     0,     0,
     194,   195,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   312,   313,     0,     0,     0,     0,   583,     0,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
       0,   183,   184,   185,   199,   200,   311,     0,     0,     0,
     188,   128,     0,   207,     0,   189,   190,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,     0,   225,   524,   191,   192,     0,     0,   194,
     195,   226,   227,   228,   229,   230,   231,     0,     0,     0,
     312,   313,     0,     0,     0,     0,   374,     0,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,     0,
     183,   184,   185,   199,   200,   311,     0,     0,     0,   188,
     128,     0,   207,     0,   189,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,     0,   225,   584,   191,   192,     0,     0,   194,   195,
     226,   227,   228,   229,   230,   231,     0,     0,     0,   312,
     313,     0,     0,     0,     0,   527,     0,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,     0,   183,
     184,   185,   199,   200,   311,     0,     0,     0,   188,   128,
       0,   207,     0,   189,   190,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
       0,   225,     0,   191,   192,     0,     0,   194,   195,   226,
     227,   228,   229,   230,   231,     0,     0,     0,   312,   313,
       0,     0,     0,     0,   324,     0,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,     0,   183,   184,
     185,   199,   200,   311,     0,     0,     0,   188,   128,     0,
     207,     0,   189,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,     0,
     225,     0,   191,     0,     0,     0,   194,   195,   226,   227,
     228,   229,   230,   231,     0,     0,   511,     0,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,     0,
     183,   184,   185,     0,     0,   311,     0,     0,     0,   188,
     199,   200,     0,     0,     0,     0,     0,     0,     0,   207,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,     0,   225,
       0,     0,   325,     0,     0,     0,     0,   226,   227,   228,
     229,   230,   231,   175,   176,   177,   178,   179,   180,   181,
     182,   706,   707,   708,   709,   183,   184,   185,     0,     0,
     311,     0,   199,   200,   188,   128,     0,     0,     0,   189,
     190,   207,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   191,
     192,   342,     0,   194,   195,     0,   175,   176,   177,   178,
     179,   180,   181,   182,   312,   313,     0,     0,   183,   184,
     185,     0,     0,   311,     0,     0,     0,   188,   128,     0,
       0,     0,   189,   190,     0,     0,     0,   199,   200,     0,
       0,     0,     0,     0,     0,     0,   207,     0,     0,     0,
       0,     0,   191,   192,     0,     0,   194,   195,     0,     0,
       0,     0,     0,     0,   224,     0,   225,   312,   313,     0,
       0,     0,     0,     0,   226,   227,   228,   229,   230,   231,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
     199,   200,   183,   184,   185,     0,     0,   311,     0,   207,
       0,   188,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,     0,   225,
     627,     0,     0,     0,     0,     0,     0,   226,   227,   228,
     229,   230,   231,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,     0,     0,   183,   184,   185,     0,     0,
     311,     0,     0,     0,   188,   128,     0,     0,     0,   189,
     190,     0,     0,     0,   199,   200,     0,     0,     0,     0,
       0,     0,     0,   207,     0,     0,     0,     0,     0,   191,
     192,     0,     0,   194,   195,     0,     0,     0,     0,     0,
       0,     0,     0,   342,   312,   313,     0,     0,     0,     0,
       0,     0,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,     0,   183,   184,   185,   199,   200,   311,
       0,     0,     0,   188,   128,     0,   207,     0,   189,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,     0,   225,   686,   191,   192,
       0,     0,   194,   195,   226,   227,   228,   229,   230,   231,
       0,     0,     0,   312,   313,     0,     0,     0,     0,     0,
       0,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,     0,   183,   184,   185,   199,   200,   311,     0,
       0,     0,   188,   128,     0,   207,     0,   189,   190,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,     0,   225,   702,   191,   192,     0,
       0,   194,   195,   226,   227,   228,   229,   230,   231,     0,
       0,     0,   312,   313,     0,     0,     0,     0,     0,     0,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,     0,   183,   184,   185,   199,   200,   311,     0,     0,
       0,   188,   128,     0,   207,     0,   189,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,     0,   225,   704,   191,   192,     0,     0,
     194,   195,   226,   227,   228,   229,   230,   231,     0,     0,
       0,   312,   313,     0,     0,     0,     0,     0,     0,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
       0,   183,   184,   185,   199,   200,   311,     0,     0,     0,
     188,   128,     0,   207,     0,   189,   190,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,     0,   225,   749,   191,   192,     0,     0,   194,
     195,   226,   227,   228,   229,   230,   231,     0,     0,     0,
     312,   313,     0,     0,     0,     0,     0,     0,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,     0,
     183,   184,   185,   199,   200,   311,     0,     0,     0,   188,
     128,     0,   207,     0,   189,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,     0,   225,   764,   191,   192,     0,     0,   194,   195,
     226,   227,   228,   229,   230,   231,     0,     0,     0,   312,
     313,     0,     0,     0,     0,     0,     0,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,     0,   183,
     184,   185,   199,   200,   311,     0,     0,     0,   188,   128,
       0,   207,     0,   189,   190,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
       0,   225,   774,   191,   192,     0,     0,   194,   195,   226,
     227,   228,   229,   230,   231,     0,     0,     0,   312,   313,
       0,     0,     0,     0,     0,     0,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,     0,   183,   184,
     185,   199,   200,   311,     0,     0,     0,   188,   128,     0,
     207,     0,   189,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,     0,
     225,   778,   191,   192,     0,     0,   194,   195,   226,   227,
     228,   229,   230,   231,     0,     0,     0,   312,   313,     0,
       0,     0,     0,     0,     0,   175,   176,   177,   178,   179,
     180,   181,   182,     0,     0,     0,     0,   183,   184,   185,
     199,   200,   311,     0,     0,     0,   188,   128,     0,   207,
       0,   189,   190,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,     0,   225,
     785,   191,   192,     0,     0,   194,   195,   226,   227,   228,
     229,   230,   231,     0,     0,     0,   312,   313,     0,     0,
       0,     0,     0,     0,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,     0,   183,   184,   185,   199,
     200,   311,     0,     0,     0,   188,   128,     0,   207,     0,
     189,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,     0,   225,   789,
     191,   192,     0,     0,   194,   195,   226,   227,   228,   229,
     230,   231,     0,     0,     0,   312,   313,     0,     0,     0,
       0,     0,     0,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,     0,     0,   183,   184,   185,   199,   200,
     311,     0,     0,     0,   188,   128,     0,   207,     0,   189,
     190,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,     0,   225,     0,   191,
       0,     0,     0,   194,   195,   226,   227,   228,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,     0,   183,   184,   185,   199,   200,   311,
       0,     0,     0,   188,   128,     0,   207,     0,   189,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,     0,   225,     0,   191,   606,
       0,     0,   194,   195,   226,   227,   228,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,     0,   183,   184,   185,   199,   200,   311,     0,
       0,     0,   188,   128,     0,   207,     0,   189,   190,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,     0,   225,     0,   191,   676,     0,
       0,   194,   195,   226,   227,   228,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,     0,   183,   184,   185,   199,   200,   311,     0,     0,
       0,   188,   128,     0,   207,     0,   189,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,     0,   342,     0,   191,     0,     0,     0,
     194,   195,   226,   227,   228,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
       0,   183,   184,   185,   199,   200,   311,     0,     0,     0,
     188,   128,     0,   207,     0,   189,   190,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,     0,   345,     0,   191,     0,     0,     0,   194,
     195,   226,   227,   228,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   602,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   199,   200,     0,     0,     0,     0,     0,
       0,    76,   207,     2,     0,     0,    77,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,     0,   225,     0,     0,     0,     0,     0,     0,     0,
     226,   227,   228,   229,   230,   231,    61,    62,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,   602,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     2,
       0,     0,     0,     0,     0,     0,    36,   476,   603,   477,
       0,     0,     0,     0,     0,    79,    80,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    61,    62,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,     0,   183,   184,   185,     0,
       0,   311,     0,     0,     0,   188,     0,     0,     0,     0,
       0,     0,    36,   515,   603,   477,     0,     0,     0,     0,
       0,    79,    80,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,     0,     0,   183,   184,   185,     0,     0,
     311,     0,     0,     0,   188,     0,     0,     0,   444,   445,
     446,   447,   448,   449,   450,   451,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   452,     0,     2,   199,   200,
       0,     0,     0,     0,     0,     0,     0,   207,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   342,     0,   358,
       0,     0,   359,     0,     0,     0,     2,   199,   200,   421,
     422,     0,    16,     0,    18,     0,   207,    21,    22,    23,
      24,    25,    26,     0,    28,    29,    30,    31,    32,    33,
      34,    35,     0,     0,     0,     0,   342,     2,   682,     0,
      62,   683,     7,     8,     9,    10,    11,     0,    13,    14,
       0,     0,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    62,     0,     7,     8,     9,    10,    11,     2,    13,
      14,     0,     0,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,     0,     0,     0,     0,     0,     0,     0,     2,
       0,     0,    62,     0,     7,     8,     9,    10,    11,     0,
      13,    14,     0,   162,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    62,     0,     7,     8,     9,    10,    11,
       0,    13,    14,     0,   170,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,     0,   318,     0,     0,     0,     0,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,     0,   183,   184,   185,   333,     2,   311,     0,     0,
       0,   188,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   339,     0,     0,    61,
      62,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,   456,     0,     0,   199,   200,     0,     0,     0,     0,
       0,     0,     0,   207,     0,     0,     0,     0,     0,     0,
       0,     0,     2,     0,     0,     0,     0,     0,     0,    36,
       0,   319,     0,   342,     0,   762,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    61,    62,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,   661,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     2,     0,
       0,     0,     0,     0,     0,    36,     0,   457,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    61,    62,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,   602,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,     0,     0,     0,     0,     0,
       0,    36,     0,   662,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    61,    62,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,     2,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,     0,   674,
       0,     0,    61,    62,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,     0,     0,     2,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,     0,     0,     0,     0,     0,    63,    61,
      62,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,     0,     0,     2,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    36,
       0,     0,     0,     0,     0,    90,    61,    62,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,     2,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,     0,     0,
       0,     0,    62,     0,     7,     8,     9,    10,    11,     0,
      13,    14,     0,     0,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35
};

static const yytype_int16 yycheck[] =
{
     154,     0,   207,    67,     3,   154,   156,    86,    87,    90,
      80,   201,   300,   253,   320,   163,    41,   390,    20,    20,
      22,   169,    20,    20,   206,    21,    55,    64,    92,    58,
     120,    95,   228,   229,   230,   231,   218,   320,   372,   137,
      39,    40,   157,    42,    43,    44,     0,   137,    80,    20,
     290,    50,    51,   193,    25,   120,   166,   479,   480,    20,
      92,   171,    38,    95,    25,   120,   439,   138,   120,    20,
     376,   120,   137,    21,    25,   120,   216,   225,   260,   157,
     150,   120,   137,   265,    20,   225,   201,   139,   116,    25,
     139,    20,   137,   376,   516,   517,    25,    51,   120,   163,
     139,   100,   166,    33,    34,   169,   121,   171,   120,   299,
     116,   189,   190,   191,   125,   120,    20,   139,   150,   130,
     131,   120,   138,   201,   120,   137,   155,   152,    20,   502,
      22,   163,   137,    25,   166,   469,   138,   169,   139,   171,
     138,   291,   139,   168,   136,   116,   138,   172,   226,   227,
     228,   229,   230,   231,   359,   116,    25,   156,   134,   117,
     314,   225,   120,   124,   125,   116,   138,   118,   373,   117,
     476,   353,   120,   124,   125,   120,   137,   131,   132,   467,
     116,   138,   118,    92,   299,   117,    95,   116,   120,   253,
     135,   121,   122,   225,   348,   124,   125,   345,    20,    28,
      29,    30,   342,   138,   358,   345,   402,   403,   404,   515,
     409,   410,   411,   412,   354,   355,   356,   116,     3,   118,
       5,   299,     7,   116,     9,   118,   290,   367,   116,   369,
     294,   124,   125,   387,   259,    20,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   388,   286,
     320,   332,   117,   626,   163,   120,   438,   166,    18,    19,
     169,   634,   171,   139,     3,   638,     5,     3,     7,     5,
       9,     7,   426,     9,   121,    28,    29,    30,   137,   138,
     420,   345,    21,   117,   116,   439,   120,   477,   117,   118,
     117,   120,   291,   120,   123,   320,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,   376,    28,    29,    30,
      20,   493,   494,   345,   137,   138,   225,    28,    29,    30,
      28,    29,    30,   519,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,    20,   117,    22,    20,   120,    25,   502,   589,
     117,   117,   725,   120,   120,    20,   117,   421,   422,   120,
     424,   442,   477,   116,   120,   118,   122,    28,    29,    30,
     123,   117,    18,    19,   120,   748,   440,    69,    28,    29,
      30,   126,   127,    75,    76,    77,    31,    32,   469,    81,
      82,    83,    84,   136,   767,   116,   122,   118,   771,   477,
     479,   480,   123,    35,    36,   116,   476,   118,   116,   782,
     118,   565,   123,   117,   787,   123,   120,   117,   117,   624,
     120,   120,   612,   120,   117,   122,   566,   120,   119,   120,
     117,   571,   572,   120,   119,   120,   345,   587,   620,   621,
     622,   519,   116,    20,   118,   515,   600,   629,   136,   631,
     117,   600,   138,   120,   608,   116,   116,   118,   118,   608,
     117,   611,   123,   488,   117,   121,   116,   120,   118,   407,
     408,   625,   626,   123,   405,   406,   117,   476,   683,   120,
     634,   119,   120,   623,   638,   484,   117,   122,   642,   120,
     630,   135,    28,    29,    30,   635,   116,   612,   118,   653,
     122,    28,    29,    30,   137,    22,   116,    28,    29,    30,
      27,   651,   652,    50,   117,    50,   515,   120,   658,   138,
     702,   726,   704,   117,   117,   589,   120,   120,   682,   135,
     712,   646,   714,   715,   612,   117,    20,   117,   120,   721,
     120,   117,   747,   117,   120,   699,   120,    64,   730,   116,
     699,   116,    69,   116,   736,   124,   738,   711,    75,    76,
      77,   119,   120,   768,    81,    82,    83,    84,   646,   413,
     414,   725,   777,   727,   117,   117,   137,   120,   120,   761,
     116,   137,   118,   117,   116,   739,   120,   123,   587,   116,
     116,   118,   432,   433,   748,   116,   123,   118,   117,    22,
     116,   120,   123,   117,   117,   122,   120,   120,   762,   137,
     132,   117,   611,   767,   120,   116,     1,   771,     3,     4,
       5,     6,     7,     8,     9,    10,   432,   433,   782,   116,
      15,    16,    17,   787,   116,    20,   133,    22,    23,    24,
      25,    37,   116,   116,    29,    30,    69,   116,   116,    72,
      73,    74,    75,    76,    77,   116,    79,    80,    81,    82,
      83,    84,    85,    86,    49,    50,    51,   116,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,   135,    93,    94,
      95,    96,    97,    98,    99,   100,   116,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   136,    22,   136,   116,   139,   136,    27,   124,
     125,   126,   127,   128,   129,   139,   137,   117,   120,   135,
     119,   119,   137,   138,   139,     1,    94,     3,     4,     5,
       6,     7,     8,     9,    10,    94,   137,    21,   117,    15,
      16,    17,   117,    20,    20,    64,    22,    23,    24,    25,
      69,    20,    20,    29,    30,   116,    75,    76,    77,   137,
     117,   117,    81,    82,    83,    84,   136,   122,   117,   117,
     116,   116,   119,    49,    50,    51,   117,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,   117,    93,    94,    95,
      96,    97,    98,    99,   100,   136,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,    52,   117,   117,   137,   137,    21,   117,   124,   125,
     126,   127,   128,   129,   120,   117,   117,   137,   117,   119,
     117,   137,   138,   139,     1,   119,     3,     4,     5,     6,
       7,     8,     9,    10,    92,   122,    92,   101,    15,    16,
      17,   137,   119,    20,   122,    22,    23,    24,    25,   137,
     119,   137,    29,    30,   137,   122,   119,   122,   416,   415,
     419,   253,   417,   297,    95,   418,   488,   152,   471,    34,
     146,   565,    49,    50,    51,   484,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,   345,    93,    94,    95,    96,
      97,    98,    99,   100,   351,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
       0,   433,   572,   655,   435,   213,    51,   124,   125,   126,
     127,   128,   129,   111,   288,   589,    -1,    -1,    -1,    -1,
     137,   138,    22,    -1,    -1,    56,    26,    58,    59,    60,
      61,    62,    -1,    64,    65,    -1,    -1,    68,    -1,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,     1,    -1,    -1,
      -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    26,    -1,    -1,   115,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,    -1,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,
      25,   115,    -1,    -1,    29,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   137,    49,    50,    -1,    -1,    53,    54,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    64,
      65,    -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,
      -1,    -1,    24,    25,    -1,    -1,    -1,    29,    30,    -1,
      -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    -1,    -1,    -1,    22,    -1,    49,    50,    -1,
      -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,    64,    65,    -1,    -1,    -1,    -1,    -1,   124,
     125,   126,   127,   128,   129,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   138,   139,    87,    88,    64,    65,    -1,
      67,    -1,    69,    -1,    96,    72,    73,    74,    75,    76,
      77,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   124,   125,   126,   127,   128,   129,     3,     4,
       5,     6,     7,     8,     9,    10,   138,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    20,    -1,    22,    -1,    24,
      25,    -1,    -1,    -1,    29,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
     115,   116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   124,
     125,   126,   127,   128,   129,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   137,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,
      20,    -1,    -1,    -1,    24,    25,    -1,    -1,    -1,    29,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      50,    -1,    -1,    53,    54,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    64,    65,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,    -1,    29,    30,    -1,    -1,    -1,    87,    88,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,   116,    64,    65,    -1,
      -1,    -1,    -1,    -1,   124,   125,   126,   127,   128,   129,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,    -1,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   124,   125,   126,
     127,   128,   129,    -1,    -1,    -1,    -1,    -1,    -1,     1,
     137,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,
      22,    -1,    24,    25,    -1,    -1,    -1,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,
      -1,    53,    54,    -1,    56,    -1,    58,    59,    60,    61,
      62,    -1,    64,    65,    -1,    -1,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   124,   125,   126,   127,   128,   129,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,
      53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    65,    -1,    -1,    -1,    -1,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    17,    87,    88,    20,    -1,    -1,    -1,
      24,    25,    -1,    96,    -1,    29,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,   116,   117,    49,    50,    -1,    -1,    53,
      54,   124,   125,   126,   127,   128,   129,    -1,    -1,    -1,
      64,    65,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    17,    87,    88,    20,    -1,    -1,    -1,    24,
      25,    -1,    96,    -1,    29,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,   117,    49,    50,    -1,    -1,    53,    54,
     124,   125,   126,   127,   128,   129,    -1,    -1,    -1,    64,
      65,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    17,    87,    88,    20,    -1,    -1,    -1,    24,    25,
      -1,    96,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,    -1,    49,    50,    -1,    -1,    53,    54,   124,
     125,   126,   127,   128,   129,    -1,    -1,    -1,    64,    65,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    87,    88,    20,    -1,    -1,    -1,    24,    25,    -1,
      96,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,    -1,    49,    -1,    -1,    -1,    53,    54,   124,   125,
     126,   127,   128,   129,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
      -1,    -1,   119,    -1,    -1,    -1,    -1,   124,   125,   126,
     127,   128,   129,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    -1,
      20,    -1,    87,    88,    24,    25,    -1,    -1,    -1,    29,
      30,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      50,   116,    -1,    53,    54,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    64,    65,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,    -1,    29,    30,    -1,    -1,    -1,    87,    88,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,   116,    64,    65,    -1,
      -1,    -1,    -1,    -1,   124,   125,   126,   127,   128,   129,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      87,    88,    15,    16,    17,    -1,    -1,    20,    -1,    96,
      -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
     117,    -1,    -1,    -1,    -1,    -1,    -1,   124,   125,   126,
     127,   128,   129,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,
      20,    -1,    -1,    -1,    24,    25,    -1,    -1,    -1,    29,
      30,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    49,
      50,    -1,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   116,    64,    65,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    87,    88,    20,
      -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,   116,   117,    49,    50,
      -1,    -1,    53,    54,   124,   125,   126,   127,   128,   129,
      -1,    -1,    -1,    64,    65,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    17,    87,    88,    20,    -1,
      -1,    -1,    24,    25,    -1,    96,    -1,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,   117,    49,    50,    -1,
      -1,    53,    54,   124,   125,   126,   127,   128,   129,    -1,
      -1,    -1,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    87,    88,    20,    -1,    -1,
      -1,    24,    25,    -1,    96,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,   117,    49,    50,    -1,    -1,
      53,    54,   124,   125,   126,   127,   128,   129,    -1,    -1,
      -1,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    17,    87,    88,    20,    -1,    -1,    -1,
      24,    25,    -1,    96,    -1,    29,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,   116,   117,    49,    50,    -1,    -1,    53,
      54,   124,   125,   126,   127,   128,   129,    -1,    -1,    -1,
      64,    65,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    17,    87,    88,    20,    -1,    -1,    -1,    24,
      25,    -1,    96,    -1,    29,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,   117,    49,    50,    -1,    -1,    53,    54,
     124,   125,   126,   127,   128,   129,    -1,    -1,    -1,    64,
      65,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    17,    87,    88,    20,    -1,    -1,    -1,    24,    25,
      -1,    96,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,   117,    49,    50,    -1,    -1,    53,    54,   124,
     125,   126,   127,   128,   129,    -1,    -1,    -1,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    87,    88,    20,    -1,    -1,    -1,    24,    25,    -1,
      96,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,   117,    49,    50,    -1,    -1,    53,    54,   124,   125,
     126,   127,   128,   129,    -1,    -1,    -1,    64,    65,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,
      87,    88,    20,    -1,    -1,    -1,    24,    25,    -1,    96,
      -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
     117,    49,    50,    -1,    -1,    53,    54,   124,   125,   126,
     127,   128,   129,    -1,    -1,    -1,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,    87,
      88,    20,    -1,    -1,    -1,    24,    25,    -1,    96,    -1,
      29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,   117,
      49,    50,    -1,    -1,    53,    54,   124,   125,   126,   127,
     128,   129,    -1,    -1,    -1,    64,    65,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    17,    87,    88,
      20,    -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    49,
      -1,    -1,    -1,    53,    54,   124,   125,   126,   127,   128,
     129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    87,    88,    20,
      -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    49,   119,
      -1,    -1,    53,    54,   124,   125,   126,   127,   128,   129,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    17,    87,    88,    20,    -1,
      -1,    -1,    24,    25,    -1,    96,    -1,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,    -1,    49,   119,    -1,
      -1,    53,    54,   124,   125,   126,   127,   128,   129,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    87,    88,    20,    -1,    -1,
      -1,    24,    25,    -1,    96,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,    -1,    49,    -1,    -1,    -1,
      53,    54,   124,   125,   126,   127,   128,   129,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    17,    87,    88,    20,    -1,    -1,    -1,
      24,    25,    -1,    96,    -1,    29,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,   116,    -1,    49,    -1,    -1,    -1,    53,
      54,   124,   125,   126,   127,   128,   129,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    96,    22,    -1,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     124,   125,   126,   127,   128,   129,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,     1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    -1,    -1,    -1,   115,   116,   117,   118,
      -1,    -1,    -1,    -1,    -1,   124,   125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    20,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,
      -1,    -1,   115,   116,   117,   118,    -1,    -1,    -1,    -1,
      -1,   124,   125,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,
      20,    -1,    -1,    -1,    24,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    -1,    22,    87,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,   118,
      -1,    -1,   121,    -1,    -1,    -1,    22,    87,    88,    64,
      65,    -1,    67,    -1,    69,    -1,    96,    72,    73,    74,
      75,    76,    77,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    -1,    -1,    -1,   116,    22,   118,    -1,
      56,   121,    58,    59,    60,    61,    62,    -1,    64,    65,
      -1,    -1,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    56,    -1,    58,    59,    60,    61,    62,    22,    64,
      65,    -1,    -1,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    56,    -1,    58,    59,    60,    61,    62,    -1,
      64,    65,    -1,   139,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    56,    -1,    58,    59,    60,    61,    62,
      -1,    64,    65,    -1,   139,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,     1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,   139,    22,    20,    -1,    -1,
      -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,     1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,   115,
      -1,   117,    -1,   116,    -1,   118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    -1,   115,    -1,   117,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,
      -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    22,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,   117,
      -1,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    -1,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   115,    -1,    -1,    -1,    -1,    -1,   121,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,
      -1,    -1,    -1,    -1,    -1,   121,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    58,    59,    60,    61,    62,    -1,
      64,    65,    -1,    -1,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    22,    26,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,   115,   137,   170,   171,
     174,   175,   176,   182,   183,   185,   188,   189,   190,   197,
     200,   251,   252,   253,   262,   263,   265,   270,   271,   272,
     137,    55,    56,   121,   175,    18,    19,   138,   116,   121,
      20,   138,   196,   116,   175,   175,    20,    25,   116,   124,
     125,   137,   180,   181,   202,   204,   205,   206,   175,   175,
     121,   175,   138,    20,    22,   138,   187,   175,     0,   252,
     264,   137,   138,   219,   221,   137,   221,    18,    19,    22,
      27,    64,    69,    75,    76,    77,    81,    82,    83,    84,
     122,   255,   256,   257,   258,   259,   260,   261,    25,   268,
     269,   138,   138,   183,   184,    20,   172,   173,     3,     5,
       7,     9,   203,   196,   198,   199,   138,   116,   202,   200,
     201,   205,   120,   137,   136,   254,   116,   118,   204,   204,
      20,   203,   139,   183,   185,   186,   191,   192,   193,   200,
     139,   191,   175,   139,     1,     3,     4,     5,     6,     7,
       8,     9,    10,    15,    16,    17,    20,    23,    24,    29,
      30,    49,    50,    51,    53,    54,    64,    65,    68,    87,
      88,    89,    90,    91,    93,    94,    95,    96,    97,    98,
      99,   100,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   116,   124,   125,   126,   127,
     128,   129,   137,   142,   143,   144,   145,   146,   147,   148,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   165,   166,   167,   169,   170,   175,
     215,   216,   217,   218,   221,   222,   223,   224,   227,   228,
     229,   230,   232,   237,   239,   244,   245,   246,   247,   248,
     249,   250,   269,    20,    20,   256,   175,    20,   120,   122,
     121,   116,   170,   170,   120,   139,   117,   120,   122,   136,
     120,   139,   198,    20,   177,   178,   117,   200,   205,   181,
     202,    20,    64,    65,   138,   166,   213,   221,     1,   117,
     175,   207,   208,   209,     1,   119,   150,   162,   168,   122,
     122,   193,   121,   139,   192,   194,   195,   202,   193,   139,
     202,   137,   116,   150,   150,   116,   150,   167,   116,    50,
      50,   138,   168,   135,   116,   116,   116,   216,   118,   121,
     145,    20,   244,   137,   137,   137,   167,   116,   216,   116,
     137,   116,   116,   116,     1,   167,   193,   210,   150,   150,
     151,   151,   151,   151,    28,    29,    30,   116,   118,   123,
     116,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,   136,   125,   130,   131,   126,   127,    31,    32,    33,
      34,   121,   122,    35,    36,   124,   132,   133,    37,    38,
     134,    64,    65,   164,   171,   183,   120,   137,   216,   139,
     216,   220,   116,   116,   116,   116,   116,   116,   135,   116,
     136,   269,   136,   260,     3,     4,     5,     6,     7,     8,
       9,    10,    20,   164,   266,   267,     1,   117,   207,   139,
     139,   183,   137,   172,   168,   139,   199,   120,   139,   116,
     117,   120,   213,   214,   117,   120,   116,   118,   202,   205,
     206,   211,   212,   117,   120,   119,   119,   203,   120,   137,
     210,   137,   166,   222,   135,   216,   167,   167,   167,    94,
     166,   145,   116,   137,   137,   167,    94,   167,    21,   141,
     141,     1,   145,   117,   117,   116,   205,   206,   211,   117,
      20,    22,    25,     1,   117,   149,   166,     1,   167,    20,
      22,    25,   149,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   151,   151,   151,   152,   152,   153,
     153,   154,   154,   154,   154,   155,   155,   156,   157,   158,
     159,   160,   167,   183,   183,   116,   118,   183,   166,   169,
     223,   226,   226,    20,   231,   235,   236,   236,    20,   233,
      20,   238,   216,     1,   117,   149,   183,   116,   203,   120,
     122,   117,   137,   117,   139,   141,   179,   203,   117,   178,
     120,   139,     1,   117,   207,   211,   119,   168,   136,   212,
     212,   116,   118,   209,   122,   195,   117,   117,   139,   216,
     117,   117,   117,   116,   119,   120,   116,   117,   149,   117,
     116,   117,    21,   117,   120,   120,   117,   117,   120,   151,
     117,   117,   120,   119,   119,   117,   135,   214,   167,   137,
     167,   225,   225,   136,   117,   120,   117,   117,    52,   117,
     117,     1,   117,   207,   266,   137,   137,   117,   139,   213,
     117,   117,   119,   213,   117,   207,   119,   168,   216,   216,
     216,   167,   118,   121,   145,   166,   117,   149,   117,   216,
     167,   216,   137,   149,   167,   149,   166,   162,   117,   120,
     119,   137,   117,   167,   117,   167,    11,    12,    13,    14,
     166,   234,   240,   235,   241,   242,   167,   117,   117,   117,
     119,    92,   117,   166,   145,   116,   119,   120,   122,   117,
      92,   117,   117,   117,   117,   216,   117,   216,   117,   101,
     166,   216,   216,   216,   117,   216,   137,   119,   116,   117,
     149,   145,   166,   122,   216,   137,   137,   137,   216,   216,
     166,   243,   118,   145,   117,   149,   117,   116,   119,   216,
     166,   116,   122,   117,   117,   149,   145,   119,   117,   149,
     122,   117,   116,   145,   117,   117,   149,   116,   117,   117,
     149,   117
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   140,   141,   141,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   143,   143,   143,   143,   143,   143,   143,   143,   143,
     143,   143,   143,   143,   143,   143,   143,   144,   144,   144,
     145,   145,   145,   145,   145,   145,   145,   145,   145,   145,
     145,   145,   146,   147,   148,   148,   148,   148,   148,   148,
     148,   149,   149,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   151,   151,   152,
     152,   152,   152,   153,   153,   153,   154,   154,   154,   155,
     155,   155,   155,   155,   156,   156,   156,   157,   157,   158,
     158,   159,   159,   160,   160,   161,   161,   162,   162,   163,
     163,   163,   164,   164,   164,   164,   165,   165,   165,   165,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   167,   167,   168,   169,   170,   170,   171,   172,
     173,   173,   174,   175,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   175,   175,   175,   175,   176,   177,   177,
     178,   178,   179,   179,   180,   180,   181,   181,   182,   182,
     182,   182,   182,   183,   183,   183,   183,   184,   184,   185,
     185,   185,   185,   185,   185,   185,   185,   185,   185,   185,
     185,   185,   186,   187,   187,   188,   189,   189,   189,   189,
     189,   190,   191,   191,   192,   193,   193,   193,   193,   194,
     194,   195,   196,   197,   197,   197,   197,   197,   198,   198,
     199,   199,   200,   200,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   200,   201,   201,   202,   202,   202,   203,
     203,   203,   203,   204,   204,   204,   204,   204,   204,   204,
     204,   204,   205,   205,   205,   205,   206,   207,   208,   208,
     208,   209,   209,   209,   209,   210,   210,   211,   211,   211,
     211,   211,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   213,   213,   213,   214,   214,   215,   216,   216,   217,
     217,   217,   217,   217,   217,   217,   217,   217,   217,   217,
     217,   217,   218,   218,   218,   219,   220,   221,   221,   222,
     222,   223,   223,   224,   224,   224,   224,   224,   225,   225,
     226,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     234,   234,   234,   235,   235,   236,   236,   237,   238,   239,
     239,   239,   239,   239,   239,   239,   239,   240,   239,   241,
     239,   242,   239,   243,   239,   244,   245,   245,   245,   245,
     245,   246,   247,   248,   249,   249,   250,   251,   251,   251,
     252,   252,   252,   252,   252,   252,   252,   252,   252,   254,
     253,   255,   255,   256,   256,   256,   256,   256,   256,   256,
     256,   257,   257,   258,   258,   259,   260,   260,   260,   261,
     261,   262,   264,   263,   265,   265,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   267,   267,   268,   269,
     269,   270,   270,   270,   271,   271,   271,   272,   272
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     5,     4,     8,     7,    10,     9,    11,    10,    12,
      11,    14,    13,     7,     6,    10,     9,     4,     6,     4,
       1,     4,     4,     1,     3,     3,     3,     3,     3,     3,
       2,     2,     1,     4,     1,     3,     4,     4,     3,     4,
       4,     1,     3,     1,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     4,     4,     1,     4,     1,
       3,     3,     3,     1,     3,     3,     1,     3,     3,     1,
       3,     3,     3,     3,     1,     3,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     5,     1,
       2,     2,     1,     2,     2,     2,     1,     2,     5,     5,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     3,     1,     1,     2,     3,     4,     1,
       1,     3,     4,     1,     2,     1,     2,     1,     2,     1,
       4,     4,     2,     1,     2,     1,     2,     6,     1,     3,
       1,     4,     1,     1,     1,     3,     1,     3,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     1,     1,     2,     1,     4,     4,     3,
       3,     1,     1,     2,     3,     2,     1,     1,     2,     1,
       3,     1,     1,     4,     5,     5,     6,     2,     1,     3,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     3,     4,     3,     4,     4,
       3,     4,     1,     2,     2,     3,     1,     1,     1,     3,
       2,     2,     4,     2,     1,     1,     2,     1,     1,     2,
       1,     2,     3,     2,     3,     3,     4,     2,     3,     3,
       4,     1,     3,     4,     1,     3,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     4,     3,     1,     1,     2,     3,     1,
       2,     1,     2,     5,     7,     5,     7,     5,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     4,     1,     3,     1,     1,     5,
       5,     7,     7,     6,     7,     6,     7,     0,     6,     0,
       6,     0,     6,     0,     8,     1,     3,     2,     2,     2,
       3,     2,     3,     4,     5,     7,     7,     1,     2,     2,
       1,     1,     1,     1,     5,     5,     5,     1,     1,     0,
       4,     2,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     4,     2,     1,     1,     1,     1,
       3,     4,     0,     4,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     4,
       1,     7,     6,     7,     8,     7,     8,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_TOKEN_FLOAT16_CONSTANT: /* TOKEN_FLOAT16_CONSTANT  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2883 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_IDENTIFIER: /* TOKEN_IDENTIFIER  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2889 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_STRING_LITERAL: /* TOKEN_STRING_LITERAL  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2895 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_TYPE_NAME: /* TOKEN_TYPE_NAME  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2901 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_TEMPLATE_NAME: /* TOKEN_TEMPLATE_NAME  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2907 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_INTRINSIC_CALL: /* TOKEN_INTRINSIC_CALL  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2913 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_string_constant: /* string_constant  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2919 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_intrinsic_name: /* intrinsic_name  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2925 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* string_constant: TOKEN_STRING_LITERAL  */
#line 301 "src/parse.yy"
    {
        (yyval.stringVal) = new std::string(*(yyvsp[0].stringVal));
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 3226 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 3: /* string_constant: string_constant TOKEN_STRING_LITERAL  */
#line 306 "src/parse.yy"
    {
        std::string *p_str_cst = new std::string();
        p_str_cst->append(*(yyvsp[-1].stringVal));
        p_str_cst->append(*(yyvsp[0].stringVal));
        (yyval.stringVal) = p_str_cst;
        // Allocated in lStringConst
        lCleanUpString((yyvsp[-1].stringVal));
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 3240 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 4: /* primary_expression: TOKEN_IDENTIFIER  */
#line 318 "src/parse.yy"
                       {
        const char *name = (yyvsp[0].stringVal)->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        (yyval.expr) = nullptr;
        if (s)
            (yyval.expr) = new SymbolExpr(s, (yylsp[0]));
        else {
            std::vector<Symbol *> funs;
            m->symbolTable->LookupFunction(name, &funs);
            if (funs.size() > 0)
                (yyval.expr) = new FunctionSymbolExpr(name, funs, (yylsp[0]));
        }
        if ((yyval.expr) == nullptr) {
            std::vector<std::string> alternates =
                m->symbolTable->ClosestVariableOrFunctionMatch(name);
            std::string alts = lGetAlternates(alternates);
            Error((yylsp[0]), "Undeclared symbol \"%s\".%s", name, alts.c_str());
        }
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 3265 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 5: /* primary_expression: TOKEN_INT8_CONSTANT  */
#line 338 "src/parse.yy"
                          {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0]));
    }
#line 3274 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 6: /* primary_expression: TOKEN_UINT8_CONSTANT  */
#line 342 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0]));
    }
#line 3283 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 7: /* primary_expression: TOKEN_INT16_CONSTANT  */
#line 346 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0]));
    }
#line 3292 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 8: /* primary_expression: TOKEN_UINT16_CONSTANT  */
#line 350 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0]));
    }
#line 3301 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 9: /* primary_expression: TOKEN_INT32_CONSTANT  */
#line 354 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 3310 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 10: /* primary_expression: TOKEN_UINT32_CONSTANT  */
#line 358 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 3319 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 11: /* primary_expression: TOKEN_INT64_CONSTANT  */
#line 362 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 3328 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 12: /* primary_expression: TOKEN_UINT64_CONSTANT  */
#line 366 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 3337 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 13: /* primary_expression: TOKEN_FLOAT16_CONSTANT  */
#line 370 "src/parse.yy"
                             {
         std::string sval = *(yyvsp[0].stringVal);
         lCleanUpString((yyvsp[0].stringVal));
         llvm::Type *hType = llvm::Type::getHalfTy(*g->ctx);
         const llvm::fltSemantics &FS = hType->getFltSemantics();
         llvm::APFloat f16(FS, sval);
         (yyval.expr) = new ConstExpr(AtomicType::UniformFloat16->GetAsConstType(),
                           f16, (yylsp[0]));
    }
#line 3351 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 14: /* primary_expression: TOKEN_FLOAT_CONSTANT  */
#line 379 "src/parse.yy"
                           {
        llvm::APFloat f(yylval.floatVal);
        (yyval.expr) = new ConstExpr(AtomicType::UniformFloat->GetAsConstType(),
                           f, (yylsp[0]));
    }
#line 3361 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 15: /* primary_expression: TOKEN_DOUBLE_CONSTANT  */
#line 384 "src/parse.yy"
                            {
        llvm::APFloat d(yylval.doubleVal);
        (yyval.expr) = new ConstExpr(AtomicType::UniformDouble->GetAsConstType(),
                           d, (yylsp[0]));
    }
#line 3371 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 16: /* primary_expression: TOKEN_TRUE  */
#line 389 "src/parse.yy"
                 {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), true, (yylsp[0]));
    }
#line 3379 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 17: /* primary_expression: TOKEN_FALSE  */
#line 392 "src/parse.yy"
                  {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), false, (yylsp[0]));
    }
#line 3387 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 18: /* primary_expression: TOKEN_NULL  */
#line 395 "src/parse.yy"
                 {
        (yyval.expr) = new NullPointerExpr((yylsp[0]));
    }
#line 3395 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 19: /* primary_expression: '(' expression ')'  */
#line 400 "src/parse.yy"
                         { (yyval.expr) = (yyvsp[-1].expr); }
#line 3401 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 20: /* primary_expression: '(' error ')'  */
#line 401 "src/parse.yy"
                    { (yyval.expr) = nullptr; }
#line 3407 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 21: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' argument_expression_list ')'  */
#line 406 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]), (yylsp[0])), true, launchCount);
      }
#line 3417 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 22: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' ')'  */
#line 412 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-1]),(yylsp[0]))), Union((yylsp[-2]), (yylsp[0])), true, launchCount);
       }
#line 3427 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 23: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 419 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3437 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 24: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 425 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3447 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 25: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 432 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-7].expr), (yyvsp[-5].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3457 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 26: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 438 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-6].expr), (yyvsp[-4].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3467 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 27: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 444 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3477 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 28: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 450 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3487 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 29: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 457 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-9].expr), (yyvsp[-7].expr), (yyvsp[-5].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3496 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 30: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 462 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3505 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 31: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 467 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), (yyvsp[-11].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3514 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 32: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 472 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), (yyvsp[-10].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3523 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 33: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 479 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 3533 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 34: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' ')' '>'  */
#line 485 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 3543 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 35: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 491 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 3553 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 36: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' ')' '>'  */
#line 497 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 3563 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 37: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' postfix_expression ')'  */
#line 506 "src/parse.yy"
      {
          (yyval.expr) = new FunctionCallExpr((yyvsp[-1].expr), new ExprList((yylsp[0])), Union((yylsp[-3]),(yylsp[0])), false, nullptr, true);
      }
#line 3571 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 38: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' postfix_expression ',' argument_expression_list ')'  */
#line 510 "src/parse.yy"
      {
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-5]),(yylsp[0])), false, nullptr, true);
      }
#line 3579 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 39: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' error ')'  */
#line 514 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 3585 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 41: /* postfix_expression: postfix_expression '[' expression ']'  */
#line 520 "src/parse.yy"
      { (yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].expr), Union((yylsp[-3]),(yylsp[0]))); }
#line 3591 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 42: /* postfix_expression: postfix_expression '[' error ']'  */
#line 522 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 3597 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 44: /* postfix_expression: postfix_expression '.' TOKEN_IDENTIFIER  */
#line 525 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3606 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 45: /* postfix_expression: postfix_expression '.' TOKEN_TYPE_NAME  */
#line 532 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3615 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 46: /* postfix_expression: postfix_expression '.' TOKEN_TEMPLATE_NAME  */
#line 537 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3624 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 47: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_IDENTIFIER  */
#line 542 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3633 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 48: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_TYPE_NAME  */
#line 549 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3642 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 49: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_TEMPLATE_NAME  */
#line 554 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3651 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 50: /* postfix_expression: postfix_expression TOKEN_INC_OP  */
#line 559 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostInc, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3657 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 51: /* postfix_expression: postfix_expression TOKEN_DEC_OP  */
#line 561 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostDec, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3663 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 52: /* intrinsic_name: TOKEN_INTRINSIC_CALL  */
#line 566 "src/parse.yy"
      {
          (yyval.stringVal) = (yyvsp[0].stringVal);
      }
#line 3671 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 53: /* intrincall_expression: intrinsic_name '(' argument_expression_list ')'  */
#line 573 "src/parse.yy"
      {
          std::string *name = (yyvsp[-3].stringVal);
          name->erase(0, 1);
          Symbol* sym = m->AddLLVMIntrinsicDecl(*name, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          const char *fname = name->c_str();
          const std::vector<Symbol *> funcs{sym};
          FunctionSymbolExpr *fSym = nullptr;
          if (sym != nullptr)
              fSym = new FunctionSymbolExpr(fname, funcs, (yylsp[-3]));
          (yyval.expr) = new FunctionCallExpr(fSym, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          delete name;
      }
#line 3688 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 55: /* funcall_expression: postfix_expression '(' ')'  */
#line 590 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0]))); }
#line 3694 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 56: /* funcall_expression: postfix_expression '(' argument_expression_list ')'  */
#line 592 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0]))); }
#line 3700 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 57: /* funcall_expression: postfix_expression '(' error ')'  */
#line 594 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 3706 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 58: /* funcall_expression: simple_template_id '(' ')'  */
#line 596 "src/parse.yy"
      {
          // Create FunctionSymbolExpr with a candidate functions list
          Expr *functionSymbolExpr = nullptr;
          std::vector<TemplateSymbol *> funcTempls;
          const std::string name = (yyvsp[-2].simpleTemplateID)->first->name;
          m->symbolTable->LookupFunctionTemplate(name, &funcTempls);
          if (funcTempls.size() > 0) {
              TemplateArgs *templArgs = (yyvsp[-2].simpleTemplateID)->second;
              Assert(templArgs);
              functionSymbolExpr = new FunctionSymbolExpr(name.c_str(), funcTempls, *templArgs, (yylsp[-2]));
              (yyval.expr) = new FunctionCallExpr(functionSymbolExpr, new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])));
          } else {
              Error((yylsp[-2]), "No matching template functions were declared.");
              (yyval.expr) = nullptr;
          }

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-2].simpleTemplateID));
      }
#line 3730 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 59: /* funcall_expression: simple_template_id '(' argument_expression_list ')'  */
#line 616 "src/parse.yy"
      {
          // Create FunctionSymbolExpr with a candidate functions list
          Expr *functionSymbolExpr = nullptr;
          std::vector<TemplateSymbol *> funcTempls;
          const std::string name = (yyvsp[-3].simpleTemplateID)->first->name;
          m->symbolTable->LookupFunctionTemplate(name, &funcTempls);
          if (funcTempls.size() > 0) {
              TemplateArgs *templArgs = (yyvsp[-3].simpleTemplateID)->second;
              Assert(templArgs);
              functionSymbolExpr = new FunctionSymbolExpr(name.c_str(), funcTempls, *templArgs, (yylsp[-3]));
              (yyval.expr) = new FunctionCallExpr(functionSymbolExpr, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          } else {
              Error((yylsp[-3]), "No matching template functions were declared.");
              (yyval.expr) = nullptr;
          }

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
      }
#line 3754 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 60: /* funcall_expression: simple_template_id '(' error ')'  */
#line 636 "src/parse.yy"
      {
          (yyval.expr) = nullptr;

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
      }
#line 3765 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 61: /* argument_expression_list: assignment_expression  */
#line 645 "src/parse.yy"
                                 { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 3771 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 62: /* argument_expression_list: argument_expression_list ',' assignment_expression  */
#line 647 "src/parse.yy"
      {
          ExprList *argList = llvm::dyn_cast<ExprList>((yyvsp[-2].exprList));
          if (argList == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              argList = new ExprList((yylsp[0]));
          }
          argList->exprs.push_back((yyvsp[0].expr));
          argList->pos = Union(argList->pos, (yylsp[0]));
          (yyval.exprList) = argList;
      }
#line 3786 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 66: /* unary_expression: TOKEN_INC_OP unary_expression  */
#line 664 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreInc, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3792 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 67: /* unary_expression: TOKEN_DEC_OP unary_expression  */
#line 666 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreDec, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3798 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 68: /* unary_expression: '&' unary_expression  */
#line 668 "src/parse.yy"
      { (yyval.expr) = new AddressOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3804 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 69: /* unary_expression: '*' unary_expression  */
#line 670 "src/parse.yy"
      { (yyval.expr) = new PtrDerefExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3810 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 70: /* unary_expression: '+' cast_expression  */
#line 672 "src/parse.yy"
      { (yyval.expr) = (yyvsp[0].expr); }
#line 3816 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 71: /* unary_expression: '-' cast_expression  */
#line 674 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::Negate, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3822 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 72: /* unary_expression: '~' cast_expression  */
#line 676 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::BitNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3828 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 73: /* unary_expression: '!' cast_expression  */
#line 678 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::LogicalNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3834 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 74: /* unary_expression: TOKEN_SIZEOF unary_expression  */
#line 680 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3840 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 75: /* unary_expression: TOKEN_SIZEOF '(' type_name ')'  */
#line 682 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[-1].type), Union((yylsp[-3]), (yylsp[0]))); }
#line 3846 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 76: /* unary_expression: TOKEN_ALLOCA '(' assignment_expression ')'  */
#line 684 "src/parse.yy"
      {
          (yyval.expr) = new AllocaExpr((yyvsp[-1].expr), Union((yylsp[-3]), (yylsp[0])));
      }
#line 3854 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 78: /* cast_expression: '(' type_name ')' cast_expression  */
#line 692 "src/parse.yy"
      {
          (yyval.expr) = new TypeCastExpr((yyvsp[-2].type), (yyvsp[0].expr), Union((yylsp[-3]),(yylsp[0])));
      }
#line 3862 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 80: /* multiplicative_expression: multiplicative_expression '*' cast_expression  */
#line 700 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mul, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3868 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 81: /* multiplicative_expression: multiplicative_expression '/' cast_expression  */
#line 702 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Div, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3874 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 82: /* multiplicative_expression: multiplicative_expression '%' cast_expression  */
#line 704 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mod, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3880 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 84: /* additive_expression: additive_expression '+' multiplicative_expression  */
#line 710 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Add, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3886 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 85: /* additive_expression: additive_expression '-' multiplicative_expression  */
#line 712 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Sub, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3892 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 87: /* shift_expression: shift_expression TOKEN_LEFT_OP additive_expression  */
#line 718 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shl, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3898 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 88: /* shift_expression: shift_expression TOKEN_RIGHT_OP additive_expression  */
#line 720 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3904 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 90: /* relational_expression: relational_expression '<' shift_expression  */
#line 726 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Lt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3910 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 91: /* relational_expression: relational_expression '>' shift_expression  */
#line 728 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Gt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3916 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 92: /* relational_expression: relational_expression TOKEN_LE_OP shift_expression  */
#line 730 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Le, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3922 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 93: /* relational_expression: relational_expression TOKEN_GE_OP shift_expression  */
#line 732 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Ge, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3928 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 95: /* equality_expression: equality_expression TOKEN_EQ_OP relational_expression  */
#line 738 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Equal, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3934 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 96: /* equality_expression: equality_expression TOKEN_NE_OP relational_expression  */
#line 740 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::NotEqual, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3940 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 98: /* and_expression: and_expression '&' equality_expression  */
#line 746 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3946 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 100: /* exclusive_or_expression: exclusive_or_expression '^' and_expression  */
#line 752 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitXor, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3952 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 102: /* inclusive_or_expression: inclusive_or_expression '|' exclusive_or_expression  */
#line 758 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3958 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 104: /* logical_and_expression: logical_and_expression TOKEN_AND_OP inclusive_or_expression  */
#line 764 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3964 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 106: /* logical_or_expression: logical_or_expression TOKEN_OR_OP logical_and_expression  */
#line 770 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3970 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 108: /* conditional_expression: logical_or_expression '?' expression ':' conditional_expression  */
#line 776 "src/parse.yy"
      { (yyval.expr) = new SelectExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-4]),(yylsp[0]))); }
#line 3976 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 109: /* rate_qualified_new: TOKEN_NEW  */
#line 780 "src/parse.yy"
                { (yyval.intVal) = 0; }
#line 3982 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 110: /* rate_qualified_new: TOKEN_UNIFORM TOKEN_NEW  */
#line 781 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_UNIFORM; }
#line 3988 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 111: /* rate_qualified_new: TOKEN_VARYING TOKEN_NEW  */
#line 782 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_VARYING; }
#line 3994 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 112: /* rate_qualified_type_specifier: type_specifier  */
#line 786 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].type); }
#line 4000 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 113: /* rate_qualified_type_specifier: TOKEN_UNIFORM type_specifier  */
#line 788 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.type) = nullptr;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
            (yyval.type) = nullptr;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
    }
#line 4015 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 114: /* rate_qualified_type_specifier: TOKEN_VARYING type_specifier  */
#line 799 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.type) = nullptr;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
            (yyval.type) = nullptr;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
    }
#line 4030 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 115: /* rate_qualified_type_specifier: soa_width_specifier type_specifier  */
#line 810 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.type) = nullptr;
        else {
            int soaWidth = (int)(yyvsp[-1].intVal);
            const StructType *st = CastType<StructType>((yyvsp[0].type));
            if (st == nullptr) {
                Error((yylsp[-1]), "\"soa\" qualifier is illegal with non-struct type \"%s\".",
                      (yyvsp[0].type)->GetString().c_str());
                (yyval.type) = nullptr;
            }
            else if (soaWidth <= 0 || (soaWidth & (soaWidth - 1)) != 0) {
                Error((yylsp[-1]), "soa<%d> width illegal. Value must be positive power "
                      "of two.", soaWidth);
                (yyval.type) = nullptr;
            }
            else
                (yyval.type) = st->GetAsSOAType(soaWidth);
        }
    }
#line 4055 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 117: /* new_expression: rate_qualified_new rate_qualified_type_specifier  */
#line 835 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-1].intVal), (yyvsp[0].type), nullptr, nullptr, (yylsp[-1]), Union((yylsp[-1]), (yylsp[0])));
    }
#line 4063 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 118: /* new_expression: rate_qualified_new rate_qualified_type_specifier '(' initializer_list ')'  */
#line 839 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), (yyvsp[-1].exprList), nullptr, (yylsp[-4]), Union((yylsp[-4]), (yylsp[-3])));
    }
#line 4071 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 119: /* new_expression: rate_qualified_new rate_qualified_type_specifier '[' expression ']'  */
#line 843 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), nullptr, (yyvsp[-1].expr), (yylsp[-4]), Union((yylsp[-4]), (yylsp[-1])));
    }
#line 4079 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 121: /* assignment_expression: unary_expression '=' assignment_expression  */
#line 851 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::Assign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4085 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 122: /* assignment_expression: unary_expression TOKEN_MUL_ASSIGN assignment_expression  */
#line 853 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::MulAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4091 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 123: /* assignment_expression: unary_expression TOKEN_DIV_ASSIGN assignment_expression  */
#line 855 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::DivAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4097 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 124: /* assignment_expression: unary_expression TOKEN_MOD_ASSIGN assignment_expression  */
#line 857 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ModAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4103 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 125: /* assignment_expression: unary_expression TOKEN_ADD_ASSIGN assignment_expression  */
#line 859 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AddAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4109 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 126: /* assignment_expression: unary_expression TOKEN_SUB_ASSIGN assignment_expression  */
#line 861 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::SubAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4115 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 127: /* assignment_expression: unary_expression TOKEN_LEFT_ASSIGN assignment_expression  */
#line 863 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShlAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4121 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 128: /* assignment_expression: unary_expression TOKEN_RIGHT_ASSIGN assignment_expression  */
#line 865 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4127 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 129: /* assignment_expression: unary_expression TOKEN_AND_ASSIGN assignment_expression  */
#line 867 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AndAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4133 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 130: /* assignment_expression: unary_expression TOKEN_XOR_ASSIGN assignment_expression  */
#line 869 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::XorAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4139 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 131: /* assignment_expression: unary_expression TOKEN_OR_ASSIGN assignment_expression  */
#line 871 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::OrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4145 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 133: /* expression: expression ',' assignment_expression  */
#line 877 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Comma, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4151 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 135: /* declaration_statement: declaration  */
#line 886 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) == nullptr) {
            AssertPos((yylsp[0]), m->errorCount > 0);
            (yyval.stmt) = nullptr;
        }
        else if ((yyvsp[0].declaration)->declSpecs->storageClass == SC_TYPEDEF) {
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i) {
                if ((yyvsp[0].declaration)->declarators[i] == nullptr)
                    AssertPos((yylsp[0]), m->errorCount > 0);
                else
                    m->AddTypeDef((yyvsp[0].declaration)->declarators[i]->name,
                                  (yyvsp[0].declaration)->declarators[i]->type,
                                  (yyvsp[0].declaration)->declarators[i]->pos);
            }
            (yyval.stmt) = nullptr;
        }
        else {
            (yyvsp[0].declaration)->DeclareFunctions();
            std::vector<VariableDeclaration> vars = (yyvsp[0].declaration)->GetVariableDeclarations();
            (yyval.stmt) = new DeclStmt(vars, (yylsp[0]));
        }
    }
#line 4178 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 136: /* declaration: declaration_specifiers ';'  */
#line 912 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs));
      }
#line 4186 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 137: /* declaration: declaration_specifiers init_declarator_list ';'  */
#line 916 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-2].declSpecs), (yyvsp[-1].declarators));
          // init_declarator_list returns vector of declarators, its copy is
          // saved in Declaration constructor, so it is not needed anymore.
          delete (yyvsp[-1].declarators);
      }
#line 4197 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 138: /* soa_width_specifier: TOKEN_SOA '<' int_constant '>'  */
#line 926 "src/parse.yy"
      { (yyval.intVal) = (yyvsp[-1].intVal); }
#line 4203 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 139: /* declspec_item: TOKEN_IDENTIFIER  */
#line 931 "src/parse.yy"
    {
        std::pair<std::string, SourcePos> *p = new std::pair<std::string, SourcePos>;
        p->first = *(yyvsp[0].stringVal);
        p->second = (yylsp[0]);
        (yyval.declspecPair) = p;
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4215 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 140: /* declspec_list: declspec_item  */
#line 942 "src/parse.yy"
    {
        (yyval.declspecList) = new std::vector<std::pair<std::string, SourcePos> >;
        (yyval.declspecList)->push_back(*(yyvsp[0].declspecPair));
        // declspec_item returns pair that was copied so it is not needed anymore.
        delete (yyvsp[0].declspecPair);
    }
#line 4226 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 141: /* declspec_list: declspec_list ',' declspec_item  */
#line 949 "src/parse.yy"
    {
        if ((yyvsp[-2].declspecList) != nullptr) {
            (yyvsp[-2].declspecList)->push_back(*(yyvsp[0].declspecPair));
            // declspec_item returns pair that was copied so it is not needed anymore.
            delete (yyvsp[0].declspecPair);
        }
        (yyval.declspecList) = (yyvsp[-2].declspecList);
    }
#line 4239 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 142: /* declspec_specifier: TOKEN_DECLSPEC '(' declspec_list ')'  */
#line 961 "src/parse.yy"
    {
        // declspec_list returns heap allocated vector that passed up here.
        (yyval.declspecList) = (yyvsp[-1].declspecList);
    }
#line 4248 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 143: /* declaration_specifiers: storage_class_specifier  */
#line 969 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(nullptr, (yyvsp[0].storageClass));
      }
#line 4256 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 144: /* declaration_specifiers: storage_class_specifier declaration_specifiers  */
#line 973 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr) {
              if (ds->storageClass != SC_NONE)
                  Error((yylsp[-1]), "Multiple storage class specifiers in a declaration are illegal. "
                        "(Have provided both \"%s\" and \"%s\".)",
                        lGetStorageClassString(ds->storageClass),
                        lGetStorageClassString((yyvsp[-1].storageClass)));
              else
                  ds->storageClass = (yyvsp[-1].storageClass);
          }
          (yyval.declSpecs) = ds;
      }
#line 4274 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 145: /* declaration_specifiers: declspec_specifier  */
#line 987 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs;
          if ((yyvsp[0].declspecList) != nullptr) {
              (yyval.declSpecs)->declSpecList = *(yyvsp[0].declspecList);
              // declspec_specifier returns a vector that was copied and it is not needed anymore.
              delete (yyvsp[0].declspecList);
          }
      }
#line 4287 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 146: /* declaration_specifiers: declspec_specifier declaration_specifiers  */
#line 996 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          std::vector<std::pair<std::string, SourcePos> > *declSpecList = (yyvsp[-1].declspecList);
          if (ds != nullptr && declSpecList != nullptr) {
              for (int i = 0; i < (int)declSpecList->size(); ++i)
                  ds->declSpecList.push_back((*declSpecList)[i]);

              // declspec_specifier returns a vector that was copied and it is not needed anymore.
              delete declSpecList;
          }
          (yyval.declSpecs) = ds;
      }
#line 4304 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 147: /* declaration_specifiers: soa_width_specifier  */
#line 1009 "src/parse.yy"
      {
          DeclSpecs *ds = new DeclSpecs;
          ds->soaWidth = (int32_t)(yyvsp[0].intVal);
          (yyval.declSpecs) = ds;
      }
#line 4314 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 148: /* declaration_specifiers: soa_width_specifier declaration_specifiers  */
#line 1015 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr) {
              if (ds->soaWidth != 0)
                  Error((yylsp[-1]), "soa<> qualifier supplied multiple times in declaration.");
              else
                  ds->soaWidth = (int32_t)(yyvsp[-1].intVal);
          }
          (yyval.declSpecs) = ds;
      }
#line 4329 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 149: /* declaration_specifiers: type_specifier  */
#line 1026 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs((yyvsp[0].type));
      }
#line 4337 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 150: /* declaration_specifiers: type_specifier '<' int_constant '>'  */
#line 1030 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          ds->vectorSize = (int32_t)(yyvsp[-1].intVal);
          (yyval.declSpecs) = ds;
    }
#line 4347 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 151: /* declaration_specifiers: type_specifier '<' TOKEN_IDENTIFIER '>'  */
#line 1036 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          const char *name = (yyvsp[-1].stringVal)->c_str();
          Symbol *s = m->symbolTable->LookupVariable(name);
          if (s) {
            ds->vectorSize = s;
          } else {
            Error((yylsp[-1]), "Unknown identifier \"%s\" is used to specify the size of a vector type.", name);
          }
          (yyval.declSpecs) = ds;
          lCleanUpString((yyvsp[-1].stringVal));
    }
#line 4364 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 152: /* declaration_specifiers: type_specifier declaration_specifiers  */
#line 1049 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr) {
              if (ds->baseType != nullptr) {
                  if( ds->baseType->IsUnsignedType()) {
                      Error((yylsp[-1]), "Redefining uint8/uint16/uint32/uint64 type "
                      "which is part of ISPC language since version 1.13. "
                      "Remove this typedef or use ISPC_UINT_IS_DEFINED to "
                      "detect that these types are defined.");
                  } else if (CastType<StructType>(ds->baseType)) {
                      // Skip the error if the base type is a struct type to
                      // support typedef struct foo { } foo;
                      ;
                  } else
                      Error((yylsp[-1]), "Multiple types provided for declaration.");
              }
              ds->baseType = (yyvsp[-1].type);
          }
          (yyval.declSpecs) = ds;
      }
#line 4389 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 153: /* declaration_specifiers: type_qualifier  */
#line 1070 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(nullptr, SC_NONE, (yyvsp[0].typeQualifier));
      }
#line 4397 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 154: /* declaration_specifiers: type_qualifier declaration_specifiers  */
#line 1074 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr)
              ds->typeQualifiers |= (yyvsp[-1].typeQualifier);
          (yyval.declSpecs) = ds;
      }
#line 4408 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 155: /* declaration_specifiers: attribute_specifier  */
#line 1081 "src/parse.yy"
      {
          AttributeList *al = (yyvsp[0].attributeList);
          DeclSpecs *ds = new DeclSpecs();
          if (al) {
              ds->AddAttrList(*al);
              delete al;
          }
          (yyval.declSpecs) = ds;
      }
#line 4422 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 156: /* declaration_specifiers: attribute_specifier declaration_specifiers  */
#line 1091 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          AttributeList *al = (yyvsp[-1].attributeList);
          if (ds && al) {
              ds->AddAttrList(*al);
              delete al;
          }
          (yyval.declSpecs) = ds;
      }
#line 4436 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 157: /* attribute_specifier: TOKEN_ATTRIBUTE '(' '(' attribute_list ')' ')'  */
#line 1104 "src/parse.yy"
      {
          (yyval.attributeList) = (yyvsp[-2].attributeList);
      }
#line 4444 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 158: /* attribute_list: attribute  */
#line 1111 "src/parse.yy"
      {
          Attribute *attr = (yyvsp[0].attr);
          AttributeList *al = new AttributeList;
          al->AddAttribute(*attr);
          (yyval.attributeList) = al;
          delete attr;
      }
#line 4456 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 159: /* attribute_list: attribute_list ',' attribute  */
#line 1119 "src/parse.yy"
      {
          Attribute *attr = (yyvsp[0].attr);
          AttributeList *al = (yyvsp[-2].attributeList);
          al->AddAttribute(*attr);
          (yyval.attributeList) = al;
          delete attr;
      }
#line 4468 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 160: /* attribute: TOKEN_IDENTIFIER  */
#line 1130 "src/parse.yy"
      {
          std::string *str = (yyvsp[0].stringVal);;
          (yyval.attr) = new Attribute(*str);
          // cleanup TOKEN_IDENTIFIER string
          lCleanUpString(str);
      }
#line 4479 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 161: /* attribute: TOKEN_IDENTIFIER '(' attribute_argument ')'  */
#line 1137 "src/parse.yy"
      {
          std::string *str = (yyvsp[-3].stringVal);;
          AttrArgument *arg = (yyvsp[-1].attrArg);
          (yyval.attr) = new Attribute(*str, *arg);
          delete arg;
          // cleanup TOKEN_IDENTIFIER string
          lCleanUpString(str);
      }
#line 4492 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 162: /* attribute_argument: int_constant  */
#line 1149 "src/parse.yy"
      {
          (yyval.attrArg) = new AttrArgument((yyvsp[0].intVal));
      }
#line 4500 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 163: /* attribute_argument: string_constant  */
#line 1153 "src/parse.yy"
      {
          std::string *str = (yyvsp[0].stringVal);;
          (yyval.attrArg) = new AttrArgument(*str);
          // deallocate std::string of string_constant
          lCleanUpString(str);
      }
#line 4511 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 164: /* init_declarator_list: init_declarator  */
#line 1163 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != nullptr)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 4522 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 165: /* init_declarator_list: init_declarator_list ',' init_declarator  */
#line 1170 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = (std::vector<Declarator *> *)(yyvsp[-2].declarators);
          if (dl == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              dl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != nullptr)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 4537 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 167: /* init_declarator: declarator '=' initializer  */
#line 1185 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != nullptr)
              (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
          (yyval.declarator) = (yyvsp[-2].declarator);
      }
#line 4547 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 168: /* storage_class_specifier: TOKEN_TYPEDEF  */
#line 1193 "src/parse.yy"
                    { (yyval.storageClass) = SC_TYPEDEF; }
#line 4553 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 169: /* storage_class_specifier: TOKEN_EXTERN  */
#line 1194 "src/parse.yy"
                   { (yyval.storageClass) = SC_EXTERN; }
#line 4559 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 170: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_C_LITERAL  */
#line 1195 "src/parse.yy"
                                           { (yyval.storageClass) = SC_EXTERN_C; }
#line 4565 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 171: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_SYCL_LITERAL  */
#line 1196 "src/parse.yy"
                                              { (yyval.storageClass) = SC_EXTERN_SYCL; }
#line 4571 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 172: /* storage_class_specifier: TOKEN_STATIC  */
#line 1197 "src/parse.yy"
                   { (yyval.storageClass) = SC_STATIC; }
#line 4577 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 173: /* type_specifier: atomic_var_type_specifier  */
#line 1201 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].atomicType); }
#line 4583 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 174: /* type_specifier: TOKEN_TYPE_NAME  */
#line 1203 "src/parse.yy"
    {
        const Type *t = m->symbolTable->LookupType(yytext);
        (yyval.type) = t;
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4593 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 175: /* type_specifier: struct_or_union_specifier  */
#line 1208 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].type); }
#line 4599 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 176: /* type_specifier: enum_specifier  */
#line 1209 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].enumType); }
#line 4605 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 177: /* type_specifier_list: type_specifier  */
#line 1214 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.typeList) = nullptr;
        else {
            std::vector<std::pair<const Type *, SourcePos> > *vec =
                new std::vector<std::pair<const Type *, SourcePos> >;
            vec->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
            (yyval.typeList) = vec;
        }
    }
#line 4620 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 178: /* type_specifier_list: type_specifier_list ',' type_specifier  */
#line 1225 "src/parse.yy"
    {
        (yyval.typeList) = (yyvsp[-2].typeList);
        if ((yyvsp[-2].typeList) == nullptr)
            Assert(m->errorCount > 0);
        else
            (yyval.typeList)->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
    }
#line 4632 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 179: /* atomic_var_type_specifier: TOKEN_VOID  */
#line 1235 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::Void; }
#line 4638 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 180: /* atomic_var_type_specifier: TOKEN_BOOL  */
#line 1236 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformBool->GetAsUnboundVariabilityType(); }
#line 4644 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 181: /* atomic_var_type_specifier: TOKEN_INT8  */
#line 1237 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformInt8->GetAsUnboundVariabilityType(); }
#line 4650 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 182: /* atomic_var_type_specifier: TOKEN_UINT8  */
#line 1238 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt8->GetAsUnboundVariabilityType(); }
#line 4656 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 183: /* atomic_var_type_specifier: TOKEN_INT16  */
#line 1239 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt16->GetAsUnboundVariabilityType(); }
#line 4662 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 184: /* atomic_var_type_specifier: TOKEN_UINT16  */
#line 1240 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt16->GetAsUnboundVariabilityType(); }
#line 4668 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 185: /* atomic_var_type_specifier: TOKEN_INT  */
#line 1241 "src/parse.yy"
                { (yyval.atomicType) = AtomicType::UniformInt32->GetAsUnboundVariabilityType(); }
#line 4674 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 186: /* atomic_var_type_specifier: TOKEN_UINT  */
#line 1242 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformUInt32->GetAsUnboundVariabilityType(); }
#line 4680 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 187: /* atomic_var_type_specifier: TOKEN_FLOAT16  */
#line 1243 "src/parse.yy"
                    { (yyval.atomicType) = AtomicType::UniformFloat16->GetAsUnboundVariabilityType(); }
#line 4686 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 188: /* atomic_var_type_specifier: TOKEN_FLOAT  */
#line 1244 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformFloat->GetAsUnboundVariabilityType(); }
#line 4692 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 189: /* atomic_var_type_specifier: TOKEN_DOUBLE  */
#line 1245 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformDouble->GetAsUnboundVariabilityType(); }
#line 4698 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 190: /* atomic_var_type_specifier: TOKEN_INT64  */
#line 1246 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt64->GetAsUnboundVariabilityType(); }
#line 4704 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 191: /* atomic_var_type_specifier: TOKEN_UINT64  */
#line 1247 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt64->GetAsUnboundVariabilityType(); }
#line 4710 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 192: /* short_vec_specifier: atomic_var_type_specifier '<' int_constant '>'  */
#line 1252 "src/parse.yy"
    {
        (yyval.type) = (yyvsp[-3].atomicType) ? new VectorType((yyvsp[-3].atomicType), (int32_t)(yyvsp[-1].intVal)) : nullptr;
    }
#line 4718 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 193: /* struct_or_union_name: TOKEN_IDENTIFIER  */
#line 1267 "src/parse.yy"
    {
        (yyval.constCharPtr) = strdup(yytext);
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4727 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 194: /* struct_or_union_name: TOKEN_TYPE_NAME  */
#line 1272 "src/parse.yy"
    {
        (yyval.constCharPtr) = strdup(yytext);
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4736 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 195: /* struct_or_union_and_name: struct_or_union struct_or_union_name  */
#line 1280 "src/parse.yy"
      {
          const Type *st = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (st == nullptr) {
              st = new UndefinedStructType((yyvsp[0].constCharPtr), Variability::Unbound, false, (yylsp[0]));
              m->symbolTable->AddType((yyvsp[0].constCharPtr), st, (yylsp[0]));
              (yyval.type) = st;
          }
          else {
              if (CastType<StructType>(st) == nullptr &&
                  CastType<UndefinedStructType>(st) == nullptr) {
                  Error((yylsp[0]), "Type \"%s\" is not a struct type! (%s)", (yyvsp[0].constCharPtr),
                        st->GetString().c_str());
                  (yyval.type) = nullptr;
              }
              else
                  (yyval.type) = st;
         }
         // allocated by strdup in struct_or_union_name
         free((char*)(yyvsp[0].constCharPtr));
      }
#line 4761 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 197: /* struct_or_union_specifier: struct_or_union_and_name '{' struct_declaration_list '}'  */
#line 1305 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != nullptr) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              const std::string &name = CastType<StructType>((yyvsp[-3].type)) ?
                  CastType<StructType>((yyvsp[-3].type))->GetStructName() :
                  CastType<UndefinedStructType>((yyvsp[-3].type))->GetStructName();
              StructType *st = new StructType(name, elementTypes, elementNames,
                                              elementPositions, false,
                                              Variability::Unbound, false, (yylsp[-3]));
              m->symbolTable->AddType(name.c_str(), st, (yylsp[-3]));
              (yyval.type) = st;
              // struct_declaration_list returns a vector that is not needed anymore.
              delete (yyvsp[-1].structDeclarationList);
          }
          else
              (yyval.type) = nullptr;
      }
#line 4787 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 198: /* struct_or_union_specifier: struct_or_union '{' struct_declaration_list '}'  */
#line 1327 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != nullptr) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                                  false, Variability::Unbound, true, (yylsp[-3]));
              // struct_declaration_list returns a vector that is not needed anymore.
              delete (yyvsp[-1].structDeclarationList);
          }
          else
              (yyval.type) = nullptr;
      }
#line 4807 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 199: /* struct_or_union_specifier: struct_or_union '{' '}'  */
#line 1343 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                              false, Variability::Unbound, true, (yylsp[-2]));
      }
#line 4819 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 200: /* struct_or_union_specifier: struct_or_union_and_name '{' '}'  */
#line 1351 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          const std::string &name = CastType<StructType>((yyvsp[-2].type)) ?
              CastType<StructType>((yyvsp[-2].type))->GetStructName() :
              CastType<UndefinedStructType>((yyvsp[-2].type))->GetStructName();
          StructType *st = new StructType(name, elementTypes,
                                          elementNames, elementPositions,
                                          false, Variability::Unbound, false, (yylsp[-2]));
          m->symbolTable->AddType(name.c_str(), st, (yylsp[-1]));
          (yyval.type) = st;
      }
#line 4837 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 202: /* struct_declaration_list: struct_declaration  */
#line 1372 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = new std::vector<StructDeclaration *>;
          if ((yyvsp[0].structDeclaration) != nullptr)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4848 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 203: /* struct_declaration_list: struct_declaration_list struct_declaration  */
#line 1379 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = (std::vector<StructDeclaration *> *)(yyvsp[-1].structDeclarationList);
          if (sdl == nullptr) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sdl = new std::vector<StructDeclaration *>;
          }
          if ((yyvsp[0].structDeclaration) != nullptr)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4863 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 204: /* struct_declaration: specifier_qualifier_list struct_declarator_list ';'  */
#line 1393 "src/parse.yy"
      { (yyval.structDeclaration) = ((yyvsp[-2].type) != nullptr && (yyvsp[-1].structDeclaratorList) != nullptr) ? new StructDeclaration((yyvsp[-2].type), (yyvsp[-1].structDeclaratorList)) : nullptr; }
#line 4869 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 208: /* specifier_qualifier_list: type_qualifier specifier_qualifier_list  */
#line 1401 "src/parse.yy"
    {
        if ((yyvsp[0].type) != nullptr) {
            if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNIFORM) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = nullptr;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VARYING) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = nullptr;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_CONST)
                (yyval.type) = (yyvsp[0].type)->GetAsConstType();
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_SIGNED) {
                if ((yyvsp[0].type)->IsIntType() == false) {
                    Error((yylsp[-1]), "Can't apply \"signed\" qualifier to \"%s\" type.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNSIGNED) {
                const Type *t = (yyvsp[0].type)->GetAsUnsignedType();
                if (t)
                    (yyval.type) = t;
                else {
                    Error((yylsp[-1]), "Can't apply \"unsigned\" qualifier to \"%s\" type. Ignoring.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_INLINE) {
                Error((yylsp[-1]), "\"inline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_NOINLINE) {
                Error((yylsp[-1]), "\"noinline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VECTORCALL) {
                Error((yylsp[-1]), "\"__vectorcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_REGCALL) {
                Error((yylsp[-1]), "\"__regcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_TASK) {
                Error((yylsp[-1]), "\"task\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNMASKED) {
                Error((yylsp[-1]), "\"unmasked\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_EXPORT) {
                Error((yylsp[-1]), "\"export\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else
                FATAL("Unhandled type qualifier in parser.");
        }
        else {
            if (m->errorCount == 0)
                Error((yylsp[-1]), "Lost type qualifier in parser.");
            (yyval.type) = nullptr;
        }
    }
#line 4955 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 209: /* struct_declarator_list: struct_declarator  */
#line 1487 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != nullptr)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4966 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 210: /* struct_declarator_list: struct_declarator_list ',' struct_declarator  */
#line 1494 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = (std::vector<Declarator *> *)(yyvsp[-2].structDeclaratorList);
          if (sdl == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              sdl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != nullptr)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4981 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 211: /* struct_declarator: declarator  */
#line 1507 "src/parse.yy"
                 { (yyval.declarator) = (yyvsp[0].declarator); }
#line 4987 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 212: /* enum_identifier: TOKEN_IDENTIFIER  */
#line 1516 "src/parse.yy"
      {
          (yyval.constCharPtr) = strdup(yytext);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 4996 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 213: /* enum_specifier: TOKEN_ENUM '{' enumerator_list '}'  */
#line 1524 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(nullptr, (yyvsp[-1].symbolList), (yylsp[-3]));
          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-1].symbolList);
      }
#line 5006 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 214: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list '}'  */
#line 1530 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-3].constCharPtr), (yyvsp[-1].symbolList), (yylsp[-3]));
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[-3].constCharPtr));

          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-1].symbolList);
      }
#line 5019 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 215: /* enum_specifier: TOKEN_ENUM '{' enumerator_list ',' '}'  */
#line 1539 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(nullptr, (yyvsp[-2].symbolList), (yylsp[-4]));
          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-2].symbolList);
      }
#line 5029 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 216: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list ',' '}'  */
#line 1545 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-4].constCharPtr), (yyvsp[-2].symbolList), (yylsp[-4]));
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[-4].constCharPtr));

          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-2].symbolList);
      }
#line 5042 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 217: /* enum_specifier: TOKEN_ENUM enum_identifier  */
#line 1554 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (type == nullptr) {
              std::vector<std::string> alternates = m->symbolTable->ClosestEnumTypeMatch((yyvsp[0].constCharPtr));
              std::string alts = lGetAlternates(alternates);
              Error((yylsp[0]), "Enum type \"%s\" unknown.%s", (yyvsp[0].constCharPtr), alts.c_str());
              (yyval.enumType) = nullptr;
          }
          else {
              const EnumType *enumType = CastType<EnumType>(type);
              if (enumType == nullptr) {
                  Error((yylsp[0]), "Type \"%s\" is not an enum type (%s).", (yyvsp[0].constCharPtr),
                        type->GetString().c_str());
                  (yyval.enumType) = nullptr;
              }
              else
                  (yyval.enumType) = enumType;
          }
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[0].constCharPtr));
      }
#line 5068 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 218: /* enumerator_list: enumerator  */
#line 1579 "src/parse.yy"
      {
          if ((yyvsp[0].symbol) == nullptr)
              (yyval.symbolList) = nullptr;
          else {
              std::vector<Symbol *> *el = new std::vector<Symbol *>;
              el->push_back((yyvsp[0].symbol));
              (yyval.symbolList) = el;
          }
      }
#line 5082 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 219: /* enumerator_list: enumerator_list ',' enumerator  */
#line 1589 "src/parse.yy"
      {
          std::vector<Symbol *> *symList = (yyvsp[-2].symbolList);
          if (symList == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              symList = new std::vector<Symbol *>;
          }
          if ((yyvsp[0].symbol) != nullptr)
              symList->push_back((yyvsp[0].symbol));
          (yyval.symbolList) = symList;
      }
#line 5097 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 220: /* enumerator: enum_identifier  */
#line 1603 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol((yyvsp[0].constCharPtr), (yylsp[0]), Symbol::SymbolKind::Enumerator);
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[0].constCharPtr));
      }
#line 5107 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 221: /* enumerator: enum_identifier '=' constant_expression  */
#line 1609 "src/parse.yy"
      {
          std::variant<std::monostate, int, Symbol*> value;
          if ((yyvsp[-2].constCharPtr) != nullptr && (yyvsp[0].expr) != nullptr &&
              lGetConstantIntOrSymbol((yyvsp[0].expr), &value, (yylsp[0]), "Enumerator value")) {
              Symbol *sym = new Symbol((yyvsp[-2].constCharPtr), (yylsp[-2]), Symbol::SymbolKind::Enumerator);

              // Check if value holds an int
              if (std::holds_alternative<int>(value)) {
                  int intValue = std::get<int>(value);
                  sym->constValue = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                                                  (uint32_t)intValue, (yylsp[0]));
              } else {
                  Error((yylsp[0]), "Enumerator value must be a compile-time constant.");
                  (yyval.symbol) = nullptr;
              }
              (yyval.symbol) = sym;
          }
          else {
              (yyval.symbol) = nullptr;
          }

          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[-2].constCharPtr));
      }
#line 5136 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 222: /* type_qualifier: TOKEN_CONST  */
#line 1636 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_CONST; }
#line 5142 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 223: /* type_qualifier: TOKEN_UNIFORM  */
#line 1637 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNIFORM; }
#line 5148 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 224: /* type_qualifier: TOKEN_VARYING  */
#line 1638 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_VARYING; }
#line 5154 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 225: /* type_qualifier: TOKEN_TASK  */
#line 1639 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_TASK; }
#line 5160 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 226: /* type_qualifier: TOKEN_UNMASKED  */
#line 1640 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNMASKED; }
#line 5166 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 227: /* type_qualifier: TOKEN_EXPORT  */
#line 1641 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_EXPORT; }
#line 5172 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 228: /* type_qualifier: TOKEN_INLINE  */
#line 1642 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_INLINE; }
#line 5178 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 229: /* type_qualifier: TOKEN_NOINLINE  */
#line 1643 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_NOINLINE; }
#line 5184 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 230: /* type_qualifier: TOKEN_VECTORCALL  */
#line 1644 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_VECTORCALL; }
#line 5190 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 231: /* type_qualifier: TOKEN_REGCALL  */
#line 1645 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_REGCALL; }
#line 5196 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 232: /* type_qualifier: TOKEN_SIGNED  */
#line 1646 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_SIGNED; }
#line 5202 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 233: /* type_qualifier: TOKEN_UNSIGNED  */
#line 1647 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNSIGNED; }
#line 5208 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 234: /* type_qualifier_list: type_qualifier  */
#line 1652 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[0].typeQualifier);
    }
#line 5216 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 235: /* type_qualifier_list: type_qualifier_list type_qualifier  */
#line 1656 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[-1].typeQualifier) | (yyvsp[0].typeQualifier);
    }
#line 5224 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 236: /* declarator: pointer direct_declarator  */
#line 1663 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != nullptr) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != nullptr)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = nullptr;
    }
#line 5240 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 237: /* declarator: reference direct_declarator  */
#line 1675 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != nullptr) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != nullptr)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = nullptr;
    }
#line 5256 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 239: /* int_constant: TOKEN_INT8_CONSTANT  */
#line 1690 "src/parse.yy"
                          { (yyval.intVal) = yylval.intVal; }
#line 5262 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 240: /* int_constant: TOKEN_INT16_CONSTANT  */
#line 1691 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 5268 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 241: /* int_constant: TOKEN_INT32_CONSTANT  */
#line 1692 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 5274 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 242: /* int_constant: TOKEN_INT64_CONSTANT  */
#line 1693 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 5280 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 243: /* direct_declarator: TOKEN_IDENTIFIER  */
#line 1698 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 5291 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 244: /* direct_declarator: TOKEN_TEMPLATE_NAME  */
#line 1707 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 5302 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 245: /* direct_declarator: '(' declarator ')'  */
#line 1714 "src/parse.yy"
    {
        (yyval.declarator) = (yyvsp[-1].declarator);
    }
#line 5310 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 246: /* direct_declarator: direct_declarator '[' constant_expression ']'  */
#line 1718 "src/parse.yy"
    {
        std::variant<std::monostate, int, Symbol*> size;
        if ((yyvsp[-3].declarator) != nullptr && lGetConstantIntOrSymbol((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            // Check if size holds an int
            if (std::holds_alternative<int>(size)) {
                int intValue = std::get<int>(size);
                if (intValue < 0) {
                    Error((yylsp[-1]), "Array dimension must be non-negative.");
                    (yyval.declarator) = nullptr;
                } else {
                    Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                    d->arraySize = intValue;
                    d->child = (yyvsp[-3].declarator);
                    (yyval.declarator) = d;
                }
            } else if (std::holds_alternative<Symbol*>(size)) {
                // Handle the case where size holds a Symbol*
                Symbol* symbolValuePtr = std::get<Symbol*>(size);
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                d->arraySize = symbolValuePtr;
                d->child = (yyvsp[-3].declarator);
                (yyval.declarator) = d;
            } else {
                (yyval.declarator) = nullptr;    
            }
        }
        else {
            (yyval.declarator) = nullptr;
        }
    }
#line 5345 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 247: /* direct_declarator: direct_declarator '[' ']'  */
#line 1749 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != nullptr) {
            Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
            d->arraySize = 0; // unsize
            d->child = (yyvsp[-2].declarator);
            (yyval.declarator) = d;
        }
        else
            (yyval.declarator) = nullptr;
    }
#line 5360 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 248: /* direct_declarator: direct_declarator '[' error ']'  */
#line 1760 "src/parse.yy"
    {
         (yyval.declarator) = nullptr;
    }
#line 5368 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 249: /* direct_declarator: direct_declarator '(' parameter_type_list ')'  */
#line 1764 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) != nullptr) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != nullptr) {
                  d->functionParams = *(yyvsp[-1].declarationList);
                  // parameter_type_list returns vector of Declarations that is not needed anymore.
                  delete (yyvsp[-1].declarationList);
              }
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = nullptr;
      }
#line 5387 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 250: /* direct_declarator: direct_declarator '(' ')'  */
#line 1779 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != nullptr) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = nullptr;
      }
#line 5401 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 251: /* direct_declarator: direct_declarator '(' error ')'  */
#line 1789 "src/parse.yy"
    {
        (yyval.declarator) = nullptr;
    }
#line 5409 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 252: /* pointer: '*'  */
#line 1797 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_POINTER, (yylsp[0]));
    }
#line 5417 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 253: /* pointer: '*' type_qualifier_list  */
#line 1801 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[0].typeQualifier);
          (yyval.declarator) = d;
      }
#line 5427 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 254: /* pointer: '*' pointer  */
#line 1807 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 5437 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 255: /* pointer: '*' type_qualifier_list pointer  */
#line 1813 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-2]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[-1].typeQualifier);
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 5448 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 256: /* reference: '&'  */
#line 1824 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
    }
#line 5456 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 257: /* parameter_type_list: parameter_list  */
#line 1831 "src/parse.yy"
                     { (yyval.declarationList) = (yyvsp[0].declarationList); }
#line 5462 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 258: /* parameter_list: parameter_declaration  */
#line 1836 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != nullptr)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 5473 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 259: /* parameter_list: parameter_list ',' parameter_declaration  */
#line 1843 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = (std::vector<Declaration *> *)(yyvsp[-2].declarationList);
        if (dl == nullptr)
            dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != nullptr)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 5486 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 260: /* parameter_list: error ','  */
#line 1852 "src/parse.yy"
    {
        lSuggestParamListAlternates();
        (yyval.declarationList) = nullptr;
    }
#line 5495 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 261: /* parameter_declaration: declaration_specifiers declarator  */
#line 1860 "src/parse.yy"
    {
        (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
    }
#line 5503 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 262: /* parameter_declaration: declaration_specifiers declarator '=' initializer  */
#line 1864 "src/parse.yy"
    {
        if ((yyvsp[-3].declSpecs) != nullptr && (yyvsp[-2].declarator) != nullptr) {
            (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
            (yyval.declaration) = new Declaration((yyvsp[-3].declSpecs), (yyvsp[-2].declarator));
        }
        else
            (yyval.declaration) = nullptr;
    }
#line 5516 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 263: /* parameter_declaration: declaration_specifiers abstract_declarator  */
#line 1873 "src/parse.yy"
    {
        if ((yyvsp[-1].declSpecs) != nullptr && (yyvsp[0].declarator) != nullptr)
            (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        else
            (yyval.declaration) = nullptr;
    }
#line 5527 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 264: /* parameter_declaration: declaration_specifiers  */
#line 1880 "src/parse.yy"
    {
        if ((yyvsp[0].declSpecs) == nullptr)
            (yyval.declaration) = nullptr;
        else
            (yyval.declaration) = new Declaration((yyvsp[0].declSpecs));
    }
#line 5538 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 266: /* type_name: specifier_qualifier_list abstract_declarator  */
#line 1898 "src/parse.yy"
    {
        if ((yyvsp[-1].type) == nullptr || (yyvsp[0].declarator) == nullptr)
            (yyval.type) = nullptr;
        else {
            (yyvsp[0].declarator)->InitFromType((yyvsp[-1].type), nullptr);
            (yyval.type) = (yyvsp[0].declarator)->type;
        }
    }
#line 5551 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 267: /* abstract_declarator: pointer  */
#line 1910 "src/parse.yy"
      {
          (yyval.declarator) = (yyvsp[0].declarator);
      }
#line 5559 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 269: /* abstract_declarator: pointer direct_abstract_declarator  */
#line 1915 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5573 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 270: /* abstract_declarator: reference  */
#line 1925 "src/parse.yy"
      {
          (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
      }
#line 5581 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 271: /* abstract_declarator: reference direct_abstract_declarator  */
#line 1929 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_REFERENCE, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5595 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 272: /* direct_abstract_declarator: '(' abstract_declarator ')'  */
#line 1942 "src/parse.yy"
      { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5601 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 273: /* direct_abstract_declarator: '[' ']'  */
#line 1944 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-1]), (yylsp[0])));
          d->arraySize = 0;
          (yyval.declarator) = d;
      }
#line 5611 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 274: /* direct_abstract_declarator: '[' constant_expression ']'  */
#line 1950 "src/parse.yy"
      {
        std::variant<std::monostate, int, Symbol*> size;
        if ((yyvsp[-1].expr) != nullptr && lGetConstantIntOrSymbol((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            // Check if size holds an int
            if (std::holds_alternative<int>(size)) {
                int intValue = std::get<int>(size);
                if (intValue < 0) {
                    Error((yylsp[-1]), "Array dimension must be non-negative.");
                    (yyval.declarator) = nullptr;
                } else {
                    Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                    d->arraySize = intValue;
                    (yyval.declarator) = d;
                }
            } else if (std::holds_alternative<Symbol*>(size)) {
                // Handle the case where size holds a Symbol*
                Symbol* symbolValuePtr = std::get<Symbol*>(size);
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                d->arraySize = symbolValuePtr;
                (yyval.declarator) = d;
            } else {
                (yyval.declarator) = nullptr;    
            }
        }
        else {
            (yyval.declarator) = nullptr;
        }
      }
#line 5644 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 275: /* direct_abstract_declarator: direct_abstract_declarator '[' ']'  */
#line 1979 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
              d->arraySize = 0;
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5659 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 276: /* direct_abstract_declarator: direct_abstract_declarator '[' constant_expression ']'  */
#line 1990 "src/parse.yy"
      {
          std::variant<std::monostate, int, Symbol*> size;
          if ((yyvsp[-3].declarator) != nullptr && (yyvsp[-1].expr) != nullptr && lGetConstantIntOrSymbol((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
              // Check if size holds an int
              if (std::holds_alternative<int>(size)) {
                  int intValue = std::get<int>(size);
                  if (intValue < 0) {
                      Error((yylsp[-1]), "Array dimension must be non-negative.");
                      (yyval.declarator) = nullptr;
                  } else {
                      Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                      d->arraySize = intValue;
                      d->child = (yyvsp[-3].declarator);
                      (yyval.declarator) = d;
                  }
              } else if (std::holds_alternative<Symbol*>(size)) {
                  // Handle the case where size holds a Symbol*
                  Symbol* symbolValuePtr = std::get<Symbol*>(size);
                  Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                  d->arraySize = symbolValuePtr;
                  d->child = (yyvsp[-3].declarator);
                  (yyval.declarator) = d;
              } else {
                  (yyval.declarator) = nullptr;  
              }
          }
          else {
              (yyval.declarator) = nullptr;
          }
      }
#line 5694 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 277: /* direct_abstract_declarator: '(' ')'  */
#line 2021 "src/parse.yy"
      { (yyval.declarator) = new Declarator(DK_FUNCTION, Union((yylsp[-1]), (yylsp[0]))); }
#line 5700 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 278: /* direct_abstract_declarator: '(' parameter_type_list ')'  */
#line 2023 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
          if ((yyvsp[-1].declarationList) != nullptr) {
              d->functionParams = *(yyvsp[-1].declarationList);
              // parameter_type_list returns vector of Declarations that is not needed anymore.
              delete (yyvsp[-1].declarationList);
          }
          (yyval.declarator) = d;
      }
#line 5714 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 279: /* direct_abstract_declarator: direct_abstract_declarator '(' ')'  */
#line 2033 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5728 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 280: /* direct_abstract_declarator: direct_abstract_declarator '(' parameter_type_list ')'  */
#line 2043 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != nullptr) {
                  d->functionParams = *(yyvsp[-1].declarationList);
                  // parameter_type_list returns vector of Declarations that is not needed anymore.
                  delete (yyvsp[-1].declarationList);
              }
              (yyval.declarator) = d;
          }
      }
#line 5747 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 282: /* initializer: '{' initializer_list '}'  */
#line 2061 "src/parse.yy"
                               { (yyval.expr) = (yyvsp[-1].exprList); }
#line 5753 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 283: /* initializer: '{' initializer_list ',' '}'  */
#line 2062 "src/parse.yy"
                                   { (yyval.expr) = (yyvsp[-2].exprList); }
#line 5759 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 284: /* initializer_list: initializer  */
#line 2067 "src/parse.yy"
      { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 5765 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 285: /* initializer_list: initializer_list ',' initializer  */
#line 2069 "src/parse.yy"
      {
          ExprList *exprList = (yyvsp[-2].exprList);
          if (exprList == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              exprList = new ExprList((yylsp[0]));
          }
          exprList->exprs.push_back((yyvsp[0].expr));
          exprList->pos = Union(exprList->pos, (yylsp[0]));
          (yyval.exprList) = exprList;
      }
#line 5780 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 286: /* pragma: TOKEN_PRAGMA  */
#line 2083 "src/parse.yy"
    {
        (yyval.pragmaAttributes) = (yylval.pragmaAttributes);
    }
#line 5788 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 287: /* attributed_statement: pragma attributed_statement  */
#line 2090 "src/parse.yy"
    {
        if (((yyvsp[-1].pragmaAttributes)->aType == PragmaAttributes::AttributeType::pragmaloop) && ((yyvsp[0].stmt) != nullptr)) {
            std::pair<Globals::pragmaUnrollType, int> unrollVal = std::pair<Globals::pragmaUnrollType, int>((yyvsp[-1].pragmaAttributes)->unrollType, (yyvsp[-1].pragmaAttributes)->count);
            (yyvsp[0].stmt)->SetLoopAttribute(unrollVal);
        }
        (yyval.stmt) = (yyvsp[0].stmt);
        // deallocate yylval.pragmaAttributes returned from pragma and allocated in lPragmaUnroll
        delete (yyvsp[-1].pragmaAttributes);
    }
#line 5802 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 301: /* statement: error ';'  */
#line 2116 "src/parse.yy"
    {
        lSuggestBuiltinAlternates();
        (yyval.stmt) = nullptr;
    }
#line 5811 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 302: /* labeled_statement: goto_identifier ':' attributed_statement  */
#line 2124 "src/parse.yy"
    {
        (yyval.stmt) = new LabeledStmt((yyvsp[-2].constCharPtr), (yyvsp[0].stmt), (yylsp[-2]));
        // allocated by strdup in goto_identifier
        free((char*)(yyvsp[-2].constCharPtr));
    }
#line 5821 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 303: /* labeled_statement: TOKEN_CASE constant_expression ':' attributed_statement  */
#line 2130 "src/parse.yy"
      {
          std::variant<std::monostate, int, Symbol*> value;
          if ((yyvsp[-2].expr) != nullptr &&
              lGetConstantIntOrSymbol((yyvsp[-2].expr), &value, (yylsp[-2]), "Case statement value")) {
              // Check if value holds an int
              if (std::holds_alternative<int>(value)) {
                  int intValue = std::get<int>(value);
                  (yyval.stmt) = new CaseStmt(intValue, (yyvsp[0].stmt), Union((yylsp[-3]), (yylsp[-2])));
              } else {
                  Error((yylsp[-2]), "Case statement value must be a compile-time constant or template non-type parameter.");
                  (yyval.stmt) = nullptr;
              }
          }
          else {
              (yyval.stmt) = nullptr;
          }
      }
#line 5843 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 304: /* labeled_statement: TOKEN_DEFAULT ':' attributed_statement  */
#line 2148 "src/parse.yy"
      { (yyval.stmt) = new DefaultStmt((yyvsp[0].stmt), (yylsp[-2])); }
#line 5849 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 305: /* start_scope: '{'  */
#line 2152 "src/parse.yy"
          { m->symbolTable->PushScope(); }
#line 5855 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 306: /* end_scope: '}'  */
#line 2156 "src/parse.yy"
          { m->symbolTable->PopScope(); }
#line 5861 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 307: /* compound_statement: '{' '}'  */
#line 2160 "src/parse.yy"
              { (yyval.stmt) = nullptr; }
#line 5867 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 308: /* compound_statement: start_scope statement_list end_scope  */
#line 2161 "src/parse.yy"
                                           { (yyval.stmt) = (yyvsp[-1].stmt); }
#line 5873 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 309: /* statement_list: attributed_statement  */
#line 2166 "src/parse.yy"
      {
          StmtList *sl = new StmtList((yylsp[0]));
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 5883 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 310: /* statement_list: statement_list attributed_statement  */
#line 2172 "src/parse.yy"
      {
          StmtList *sl = (StmtList *)(yyvsp[-1].stmt);
          if (sl == nullptr) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sl = new StmtList((yylsp[0]));
          }
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 5897 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 311: /* expression_statement: ';'  */
#line 2184 "src/parse.yy"
          { (yyval.stmt) = nullptr; }
#line 5903 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 312: /* expression_statement: expression ';'  */
#line 2185 "src/parse.yy"
                     { (yyval.stmt) = (yyvsp[-1].expr) ? new ExprStmt((yyvsp[-1].expr), (yylsp[-1])) : nullptr; }
#line 5909 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 313: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement  */
#line 2190 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), nullptr, false, (yylsp[-4])); }
#line 5915 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 314: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 2192 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), false, (yylsp[-6])); }
#line 5921 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 315: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement  */
#line 2194 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), nullptr, true, (yylsp[-4])); }
#line 5927 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 316: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 2196 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), true, (yylsp[-6])); }
#line 5933 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 317: /* selection_statement: TOKEN_SWITCH '(' expression ')' attributed_statement  */
#line 2198 "src/parse.yy"
      { (yyval.stmt) = new SwitchStmt((yyvsp[-2].expr), (yyvsp[0].stmt), (yylsp[-4])); }
#line 5939 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 318: /* for_test: ';'  */
#line 2203 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 5945 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 319: /* for_test: expression ';'  */
#line 2205 "src/parse.yy"
      { (yyval.expr) = (yyvsp[-1].expr); }
#line 5951 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 322: /* for_scope: TOKEN_FOR  */
#line 2214 "src/parse.yy"
                { m->symbolTable->PushScope(); }
#line 5957 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 323: /* cfor_scope: TOKEN_CFOR  */
#line 2218 "src/parse.yy"
                 { m->symbolTable->PushScope(); }
#line 5963 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 324: /* foreach_scope: TOKEN_FOREACH  */
#line 2222 "src/parse.yy"
                    { m->symbolTable->PushScope(); }
#line 5969 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 325: /* foreach_tiled_scope: TOKEN_FOREACH_TILED  */
#line 2226 "src/parse.yy"
                          { m->symbolTable->PushScope(); }
#line 5975 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 326: /* foreach_identifier: TOKEN_IDENTIFIER  */
#line 2231 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), Symbol::SymbolKind::Variable, AtomicType::VaryingInt32->GetAsConstType());
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 5984 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 327: /* foreach_active_scope: TOKEN_FOREACH_ACTIVE  */
#line 2238 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5990 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 328: /* foreach_active_identifier: TOKEN_IDENTIFIER  */
#line 2243 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), Symbol::SymbolKind::Variable, AtomicType::UniformInt64->GetAsConstType());
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 5999 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 329: /* integer_dotdotdot: TOKEN_INT32DOTDOTDOT_CONSTANT  */
#line 2250 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 6008 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 330: /* integer_dotdotdot: TOKEN_UINT32DOTDOTDOT_CONSTANT  */
#line 2254 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 6017 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 331: /* integer_dotdotdot: TOKEN_INT64DOTDOTDOT_CONSTANT  */
#line 2258 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 6026 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 332: /* integer_dotdotdot: TOKEN_UINT64DOTDOTDOT_CONSTANT  */
#line 2262 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 6035 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 333: /* foreach_dimension_specifier: foreach_identifier '=' assignment_expression TOKEN_DOTDOTDOT assignment_expression  */
#line 2270 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-4].symbol), (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 6043 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 334: /* foreach_dimension_specifier: foreach_identifier '=' integer_dotdotdot assignment_expression  */
#line 2274 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-3].symbol), (yyvsp[-1].expr), (yyvsp[0].expr));
    }
#line 6051 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 335: /* foreach_dimension_list: foreach_dimension_specifier  */
#line 2281 "src/parse.yy"
    {
        (yyval.foreachDimensionList) = new std::vector<ForeachDimension *>;
        (yyval.foreachDimensionList)->push_back((yyvsp[0].foreachDimension));
    }
#line 6060 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 336: /* foreach_dimension_list: foreach_dimension_list ',' foreach_dimension_specifier  */
#line 2286 "src/parse.yy"
    {
        std::vector<ForeachDimension *> *dv = (yyvsp[-2].foreachDimensionList);
        if (dv == nullptr) {
            AssertPos((yylsp[-2]), m->errorCount > 0);
            dv = new std::vector<ForeachDimension *>;
        }
        if ((yyvsp[0].foreachDimension) != nullptr)
            dv->push_back((yyvsp[0].foreachDimension));
        (yyval.foreachDimensionList) = dv;
    }
#line 6075 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 337: /* foreach_unique_scope: TOKEN_FOREACH_UNIQUE  */
#line 2299 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 6081 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 338: /* foreach_unique_identifier: TOKEN_IDENTIFIER  */
#line 2304 "src/parse.yy"
      {
          (yyval.constCharPtr) = strdup((yyvsp[0].stringVal)->c_str());
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6090 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 339: /* iteration_statement: TOKEN_WHILE '(' expression ')' attributed_statement  */
#line 2312 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(nullptr, (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), false, (yylsp[-4])); }
#line 6096 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 340: /* iteration_statement: TOKEN_CWHILE '(' expression ')' attributed_statement  */
#line 2314 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(nullptr, (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), true, (yylsp[-4])); }
#line 6102 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 341: /* iteration_statement: TOKEN_DO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 2316 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), false, (yylsp[-6])); }
#line 6108 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 342: /* iteration_statement: TOKEN_CDO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 2318 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), true, (yylsp[-6])); }
#line 6114 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 343: /* iteration_statement: for_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 2320 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), false, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 6122 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 344: /* iteration_statement: for_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 2324 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), false, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 6130 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 345: /* iteration_statement: cfor_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 2328 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), true, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 6138 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 346: /* iteration_statement: cfor_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 2332 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), true, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 6146 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 347: /* $@1: %empty  */
#line 2336 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }
         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 6160 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 348: /* iteration_statement: foreach_scope '(' foreach_dimension_list ')' $@1 attributed_statement  */
#line 2346 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-3]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), false, (yylsp[-5]));
         m->symbolTable->PopScope();

         // deallocate ForeachDimension elements allocated in foreach_dimension_specifier
         for (unsigned int i = 0; i < dims->size(); ++i)
             delete (*dims)[i];

         // deallocate std::vector<ForeachDimension*> allocated in foreach_dimension_list
         delete dims;
     }
#line 6189 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 349: /* $@2: %empty  */
#line 2371 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 6204 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 350: /* iteration_statement: foreach_tiled_scope '(' foreach_dimension_list ')' $@2 attributed_statement  */
#line 2382 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-5]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), true, (yylsp[-5]));
         m->symbolTable->PopScope();

         // deallocate ForeachDimension elements allocated in foreach_dimension_specifier
         for (unsigned int i = 0; i < dims->size(); ++i)
             delete (*dims)[i];

         // deallocate std::vector<ForeachDimension*> allocated in foreach_dimension_list
         delete dims;
     }
#line 6233 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 351: /* $@3: %empty  */
#line 2407 "src/parse.yy"
     {
         if ((yyvsp[-1].symbol) != nullptr)
             m->symbolTable->AddVariable((yyvsp[-1].symbol));
     }
#line 6242 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 352: /* iteration_statement: foreach_active_scope '(' foreach_active_identifier ')' $@3 attributed_statement  */
#line 2412 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachActiveStmt((yyvsp[-3].symbol), (yyvsp[0].stmt), Union((yylsp[-5]), (yylsp[-2])));
         m->symbolTable->PopScope();
     }
#line 6251 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 353: /* $@4: %empty  */
#line 2418 "src/parse.yy"
     {
         Expr *expr = (yyvsp[-1].expr);
         const Type *type;
         if (expr != nullptr &&
             (expr = TypeCheck(expr)) != nullptr &&
             (type = expr->GetType()) != nullptr) {
             const Type *iterType = type->GetAsUniformType()->GetAsConstType();
             Symbol *sym = new Symbol((yyvsp[-3].constCharPtr), (yylsp[-3]), Symbol::SymbolKind::Variable, iterType);
             m->symbolTable->AddVariable(sym);
         }
     }
#line 6267 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 354: /* iteration_statement: foreach_unique_scope '(' foreach_unique_identifier TOKEN_IN expression ')' $@4 attributed_statement  */
#line 2430 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachUniqueStmt((yyvsp[-5].constCharPtr), (yyvsp[-3].expr), (yyvsp[0].stmt), (yylsp[-7]));
         m->symbolTable->PopScope();

         // allocated by strdup in foreach_unique_identifier
         free((char*)(yyvsp[-5].constCharPtr));
     }
#line 6279 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 355: /* goto_identifier: TOKEN_IDENTIFIER  */
#line 2441 "src/parse.yy"
      {
          (yyval.constCharPtr) = strdup((yyvsp[0].stringVal)->c_str());
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6288 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 356: /* jump_statement: TOKEN_GOTO goto_identifier ';'  */
#line 2449 "src/parse.yy"
      {
          (yyval.stmt) = new GotoStmt((yyvsp[-1].constCharPtr), (yylsp[-2]), (yylsp[-1]));
          // allocated by strdup in goto_identifier
          free((char*)(yyvsp[-1].constCharPtr));
      }
#line 6298 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 357: /* jump_statement: TOKEN_CONTINUE ';'  */
#line 2455 "src/parse.yy"
      { (yyval.stmt) = new ContinueStmt((yylsp[-1])); }
#line 6304 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 358: /* jump_statement: TOKEN_BREAK ';'  */
#line 2457 "src/parse.yy"
      { (yyval.stmt) = new BreakStmt((yylsp[-1])); }
#line 6310 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 359: /* jump_statement: TOKEN_RETURN ';'  */
#line 2459 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt(nullptr, (yylsp[-1])); }
#line 6316 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 360: /* jump_statement: TOKEN_RETURN expression ';'  */
#line 2461 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt((yyvsp[-1].expr), (yylsp[-2])); }
#line 6322 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 361: /* sync_statement: TOKEN_SYNC ';'  */
#line 2466 "src/parse.yy"
      { (yyval.stmt) = new ExprStmt(new SyncExpr((yylsp[-1])), (yylsp[-1])); }
#line 6328 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 362: /* delete_statement: TOKEN_DELETE expression ';'  */
#line 2471 "src/parse.yy"
    {
        (yyval.stmt) = new DeleteStmt((yyvsp[-1].expr), Union((yylsp[-2]), (yylsp[-1])));
    }
#line 6336 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 363: /* unmasked_statement: TOKEN_UNMASKED '{' statement_list '}'  */
#line 2478 "src/parse.yy"
    {
        (yyval.stmt) = new UnmaskedStmt((yyvsp[-1].stmt), (yylsp[-3]));
    }
#line 6344 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 364: /* print_statement: TOKEN_PRINT '(' string_constant ')' ';'  */
#line 2485 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-2].stringVal), nullptr, (yylsp[-4]));
           // deallocate std::string of string_constant
           lCleanUpString((yyvsp[-2].stringVal));
      }
#line 6354 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 365: /* print_statement: TOKEN_PRINT '(' string_constant ',' argument_expression_list ')' ';'  */
#line 2491 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].exprList), (yylsp[-6]));
           // deallocate std::string of string_constant
           lCleanUpString((yyvsp[-4].stringVal));
      }
#line 6364 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 366: /* assert_statement: TOKEN_ASSERT '(' string_constant ',' expression ')' ';'  */
#line 2500 "src/parse.yy"
      {
          (yyval.stmt) = new AssertStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].expr), (yylsp[-6]));
          // deallocate std::string of string_constant
          lCleanUpString((yyvsp[-4].stringVal));
      }
#line 6374 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 376: /* external_declaration: TOKEN_EXPORT '{' type_specifier_list '}' ';'  */
#line 2521 "src/parse.yy"
    {
        if ((yyvsp[-2].typeList) != nullptr)
            m->AddExportedTypes(*(yyvsp[-2].typeList));
    }
#line 6383 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 377: /* external_declaration: declaration  */
#line 2526 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) != nullptr)
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i)
                lAddDeclaration((yyvsp[0].declaration)->declSpecs, (yyvsp[0].declaration)->declarators[i]);
    }
#line 6393 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 379: /* $@5: %empty  */
#line 2536 "src/parse.yy"
    {
        lAddDeclaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        m->symbolTable->PushScope();
        lAddFunctionParams((yyvsp[0].declarator));
        lAddMaskToSymbolTable((yylsp[0]));
        if ((yyvsp[-1].declSpecs)->typeQualifiers & TYPEQUAL_TASK)
            lAddThreadIndexCountToSymbolTable((yylsp[0]));
    }
#line 6406 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 380: /* function_definition: declaration_specifiers declarator $@5 compound_statement  */
#line 2545 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != nullptr) {
            // FIXME: Next list is redundant, as it's done in lAddDeclaration()
            (yyvsp[-2].declarator)->InitFromDeclSpecs((yyvsp[-3].declSpecs));
            const FunctionType *funcType = CastType<FunctionType>((yyvsp[-2].declarator)->type);
            if (funcType == nullptr)
                AssertPos((yylsp[-3]), m->errorCount > 0);
            else if ((yyvsp[-3].declSpecs)->storageClass == SC_TYPEDEF)
                Error((yylsp[-3]), "Illegal \"typedef\" provided with function definition.");
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == nullptr) code = new StmtList((yylsp[0]));
                m->AddFunctionDefinition((yyvsp[-2].declarator)->name, funcType, code);
            }
        }
        m->symbolTable->PopScope(); // push in lAddFunctionParams();
    }
#line 6428 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 381: /* template_type_parameter: TOKEN_TYPENAME TOKEN_IDENTIFIER  */
#line 2574 "src/parse.yy"
      {
          (yyval.templateTypeParm) = new TemplateTypeParmType(*(yyvsp[0].stringVal), Variability::VarType::Unbound, false, Union((yylsp[-1]), (yylsp[0])));
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6437 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 382: /* template_type_parameter: TOKEN_TYPENAME TOKEN_IDENTIFIER '=' type_specifier  */
#line 2579 "src/parse.yy"
      {
          (yyval.templateTypeParm) = new TemplateTypeParmType(*(yyvsp[-2].stringVal), Variability::VarType::Unbound, false, Union((yylsp[-3]), (yylsp[-2])));
          lCleanUpString((yyvsp[-2].stringVal));
          // TODO: implement
          Error((yylsp[0]), "Default values for template type parameters are not yet supported.");
      }
#line 6448 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 383: /* int_constant_type: TOKEN_INT8  */
#line 2588 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt8->GetAsConstType(); }
#line 6454 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 384: /* int_constant_type: TOKEN_INT16  */
#line 2589 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt16->GetAsConstType(); }
#line 6460 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 385: /* int_constant_type: TOKEN_INT  */
#line 2590 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt32->GetAsConstType(); }
#line 6466 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 386: /* int_constant_type: TOKEN_INT64  */
#line 2591 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt64->GetAsConstType(); }
#line 6472 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 387: /* int_constant_type: TOKEN_UINT8  */
#line 2592 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt8->GetAsConstType(); }
#line 6478 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 388: /* int_constant_type: TOKEN_UINT16  */
#line 2593 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt16->GetAsConstType(); }
#line 6484 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 389: /* int_constant_type: TOKEN_UINT  */
#line 2594 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt32->GetAsConstType(); }
#line 6490 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 390: /* int_constant_type: TOKEN_UINT64  */
#line 2595 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt64->GetAsConstType(); }
#line 6496 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 391: /* template_int_constant_type: TOKEN_UNIFORM int_constant_type  */
#line 2599 "src/parse.yy"
                                      { (yyval.atomicType) = (yyvsp[0].atomicType); }
#line 6502 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 392: /* template_int_constant_type: int_constant_type  */
#line 2600 "src/parse.yy"
                        { (yyval.atomicType) = (yyvsp[0].atomicType);}
#line 6508 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 393: /* template_int_parameter: template_int_constant_type TOKEN_IDENTIFIER  */
#line 2605 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol(*(yyvsp[0].stringVal), Union((yylsp[-1]), (yylsp[0])), Symbol::SymbolKind::TemplateNonTypeParm, (yyvsp[-1].atomicType));
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6517 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 394: /* template_int_parameter: template_int_constant_type TOKEN_IDENTIFIER '=' int_constant  */
#line 2610 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol(*(yyvsp[-2].stringVal), Union((yylsp[-3]), (yylsp[-2])), Symbol::SymbolKind::TemplateNonTypeParm, (yyvsp[-3].atomicType));
          lCleanUpString((yyvsp[-2].stringVal));
          // TODO: implement
          Error((yylsp[0]), "Default values for template non-type parameters are not yet supported.");
      }
#line 6528 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 395: /* template_enum_parameter: TOKEN_TYPE_NAME TOKEN_IDENTIFIER  */
#line 2620 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[-1].stringVal)->c_str());
          const EnumType *enumType = CastType<EnumType>(type);
          if (enumType == nullptr) {
            Error((yylsp[-1]), "Only enum types and integral types are allowed as non-type template parameters.");
          }
          (yyval.symbol) = new Symbol(*(yyvsp[0].stringVal), Union((yylsp[-1]), (yylsp[0])), Symbol::SymbolKind::TemplateNonTypeParm, enumType->GetAsConstType()->GetAsUniformType());
          lCleanUpString((yyvsp[-1].stringVal));
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6543 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 396: /* template_parameter: template_type_parameter  */
#line 2633 "src/parse.yy"
    {
        if ((yyvsp[0].templateTypeParm) != nullptr) {
            (yyval.templateParm) = new TemplateParam((yyvsp[0].templateTypeParm));
        }
    }
#line 6553 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 397: /* template_parameter: template_int_parameter  */
#line 2639 "src/parse.yy"
    {
        if ((yyvsp[0].symbol) != nullptr) {
            (yyval.templateParm) = new TemplateParam((yyvsp[0].symbol));
        }
    }
#line 6563 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 398: /* template_parameter: template_enum_parameter  */
#line 2645 "src/parse.yy"
    {
        if ((yyvsp[0].symbol) != nullptr) {
            (yyval.templateParm) = new TemplateParam((yyvsp[0].symbol));
        }
    }
#line 6573 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 399: /* template_parameter_list: template_parameter  */
#line 2654 "src/parse.yy"
      {
          TemplateParms *list = new TemplateParms();
          if ((yyvsp[0].templateParm) != nullptr) {
              list->Add((yyvsp[0].templateParm));
          }
          (yyval.templateParmList) = list;
      }
#line 6585 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 400: /* template_parameter_list: template_parameter_list ',' template_parameter  */
#line 2662 "src/parse.yy"
      {
          TemplateParms *list = (TemplateParms *) (yyvsp[-2].templateParmList);
          if (list == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              list = new TemplateParms();
          }
          if ((yyvsp[0].templateParm) != nullptr) {
              list->Add((yyvsp[0].templateParm));
          }
          (yyval.templateParmList) = list;
      }
#line 6601 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 401: /* template_head: TOKEN_TEMPLATE '<' template_parameter_list '>'  */
#line 2677 "src/parse.yy"
      {
          (yyval.templateParmList) = (yyvsp[-1].templateParmList);
      }
#line 6609 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 402: /* $@6: %empty  */
#line 2684 "src/parse.yy"
      {
          // Scope for template parameters definition
          m->symbolTable->PushScope();
          TemplateParms *list = (TemplateParms *) (yyvsp[0].templateParmList);
          for(size_t i = 0; i < list->GetCount(); i++) {
              std::string name = (*list)[i]->GetName();
              SourcePos pos = (*list)[i]->GetSourcePos();
              if ((*list)[i]->IsTypeParam()) {
                  m->AddTypeDef(name, (*list)[i]->GetTypeParam(), pos);
              } else if ((*list)[i]->IsNonTypeParam()) {
                  m->symbolTable->AddVariable((*list)[i]->GetNonTypeParam());
              }
          }
      }
#line 6628 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 403: /* template_declaration: template_head $@6 declaration_specifiers declarator  */
#line 2699 "src/parse.yy"
      {
          lAddTemplateDeclaration((yyvsp[-3].templateParmList), (yyvsp[-1].declSpecs), (yyvsp[0].declarator));
          lAddFunctionParams((yyvsp[0].declarator));
          lAddMaskToSymbolTable((yylsp[0]));
          const FunctionType *ft = CastType<FunctionType>((yyvsp[0].declarator)->type);
          // Creating a new TemplateSymbol just to pass it further seems to be a waste
          (yyval.functionTemplateSym) = new TemplateSymbol((yyvsp[-3].templateParmList), (yyvsp[0].declarator)->name, ft, (yyvsp[-1].declSpecs)->storageClass, (yylsp[0]), false /*not used*/, false /*not used*/);
      }
#line 6641 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 404: /* template_function_declaration_or_definition: template_declaration ';'  */
#line 2711 "src/parse.yy"
      {
          // deallocate TemplateSymbol created in template_declaration
          delete (yyvsp[-1].functionTemplateSym);
          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 6652 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 405: /* template_function_declaration_or_definition: template_declaration compound_statement  */
#line 2718 "src/parse.yy"
      {
          if ((yyvsp[-1].functionTemplateSym) != nullptr) {
              Stmt *code = (yyvsp[0].stmt);
              if (code == nullptr) code = new StmtList((yylsp[0]));
              m->AddFunctionTemplateDefinition((yyvsp[-1].functionTemplateSym)->templateParms, (yyvsp[-1].functionTemplateSym)->name, (yyvsp[-1].functionTemplateSym)->type, code);
              // deallocate TemplateSymbol created in template_declaration
              delete (yyvsp[-1].functionTemplateSym);
          }

          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 6669 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 406: /* template_argument: rate_qualified_type_specifier  */
#line 2734 "src/parse.yy"
    {
        (yyval.templateArg) = new TemplateArg((yyvsp[0].type), (yylsp[0]));
    }
#line 6677 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 407: /* template_argument: TOKEN_INT8_CONSTANT  */
#line 2740 "src/parse.yy"
                          {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6686 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 408: /* template_argument: TOKEN_UINT8_CONSTANT  */
#line 2744 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6695 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 409: /* template_argument: TOKEN_INT16_CONSTANT  */
#line 2748 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6704 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 410: /* template_argument: TOKEN_UINT16_CONSTANT  */
#line 2752 "src/parse.yy"
                            {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6713 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 411: /* template_argument: TOKEN_INT32_CONSTANT  */
#line 2756 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6722 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 412: /* template_argument: TOKEN_UINT32_CONSTANT  */
#line 2760 "src/parse.yy"
                            {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6731 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 413: /* template_argument: TOKEN_INT64_CONSTANT  */
#line 2764 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6740 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 414: /* template_argument: TOKEN_UINT64_CONSTANT  */
#line 2768 "src/parse.yy"
                            {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6749 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 415: /* template_argument: TOKEN_IDENTIFIER  */
#line 2774 "src/parse.yy"
    {
        const char *name = (yyvsp[0].stringVal)->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        if (s) {
            if (s->GetSymbolKind() == Symbol::SymbolKind::Enumerator ||
                s->GetSymbolKind() == Symbol::SymbolKind::TemplateNonTypeParm) {
                (yyval.templateArg) = new TemplateArg(new SymbolExpr(s, (yylsp[0])), (yylsp[0]));
            } else {
                Error((yylsp[0]), "Only integral, enum types and non-type template parameters are allowed as template arguments.");
                (yyval.templateArg) = nullptr;
            }
        } else {
            Error((yylsp[0]), "Unknown identifier");
            (yyval.templateArg) = nullptr;
        }
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 6771 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 416: /* template_argument_list: template_argument  */
#line 2795 "src/parse.yy"
      {
          TemplateArgs *templArgs = new TemplateArgs();
          if ((yyvsp[0].templateArg) != nullptr) {
            templArgs->push_back(*(yyvsp[0].templateArg));
          }
          (yyval.templateArgs) = templArgs;

      }
#line 6784 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 417: /* template_argument_list: template_argument_list ',' template_argument  */
#line 2804 "src/parse.yy"
      {
          TemplateArgs *templArgs = (TemplateArgs *) (yyvsp[-2].templateArgs);
          if ((yyvsp[0].templateArg) != nullptr) {
            templArgs->push_back(*(yyvsp[0].templateArg));
          }
          (yyval.templateArgs) = templArgs;
      }
#line 6796 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 418: /* template_identifier: TOKEN_TEMPLATE_NAME  */
#line 2815 "src/parse.yy"
    {
        (yyval.constCharPtr) = strdup(yytext);
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 6805 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 419: /* simple_template_id: template_identifier '<' template_argument_list '>'  */
#line 2823 "src/parse.yy"
      {
          // Template ID declartor
          Declarator *d = new Declarator(DK_BASE, (yylsp[-3]));
          d->name = (yyvsp[-3].constCharPtr);
          // allocated by strdup in template_identifier
          free((char*)(yyvsp[-3].constCharPtr));
          // Arguments vector
          TemplateArgs *templArgs = (TemplateArgs *) (yyvsp[-1].templateArgs);
          // Bundle template ID declarator and type list.
          (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 6821 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 420: /* simple_template_id: template_identifier  */
#line 2835 "src/parse.yy"
      {
          // Template ID declartor
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = (yyvsp[0].constCharPtr);
          // allocated by strdup in template_identifier
          free((char*)(yyvsp[0].constCharPtr));
          // Arguments vector
          TemplateArgs *templArgs = new TemplateArgs();
          // Bundle template ID declarator and empty type list.
          (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 6837 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 421: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' parameter_type_list ')' ';'  */
#line 2852 "src/parse.yy"
      {
          SimpleTemplateIDType *simpleTemplID = (SimpleTemplateIDType *) (yyvsp[-4].simpleTemplateID);

          // Function declarator
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-6]), (yylsp[-1])));
          d->child = simpleTemplID->first;
          if ((yyvsp[-2].declarationList) != nullptr) {
              d->functionParams = *(yyvsp[-2].declarationList);
              // parameter_type_list returns vector of Declarations that is not needed anymore.
              delete (yyvsp[-2].declarationList);
          }

          d->InitFromDeclSpecs((yyvsp[-5].declSpecs));
          lCheckTemplateDeclSpecs((yyvsp[-5].declSpecs), d->pos, TemplateType::Instantiation, (yyvsp[-4].simpleTemplateID)->first->name.c_str());
          const FunctionType *ftype = CastType<FunctionType>(d->type);
          bool isInline = ((yyvsp[-5].declSpecs)->typeQualifiers & TYPEQUAL_INLINE);
          bool isNoInline = ((yyvsp[-5].declSpecs)->typeQualifiers & TYPEQUAL_NOINLINE);
          if ((yyvsp[-4].simpleTemplateID)->second->size() == 0) {
              Error(d->pos, "Template arguments deduction is not yet supported in explicit template instantiation.");
          }
          m->AddFunctionTemplateInstantiation((yyvsp[-4].simpleTemplateID)->first->name, *(yyvsp[-4].simpleTemplateID)->second, ftype, (yyvsp[-5].declSpecs)->storageClass, isInline, isNoInline, Union((yylsp[-6]), (yylsp[-1])));

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID(simpleTemplID);
      }
#line 6867 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 422: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' ')' ';'  */
#line 2878 "src/parse.yy"
      {
          SimpleTemplateIDType *simpleTemplID = (SimpleTemplateIDType *) (yyvsp[-3].simpleTemplateID);

          // Function declarator
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-5]), (yylsp[-1])));
          d->child = simpleTemplID->first;

          d->InitFromDeclSpecs((yyvsp[-4].declSpecs));
          lCheckTemplateDeclSpecs((yyvsp[-4].declSpecs), d->pos, TemplateType::Instantiation, (yyvsp[-3].simpleTemplateID)->first->name.c_str());
          const FunctionType *ftype = CastType<FunctionType>(d->type);
          bool isInline = ((yyvsp[-4].declSpecs)->typeQualifiers & TYPEQUAL_INLINE);
          bool isNoInline = ((yyvsp[-4].declSpecs)->typeQualifiers & TYPEQUAL_NOINLINE);
          if ((yyvsp[-3].simpleTemplateID)->second->size() == 0) {
              Error(d->pos, "Template arguments deduction is not yet supported in explicit template instantiation.");
          }
          m->AddFunctionTemplateInstantiation((yyvsp[-3].simpleTemplateID)->first->name, *(yyvsp[-3].simpleTemplateID)->second, ftype, (yyvsp[-4].declSpecs)->storageClass, isInline, isNoInline, Union((yylsp[-5]), (yylsp[-1])));

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID(simpleTemplID);
      }
#line 6892 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 423: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' error ')' ';'  */
#line 2899 "src/parse.yy"
      {
          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-4].simpleTemplateID));
      }
#line 6901 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 424: /* template_function_specialization_declaration: TOKEN_TEMPLATE '<' '>' declaration_specifiers simple_template_id '(' parameter_type_list ')'  */
#line 2909 "src/parse.yy"
      {
        // Function declarator
        Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-7]), (yylsp[0])));
        d->child = (yyvsp[-3].simpleTemplateID)->first;

        if ((yyvsp[-1].declarationList) != nullptr) {
            d->functionParams = *(yyvsp[-1].declarationList);
            // parameter_type_list returns vector of Declarations that is not needed anymore.
            delete (yyvsp[-1].declarationList);
        }
        TemplateArgs *templArgs = new TemplateArgs(*(yyvsp[-3].simpleTemplateID)->second);
        Assert(templArgs);
        lAddTemplateSpecialization(*templArgs, (yyvsp[-4].declSpecs), d);
        m->symbolTable->PushScope();

        lAddFunctionParams(d);
        lAddMaskToSymbolTable((yylsp[-3]));
        // deallocate SimpleTemplateIDType returned by simple_template_id
        lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
        (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 6927 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 425: /* template_function_specialization_declaration: TOKEN_TEMPLATE '<' '>' declaration_specifiers simple_template_id '(' ')'  */
#line 2931 "src/parse.yy"
      {
        Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-6]), (yylsp[-2])));
        d->child = (yyvsp[-2].simpleTemplateID)->first;
        TemplateArgs *templArgs = new TemplateArgs(*(yyvsp[-2].simpleTemplateID)->second);
        Assert(templArgs);
        lAddTemplateSpecialization(*templArgs, (yyvsp[-3].declSpecs), d);
        m->symbolTable->PushScope();

        lAddMaskToSymbolTable((yylsp[-2]));
        // deallocate SimpleTemplateIDType returned by simple_template_id
        lFreeSimpleTemplateID((yyvsp[-2].simpleTemplateID));
        (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 6945 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 426: /* template_function_specialization_declaration: TOKEN_TEMPLATE '<' '>' declaration_specifiers simple_template_id '(' error ')'  */
#line 2945 "src/parse.yy"
      {
        m->symbolTable->PushScope();
        // deallocate SimpleTemplateIDType returned by simple_template_id
        lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
        (yyval.simpleTemplateID) = nullptr;
      }
#line 6956 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 427: /* template_function_specialization: template_function_specialization_declaration ';'  */
#line 2955 "src/parse.yy"
      {
          if ((yyvsp[-1].simpleTemplateID) != nullptr) {
            // deallocate TemplateSymbol created in template_declaration
            lFreeSimpleTemplateID((yyvsp[-1].simpleTemplateID));
          }
          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 6969 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;

  case 428: /* template_function_specialization: template_function_specialization_declaration compound_statement  */
#line 2964 "src/parse.yy"
      {
        if ((yyvsp[-1].simpleTemplateID) != nullptr) {
            Declarator *d = (yyvsp[-1].simpleTemplateID)->first;
            const FunctionType *ftype = CastType<FunctionType>(d->type);
            if (ftype == nullptr)
                AssertPos((yylsp[-1]), m->errorCount > 0);
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == nullptr) code = new StmtList((yylsp[0]));
                m->AddFunctionTemplateSpecializationDefinition(d->name, ftype, *(yyvsp[-1].simpleTemplateID)->second, Union((yylsp[-1]), (yylsp[0])), code);
            }
           lFreeSimpleTemplateID((yyvsp[-1].simpleTemplateID));
        }
        m->symbolTable->PopScope();
      }
#line 6989 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"
    break;


#line 6993 "/builddir/build/BUILD/ispc-1.25.3-build/ispc-1.25.3/redhat-linux-build/./parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2981 "src/parse.yy"



void yyerror(const char *s) {
    if (strlen(yytext) == 0)
        Error(yylloc, "Premature end of file: %s.", s);
    else
        Error(yylloc, "%s.", s);
}

void lCleanUpString(std::string *s) {
    if (s) {
         delete s;
    }
}

void lFreeSimpleTemplateID(void *p) {
    SimpleTemplateIDType *sid = (SimpleTemplateIDType*) p;
    TemplateArgs *templArgs = sid->second;
    if (templArgs) {
        delete templArgs;
    }
    if (sid) {
        delete sid;
    }
}

static int
lYYTNameErr (char *yyres, const char *yystr)
{
  extern std::map<std::string, std::string> tokenNameRemap;
  Assert(tokenNameRemap.size() > 0);
  if (tokenNameRemap.find(yystr) != tokenNameRemap.end()) {
      std::string n = tokenNameRemap[yystr];
      if (yyres == nullptr)
          return n.size();
      else
          return yystpcpy(yyres, n.c_str()) - yyres;
  }

  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}

static void
lSuggestBuiltinAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lBuiltinTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
         Error(yylloc, "%s", alts.c_str());
}


static void
lSuggestParamListAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lParamListTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
        Error(yylloc, "%s", alts.c_str());
}


static void
lAddDeclaration(DeclSpecs *ds, Declarator *decl) {
    if (ds == nullptr || decl == nullptr)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    if (ds->storageClass == SC_TYPEDEF) {
        const StructType *st = CastType<StructType>(decl->type);
        if (st && st->IsAnonymousType()) {
            st = st->GetAsNamed(decl->name);
            m->AddTypeDef(decl->name, st, decl->pos);
        } else {
            m->AddTypeDef(decl->name, decl->type, decl->pos);
        }
    } else {
        if (decl->type == nullptr) {
            Assert(m->errorCount > 0);
            return;
        }

        decl->type = decl->type->ResolveUnboundVariability(Variability::Varying);

        const FunctionType *ft = CastType<FunctionType>(decl->type);
        if (ft != nullptr) {
            bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
            bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
            bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
            bool isRegCall = (ds->typeQualifiers & TYPEQUAL_REGCALL);
            Declarator *funcDecl = decl;
            if (decl->kind == DK_POINTER || decl->kind == DK_REFERENCE) {
                funcDecl = decl->child;
            }
            m->AddFunctionDeclaration(decl->name, ft, ds->storageClass, funcDecl,
                                      isInline, isNoInline, isVectorCall, isRegCall, decl->pos);
        }
        else {
            bool isConst = (ds->typeQualifiers & TYPEQUAL_CONST) != 0;
            m->AddGlobalVariable(decl, isConst);
        }
    }
}

static void
lCheckTemplateDeclSpecs(DeclSpecs *ds, SourcePos pos, TemplateType type, const char* name) {
    std::string templateTypeStr;
    switch (type) {
        case TemplateType::Template:
            templateTypeStr = "function template";
            break;
        case TemplateType::Instantiation:
            templateTypeStr = "template instantiation";
            break;
        case TemplateType::Specialization:
            templateTypeStr = "template specialization";
            break;
        default:
            FATAL("Unhandled template type in lCheckTemplateDeclSpecs");
    }
    if (ds->typeQualifiers & TYPEQUAL_TASK){
        Error(pos, "'task' not supported for %s.", templateTypeStr.c_str());
        return;
    }
    if (ds->typeQualifiers & TYPEQUAL_EXPORT) {
        Error(pos, "'export' not supported for %s.", templateTypeStr.c_str());
        return;
    }
    if (ds->storageClass == SC_TYPEDEF) {
        Error(pos, "Illegal \"typedef\" provided with %s.", templateTypeStr.c_str());
        return;
    }
    // We can't support extern "C"/extern "SYCL" for templates because
    // we need mangling information.
    if (ds->storageClass == SC_EXTERN_C || ds->storageClass == SC_EXTERN_SYCL) {
        Error(pos, "Illegal linkage provided with %s.", templateTypeStr.c_str());
        return;
    }
    Assert(ds->storageClass == SC_NONE || ds->storageClass == SC_STATIC || ds->storageClass == SC_EXTERN);
    bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
    if (isVectorCall) {
        Error(pos, "Illegal to use \"__vectorcall\" qualifier on non-extern function \"%s\".", name);
    }
    bool isRegCall = (ds->typeQualifiers & TYPEQUAL_REGCALL);
    if (isRegCall) {
        Error(pos, "Illegal to use \"__regcall\" qualifier on non-extern function \"%s\".", name);
    }
}

static void
lAddTemplateDeclaration(TemplateParms *templateParmList, DeclSpecs *ds, Declarator *decl) {
    if (ds == nullptr || decl == nullptr) {
        // Error happened earlier during parsing
        return;
    }

    decl->InitFromDeclSpecs(ds);
    lCheckTemplateDeclSpecs(ds, decl->pos, TemplateType::Template, decl->name.c_str());

    if (decl->type == nullptr) {
        Assert(m->errorCount > 0);
        return;
    }

    const FunctionType *ft = CastType<FunctionType>(decl->type);
    if (ft != nullptr) {
        bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
        bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
        m->AddFunctionTemplateDeclaration(templateParmList, decl->name, ft, ds->storageClass,
                                          isInline, isNoInline, decl->pos);
    }
    else {
        Error(decl->pos, "Only function templates are supported.");
    }

}

static void
lAddTemplateSpecialization(const TemplateArgs &templArgs, DeclSpecs *ds, Declarator *decl) {
    if (ds == nullptr || decl == nullptr)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    lCheckTemplateDeclSpecs(ds, decl->pos, TemplateType::Specialization, decl->name.c_str());

    if (decl->type == nullptr) {
        Assert(m->errorCount > 0);
        return;
    }

    if (templArgs.size() == 0) {
        Error(decl->pos, "Template arguments deduction is not yet supported in template function specialization.");
        return;
    }

    const FunctionType *ftype = CastType<FunctionType>(decl->type);
    if (ftype != nullptr) {
        bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
        bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
        m->AddFunctionTemplateSpecializationDeclaration(decl->name, ftype, templArgs, ds->storageClass,
                                                        isInline, isNoInline, decl->pos);
    }
    else {
        Error(decl->pos, "Only function template specializations are supported.");
    }
}

/** We're about to start parsing the body of a function; add all of the
    parameters to the symbol table so that they're available.
*/
static void
lAddFunctionParams(Declarator *decl) {
    // It's responsibility of the caller to create a new symbol table scope.
    // For regular functions, the scope starts before function parameters.
    // For template functions, the scope starts before template parameters.
    if (decl == nullptr) {
        return;
    }

    // walk down to the declarator for the function itself
    while (decl->kind != DK_FUNCTION && decl->child != nullptr)
        decl = decl->child;
    if (decl->kind != DK_FUNCTION) {
        AssertPos(decl->pos, m->errorCount > 0);
        return;
    }

    // now loop over its parameters and add them to the symbol table
    for (unsigned int i = 0; i < decl->functionParams.size(); ++i) {
        Declaration *pdecl = decl->functionParams[i];
        Assert(pdecl != nullptr && pdecl->declarators.size() == 1);
        Declarator *declarator = pdecl->declarators[0];
        if (declarator == nullptr)
            AssertPos(decl->pos, m->errorCount > 0);
        else {
            Symbol *sym = new Symbol(declarator->name, declarator->pos, Symbol::SymbolKind::FunctionParm,
                                     declarator->type, declarator->storageClass);

            AttributeList *AL = declarator->attributeList;
            if (AL) {
                // Check for unknown attributes for parameters in function definitions.
                AL->CheckForUnknownAttributes(declarator->pos);
            }
#ifndef NDEBUG
            bool ok = m->symbolTable->AddVariable(sym);
            if (ok == false)
                AssertPos(decl->pos, m->errorCount > 0);
#else
            m->symbolTable->AddVariable(sym);
#endif
        }
    }

    // The corresponding pop scope happens in function_definition rules
    // above...
}


/** Add a symbol for the built-in mask variable to the symbol table */
static void lAddMaskToSymbolTable(SourcePos pos) {
    const Type *t = nullptr;
    switch (g->target->getMaskBitCount()) {
    case 1:
        t = AtomicType::VaryingBool;
        break;
    case 8:
        t = AtomicType::VaryingUInt8;
        break;
    case 16:
        t = AtomicType::VaryingUInt16;
        break;
    case 32:
        t = AtomicType::VaryingUInt32;
        break;
    case 64:
        t = AtomicType::VaryingUInt64;
        break;
    default:
        FATAL("Unhandled mask bitsize in lAddMaskToSymbolTable");
    }

    t = t->GetAsConstType();
    Symbol *maskSymbol = new Symbol("__mask", pos, Symbol::SymbolKind::Default, t);
    m->symbolTable->AddVariable(maskSymbol);
}


/** Add the thread index and thread count variables to the symbol table
    (this should only be done for 'task'-qualified functions. */
static void lAddThreadIndexCountToSymbolTable(SourcePos pos) {
    const Type *type = AtomicType::UniformUInt32->GetAsConstType();

    Symbol *threadIndexSym = new Symbol("threadIndex", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(threadIndexSym);

    Symbol *threadCountSym = new Symbol("threadCount", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(threadCountSym);

    Symbol *taskIndexSym = new Symbol("taskIndex", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym);

    Symbol *taskCountSym = new Symbol("taskCount", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym);

    Symbol *taskIndexSym0 = new Symbol("taskIndex0", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym0);
    Symbol *taskIndexSym1 = new Symbol("taskIndex1", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym1);
    Symbol *taskIndexSym2 = new Symbol("taskIndex2", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym2);


    Symbol *taskCountSym0 = new Symbol("taskCount0", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym0);
    Symbol *taskCountSym1 = new Symbol("taskCount1", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym1);
    Symbol *taskCountSym2 = new Symbol("taskCount2", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym2);
}


/** Small utility routine to construct a string for error messages that
    suggests alternate tokens for possibly-misspelled ones... */
static std::string lGetAlternates(std::vector<std::string> &alternates) {
    std::string alts;
    if (alternates.size()) {
        alts += " Did you mean ";
        for (unsigned int i = 0; i < alternates.size(); ++i) {
            alts += std::string("\"") + alternates[i] + std::string("\"");
            if (i < alternates.size() - 1) alts += ", or ";
        }
        alts += "?";
    }
    return alts;
}

static const char *
lGetStorageClassString(StorageClass sc) {
    switch (sc) {
    case SC_NONE:
        return "";
    case SC_EXTERN:
        return "extern";
    case SC_STATIC:
        return "static";
    case SC_TYPEDEF:
        return "typedef";
    case SC_EXTERN_C:
        return "extern \"C\"";
    case SC_EXTERN_SYCL:
        return "extern \"SYCL\"";
    default:
        Assert(!"logic error in lGetStorageClassString()");
        return "";
    }
}


/** Given an expression, see if it is equal to a compile-time constant
    integer value.  If so, return true and return the value in *value.
    If the expression isn't a compile-time constant or isn't an integer
    type, return false.
*/
static bool
lGetConstantIntOrSymbol(Expr *expr, std::variant<std::monostate, int, Symbol*> *value, SourcePos pos, const char *usage) {
    if (expr == nullptr)
        return false;
    expr = TypeCheck(expr);
    if (expr == nullptr)
        return false;
    expr = Optimize(expr);
    if (expr == nullptr)
        return false;
    const SymbolExpr* se= llvm::dyn_cast<SymbolExpr>(expr);
    if (se) {
        Symbol* s = se->GetBaseSymbol();
        if (s->GetSymbolKind() == Symbol::SymbolKind::TemplateNonTypeParm) {
            value->emplace<Symbol*>(s);
            return true;
        }
    }
    std::pair<llvm::Constant *, bool> cValPair = expr->GetConstant(expr->GetType());
    llvm::Constant *cval = cValPair.first;
    if (cval == nullptr) {
        Error(pos, "%s must be a compile-time constant or template non-type parameter.", usage);
        return false;
    }
    else {
        llvm::ConstantInt *ci = llvm::dyn_cast<llvm::ConstantInt>(cval);
        if (ci == nullptr) {
            Error(pos, "%s must be a compile-time integer constant.", usage);
            return false;
        }
        if ((int64_t)((int32_t)ci->getSExtValue()) != ci->getSExtValue()) {
            Error(pos, "%s must be representable with a 32-bit integer.", usage);
            return false;
        }
        const Type *type = expr->GetType();
        int resultValue = type->IsUnsignedType() ? (int)ci->getZExtValue() : (int)ci->getSExtValue();
        value->emplace<int>(resultValue);
        return true;
    }
}


static EnumType *
lCreateEnumType(const char *name, std::vector<Symbol *> *enums, SourcePos pos) {
    if (enums == nullptr)
        return nullptr;

    EnumType *enumType = name ? new EnumType(name, pos) : new EnumType(pos);
    if (name != nullptr)
        m->symbolTable->AddType(name, enumType, pos);

    lFinalizeEnumeratorSymbols(*enums, enumType);
    for (unsigned int i = 0; i < enums->size(); ++i)
        m->symbolTable->AddVariable((*enums)[i]);
    enumType->SetEnumerators(*enums);
    return enumType;
}


/** Given an array of enumerator symbols, make sure each of them has a
    ConstExpr * in their Symbol::constValue member that stores their
    unsigned integer value.  Symbols that had values explicitly provided
    in the source file will already have ConstExpr * set; we just need
    to set the values for the others here.
*/
static void
lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                           const EnumType *enumType) {
    enumType = enumType->GetAsConstType();
    enumType = enumType->GetAsUniformType();

    /* nextVal tracks the value for the next enumerant.  It starts from
       zero and goes up with each successive enumerant.  If any of them
       has a value specified, then nextVal is ignored for that one and is
       set to one plus that one's value for the default value for the next
       one. */
    uint32_t nextVal = 0;

    for (unsigned int i = 0; i < enums.size(); ++i) {
        enums[i]->type = enumType;
        if (enums[i]->constValue != nullptr) {
            /* Already has a value, so first update nextVal with it. */
            int count = enums[i]->constValue->GetValues(&nextVal);
            AssertPos(enums[i]->pos, count == 1);
            ++nextVal;

            /* When the source file as being parsed, the ConstExpr for any
               enumerant with a specified value was set to have unsigned
               int32 type, since we haven't created the parent EnumType
               by then.  Therefore, add a little type cast from uint32 to
               the actual enum type here and optimize it, which will have
               us end up with a ConstExpr with the desired EnumType... */
            Expr *castExpr = new TypeCastExpr(enumType, enums[i]->constValue,
                                              enums[i]->pos);
            castExpr = Optimize(castExpr);
            enums[i]->constValue = llvm::dyn_cast<ConstExpr>(castExpr);
            AssertPos(enums[i]->pos, enums[i]->constValue != nullptr);
        }
        else {
            enums[i]->constValue = new ConstExpr(enumType, nextVal++,
                                                 enums[i]->pos);
        }
    }
}
